/*jslint evil:true forin:true*/
/*global $ jQuery

soundManager
Slider
*/

/**
 * @author Cany
 */

/**
Este script depende de:
- jQuery
- flydom
- slider
- json

La página que lo use tiene que:
- definir tres botones con estos ID: cmdPlay, cmdPause, cmdStop
*/
// Objeto SoundManager

var g_soundManagerIsReady = false;
var g_pendingSound = null;
var TOKEN_BORRAME = 0;

soundManager.url = '/inconcert/lib/soundmanager2/swf/soundmanager2.swf'; // override default SWF url
soundManager.debugMode = false;
soundManager.consoleOnly = false;
soundManager.onload = function() {
	g_soundManagerIsReady = true;
	if(g_pendingSound !== null) {
		soundManager.createSound(g_pendingSound);
		g_pendingSound = null;
	}
};

function CInconcertPlayer(params, soundId, rowsOfChatDescending, hasApplyColorLastChatMessage, isLivePlayer, callbacks) {
	var self = this;
	self.m_callbacks = params.callbacks;
	/*Asignacion de parámetros */
	if(typeof(params) === "object") {
		self.m_isLivePlayer = (params.isLivePlayer === undefined ? true : params.isLivePlayer);
		self.m_playerDivId = params.id;
		self.m_soundId = params.soundId;
		self.m_rowsOfChatDescending = (params.rowsOfChatDescending === undefined ? true: params.rowsOfChatDescending);
	}
	else {
		self.m_isLivePlayer = (isLivePlayer === undefined ? true : isLivePlayer);
		self.m_playerDivId = params;
		self.m_soundId = soundId;
		self.m_rowsOfChatDescending = (rowsOfChatDescending === undefined ? true: rowsOfChatDescending);
	}
	self.m_maxVolume = 100;
	self.m_sliderVolume = undefined;
	self.m_sliderPlayingPos = undefined;
	self.m_sliderLoadedData = undefined;
	self.m_progressBarWidth = 0;	// el ancho viene dado por CSS, pero lo calculo luego y lo guardo acá, para no recalcularlo siempre
	self.m_gotFirstChunkOfAudio = false;
	self.m_jsonData = undefined; // este json es recibido en la respuesta del StartStream para el uso del chat (poolStream)
	self.m_jsonHeader = undefined; // este json es utilizado para setear las columnas a utilizar en el chat
	self.m_jsonDirections = undefined; // este json contiene todas las direcciones monitoreables obtenidas (userAddressesActive)
	self.m_jsonDataToMonitoring = undefined; // este json contiene la direccion a monitorear, el mismo se llena en la respuesta el metodo (Monitor) del mediaServer
	self.m_token = undefined;
	self.m_counterOfMessages = 0;
	self.m_prefix = 'detailId_';
	self.m_mediaType = undefined;
	self.m_mediaServerIPAddress = '127.0.0.1';
	self.m_mediaServerPort = 8082;
	self.m_isStreamChat = false;
	self.m_hasScrollToTheLastMessage = true;
	self.m_waiting = undefined;
	self.m_fieldsByRow = 3; //cantidad de campos a visualizar por fila en la zona de detalle.
	self.m_jsonDetail = undefined; //json que contiene los campos de los detalles a agregar segun tipo de interaccion
	self.m_functionHiddenDetail = 'hide';  // valores posibles 'show' o 'hide' son los nombre correspondientes a las funciones de jQuery
	self.m_urlToMonitoring = undefined; //esta propiedad es utilizada en el storedplayer, en la misma se setea con la funcion SetURL
	self.m_action = null; // contiene la accion presionada en el player de llamadas/voicemail

	//Lista de métodos en media Server
	self.m_mediaServerListOfMethod = {
		'MONITOR': 'monitor',
		'START_STREAM': 'startStream/live',
		'POLL_STREAM': 'pollStream',
		'STOP_STREAM': 'stopStream'
	};
	//paths de ubicacion de los archivos necesarios (imagenes, luas, etc)
	self.m_pathsList = {
		'APPLICATION-SCRIPTS': '/inconcert/apps/mediaplayer/liveplayer/',
		'MEDIASERVER-PATH': '/inconcert/apps/mediaserver/action/'
	};

	//////////////////////////////////////////////////////////////////////////////////////////
	// Crea el objeto Sound, seteando callbacks según sea liveplayer o no
	self.CreateSound = function (soundId, urlName) {
		soundId = (soundId === null ? self.m_soundId : soundId);
		soundManager.destroySound(soundId);
		var definitions = {
			onjustbeforefinish: function() {
				//jQuery("#msg").append("onjustbeforefinish" + "<br/>");
			},
			onbeforefinish: function() {
				//jQuery("#msg").append("onbeforefinish" + "<br/>");
			},
			onbeforefinishcomplete: function() {
				//jQuery("#msg").append("onbeforefinishcomplete" + "<br/>");
			},
			onfinish: function() {
				//$("#msg").append("onfinish" + "<br/>");
				jQuery('#cmdStop').click();
			}
		};
		if(self.m_isLivePlayer) {
			var callEnded = function () {
				jQuery('#cmdStop').click();
				jQuery("#" + self.m_playerDivId + " .formWaitingMessage").hide();
				self.EnabledDisabledButton('cmdPlay', false);
				self.EnabledDisabledButton('cmdStop', false);
				if (self.m_callbacks && self.m_callbacks.onStop) {
					self.m_callbacks.onStop();
				}
				self.ShowMessage('<%=_T([[The call has ended.]])%>', 'formInfoMessage');
			};
			// es el liveplayer
			definitions.onload = function() {
				if (this.readyState === 2) {
					callEnded();
				}
			};
			definitions.onfinish = function() {
				callEnded();
			};
			definitions.whileplaying = function() {
				if(!self.m_gotFirstChunkOfAudio) {
					self.m_gotFirstChunkOfAudio = true;
					jQuery("#" + self.m_playerDivId + " .formWaitingMessage").hide();
				}
			};
		}
		else {
			// no es el liveplayer
			definitions.whileloading = function() {
				// theoretically, this should work.
				var maximum = Math.floor((this.bytesLoaded / this.bytesTotal) * self.m_progressBarWidth);
				self.m_sliderLoadedData.style.width = maximum + "px";
			};
			var previousTime = 0;
			definitions.whileplaying = function() {
				if(!self.m_gotFirstChunkOfAudio) {
					self.m_gotFirstChunkOfAudio = true;
					var query = "#" + self.m_playerDivId + " ." + self.GetPrefixSuffix().prefix + "Progress";
					jQuery(query).addClass("playing").removeClass("pause");
				}
				// this.position tiene la posición dentro del audio, en milisegundos
				var roundedTime = Math.floor(this.position / 1000);
				if(roundedTime === previousTime) {
					return;
				}
				previousTime = roundedTime;
				var dur = this.durationEstimate;
				var position = Math.floor((this.position / dur) * self.m_progressBarWidth);
				self.m_sliderPlayingPos.style.width = position + "px";
				document.getElementById("progressPlayingTime").innerHTML = self.CalculateTime(this.position, true);
			};
			definitions.onload = function() {
				// ojo que cuando se corta el socket el bytes loaded salta al bytesTotal
				if(this.readyState === 2) {
					// terminó con error
					self.ShowMessage('<%=_T([[Error play streaming, please contact your administrator.]])%>');
				}
			};
		}
		definitions.id = soundId;
		definitions.url = urlName;
		// hay que esperar a que el soundmanager este listo. Si en este punto no lo está, encolar el audio y que lo haga el evento onload del soundmanager
		if(g_soundManagerIsReady) {
			soundManager.createSound(definitions);
		}
		else {
			/*setTimeout(function() {	// esto estar
				soundManager.createSound(definitions);
			}, 1000);*/
			g_pendingSound = definitions;
		}
		self.ResetPlayingInfo();
	};

	// pone la barra de playing y loading a cero, borra el reloj, etc
	self.ResetPlayingInfo = function() {
		self.m_sliderLoadedData.style.width = "0px";
		self.m_sliderPlayingPos.style.width = "0px";
		document.getElementById("progressPlayingTime").innerHTML = "0:00";
	};

	self.CalculateTime = function(nMSec, returnAsString) {
		// convert milliseconds to mm:ss, return as object literal or string
		var nSec = Math.floor(nMSec / 1000);
		var min = Math.floor(nSec / 60);
		var sec = nSec - (min * 60);
		return (returnAsString ? (min + ':' + (sec < 10 ? '0' + sec : sec)) : {'min' : min, 'sec' : sec});
	};

	///////////////////////////////////////////////////////////
	// vacia el div correspondinte al player y stopea el sonido.
	this.DestroyPlayer =  function() {
		jQuery('#cmdStop').click();
		jQuery('#' + self.m_playerDivId).empty();
	};

	///////////////////////////////////////////////////////////
	// funcion que se ejecuta si ocurre algun tipo de error en server o algun tipo de info a mostrar
	this.ShowMessage =  function(message, newClass) {
		var className = (newClass === undefined ? 'formErrorMessage' : newClass);
		var element = document.getElementById("messageError");
		if (element && element.className !== className) {
			element.className = className;
		}
		jQuery("#messageError div").text(message);
		jQuery("#messageError").show();

		if (self.m_waiting) {
			self.m_waiting.Hide();
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetJsonLength = function (jsonData) {
		var jsonLength = 0;
		for (var key in jsonData) {
			if (typeof(jsonData[key]) === "object") {
				jsonLength++;
			}
		}
		return jsonLength;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetObjectInJsonByProperty = function (jsonData, property, value) {
		// uso para retornar 2 parámetros un array ya que todos los parámetros en JavaScript son por valor,
		//	y además no se puede retornar mas de una valor en la funcion.
		var arrRet = [];
		var returnObject;
		var keyObject;

		for (var key in jsonData) {
			var oneObject = jsonData[key];
			if (oneObject[property] === value) {
				returnObject = oneObject;
				keyObject = key;
				break;
			}
		}
		// array a retornar
		arrRet.push(keyObject); 	// agrego la clave del objeto en la Posicion 1
		arrRet.push(returnObject); 	// agrego el objeto en la Posicion 2

		return arrRet;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetURL = function(url) {
		self.m_urlToMonitoring = url;
	};
	this.GetURL = function() {
		return (self.m_isLivePlayer !== true ? self.m_urlToMonitoring :
			self.GetMediaServerPath('START_STREAM').concat(
				'/', self.m_jsonDataToMonitoring.interactionId,
				'&', self.m_jsonDataToMonitoring.asteriskIp)
		);
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetHtmlPlayer = function (mediaType) {
		self.SetTypeOfMedia(mediaType);
		return self.m_player[mediaType].CreateHtmlBody(self);
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetJsonDetail = function(jsonDetail) {
		self.m_jsonDetail = jsonDetail;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetScrollInChat = function() {
		self.m_hasScrollToTheLastMessage = ! self.m_hasScrollToTheLastMessage;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetWaitingObject = function(waitingObject) {
		self.m_waiting = waitingObject;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetChatColumns = function(jsonHeader) {
		self.m_jsonHeader = jsonHeader;
	};

	//////////////////////////////////////////////////////////////////////////////
	//	funcion llamada desde
	this.SetTypeOfMedia = function(mediaType) {
		self.m_mediaType = mediaType;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetMediaServerConfig = function(mediaServerIPAddress, mediaServerPort) {
		if(mediaServerIPAddress !== "127.0.0.1" && mediaServerIPAddress !== "localhost") {
			self.m_mediaServerIPAddress = mediaServerIPAddress;
		}
		self.m_mediaServerPort = mediaServerPort;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetMediaServerPath = function(methodName) {
		var mediaServerPath = "";
		if(self.m_mediaServerIPAddress !== "127.0.0.1" && self.m_mediaServerIPAddress !== "localhost") {
			mediaServerPath += "http://";
			mediaServerPath += self.m_mediaServerIPAddress + ":";
			mediaServerPath += self.m_mediaServerPort;
		}
		mediaServerPath += self.m_pathsList["MEDIASERVER-PATH"];
		mediaServerPath += self.m_mediaServerListOfMethod[methodName];

		return mediaServerPath;
	};

	//////////////////////////////////////////////////////////////////////////////
	// Método privado
	this.InitializeEvents = function() {
		// evento click en el link collapse del player
		jQuery('#playerCollapse')
			.click(function() {
				eval("jQuery('#playerDetail').".concat(self.m_functionHiddenDetail, '("slow");'));
				self.m_functionHiddenDetail = (self.m_functionHiddenDetail === 'hide' ? 'show' : 'hide');

				var elementLinkDetailCollapse = document.getElementById("lnkDetailCollapse");
				if (elementLinkDetailCollapse !== null) {
					var prefixSuffix = self.GetPrefixSuffix();
					var classCollapse = "butCollapse" + prefixSuffix.suffix;
					var classUnCollapse = "butUncollapse" + prefixSuffix.suffix;
					elementLinkDetailCollapse.className = (elementLinkDetailCollapse.className === classCollapse ? classUnCollapse : classCollapse);
				}
			});

		// evento click en el checkbox de chat
		jQuery('#chkScroll').click( function() {
				self.SetScrollInChat();
			});

		// eventos comunes a los tres botones
		jQuery("#cmdPlay, #cmdPause, #cmdStop")
			.mouseover(function() {
				self.Hover(this, true);
			})
			.mouseout(function() {
				self.Hover(this, false);
			});

		// eventos sobre el boton play del player
		jQuery('#cmdPlay')
			.click( function() {
				if (self.m_action === "play") {
					return;
				}
				if (self.m_action === "stop") {
					// a este if entra si ha presionado stop, ya que se ha destruido el sonido y se debe generar nuevamente
					// url startstream del mediaserver
					self.CreateSound(self.m_soundId, self.GetURL());
				}
				self.m_gotFirstChunkOfAudio = false;
				if(self.m_isLivePlayer) {
					jQuery("#" + self.m_playerDivId + " .formWaitingMessage").show();
				}

				// es necesario hacer el play antes de setear el volumen
				var volume = self.m_sliderVolume.getValue();
				soundManager.play(self.m_soundId);
				soundManager.setVolume(self.m_soundId, volume);
				self.EnabledDisabledButton(this.id, false);
				self.EnabledDisabledButton('cmdPause', true);
				self.EnabledDisabledButton('cmdStop', true);
				self.m_action = 'play';
				return false;
			});

		// eventos sobre el boton pause del player
		jQuery('#cmdPause')
			.click( function() {
				if (self.m_action === "pause") {
					return;
				}
				soundManager.pause(self.m_soundId);
				self.EnabledDisabledButton('cmdPlay', true);
				self.EnabledDisabledButton(this.id, false);
				self.EnabledDisabledButton('cmdStop', true);
				self.m_action = 'pause';
				jQuery("#" + self.m_playerDivId + " ." + self.GetPrefixSuffix().prefix + "Progress").removeClass("playing").addClass("pause");
			});

		// eventos sobre el boton stop del player
		jQuery('#cmdStop')
			.click(function() {
				if (self.m_action === "stop") {
					return;
				}
				soundManager.destroySound(self.m_soundId);
				self.EnabledDisabledButton('cmdPlay', true);
				self.EnabledDisabledButton('cmdPause', false);
				self.EnabledDisabledButton(this.id, false);
				self.m_action = 'stop';
				self.ResetPlayingInfo();
				jQuery("#" + self.m_playerDivId + " ." + self.GetPrefixSuffix().prefix + "Progress").removeClass("playing").removeClass("pause");
			});
	};

	//////////////////////////////////////////////////////////////////////////////
	// Método privado
	this.EnabledDisabledButton = function(elementId, isEnabled) {
		var commandButton = document.getElementById(elementId);
		if (commandButton !== null) {
			commandButton.disabled = !isEnabled;
			var className = commandButton.className.replace(/-ds/g, '');
			if (isEnabled === false) {
				className = className.replace(/-ov/g, '');
				className = className + "-ds";
			}
			commandButton.className = className;
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	// Método privado
	this.Hover = function(element, addOver) {
		var className = element.className.replace(/-ov/g, '');
		if (addOver === true) {
			className = className + "-ov";
		}
		element.className = className;
	};

	//////////////////////////////////////////////////////////////////////////////
	// Método privado
	this.CreateDivContainer = function(arrHtml, prefixSuffix) {
		var divContainer = document.getElementById(self.m_playerDivId);
		if (divContainer === null) {
			divContainer = document.createElement("div");
			divContainer.id = self.m_playerDivId;
			document.body.appendChild(divContainer);
		}
		divContainer.className = 'form' + prefixSuffix.suffix;
		var elementId = '#' + self.m_playerDivId;
		jQuery(elementId).empty();
		for(var key in arrHtml) {
			if (arrHtml.hasOwnProperty(key)) {
				jQuery(elementId).createAppend(arrHtml[key].initialElement, arrHtml[key].properties, arrHtml[key].children);
			}
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	// Funcion privada
	this.CreateHtmlTitle = function(prefixSuffix) {
		var title = self.m_mediaType === 'CHAT' ? '<%=_T([[Viewer Chat]])%>' : '<%=_T([[Player Calls]])%>';
		return {
			'initialElement': 'div', 'properties': {'className': prefixSuffix.prefix + 'Top'}, 'children': [
				'div', {'className': prefixSuffix.prefix + 'Tittle', 'text': title}, title,
				'div', {'className': prefixSuffix.prefix + 'CollapseArea'}, [
					'a', {'id': 'playerCollapse', 'href': '#', 'onclick': ''}, [
						'img', {'id': 'lnkDetailCollapse', 'class': 'butUncollapse' + prefixSuffix.suffix, 'src': '/inconcert/shared/inconcertplayer/images/blank.gif'}, []
					]
				]
			]
		};
	};

	//////////////////////////////////////////////////////////////////////////////
	// Funcion privada
	this.CreateHtmlDetail = function(prefixSuffix) {
		if(self.m_jsonDetail === undefined) {
			return null;
		}
 		var fieldsList = self.m_jsonDetail[self.m_mediaType];
		var arrDetailsRow = [];
		if (fieldsList !== undefined) {
			var fieldLength = self.GetJsonLength(fieldsList);
			var counterFilter = 0;
			var arrDetailsField = [];
			//recorre el json con la cantidad de campos a agregar al detalle
			for (var i = 0; i < fieldLength; i++) {
				if (fieldsList[i].hasCreate === 0) {
					continue;
				}
				counterFilter++;
				// abre div del row, donde se generaran los campos del detalle
				if (counterFilter === 1) {
					arrDetailsField = [];
				}
				//agrega un campo al detalle (label / input)
				arrDetailsField.push(
					'div', {'className': prefixSuffix.prefix + 'DetailsLabel'}, [
						'label', {}, fieldsList[i].label + ':'
					],
					'div', {'id': fieldsList[i].label, 'className': prefixSuffix.prefix + 'DetailsData'}, [
						'input', {
							'readonly': 'readonly',
							'id': self.m_prefix + fieldsList[i].fieldId,
							'name': fieldsList[i].txtName,
							'value': fieldsList[i].value,
							'type': 'text'
						}, []
					]
				);
				// Cierra el row de campos cuando llega al maximo de numero de campos soportados en la fila.
				if (counterFilter === self.m_fieldsByRow) {
					counterFilter = 0;
					arrDetailsRow.push('div', {'className': 'playerDetailsRow'}, arrDetailsField);
				}
			}
			// este cierre de rows se utiliza cuando el numero de campos agregados al row no llego al numero máximo.
			if (counterFilter > 0 && counterFilter < self.m_fieldsByRow) {
				arrDetailsRow.push('div', {'className': 'playerDetailsRow'}, arrDetailsField);
			}
		}
		return {
			'initialElement': 'div', 'properties': {'id': 'playerDetail', 'className': prefixSuffix.prefix + 'Middle'}, 'children': [
				'div', {'className': prefixSuffix.prefix + 'Details'}, [
					'div', {'id': 'playerDetailFields', 'className': prefixSuffix.prefix + 'DetailsAux'}, arrDetailsRow
				],
				"div", {"className": "formWaitingMessage", "style": "display: none"}, [
					"div"
				]	
			]
		};
	};

	///////////////////////////////////////////////////////////
	//
	this.GetPrefixSuffix = function() {
		var tapiPrefix = (self.m_isLivePlayer === true ? {prefix: 'player', suffix: 'Player'} : {prefix: 'storedPlayer', suffix: 'StoredPlayer'});
		var prefixSuffix = {
			"TAPI": tapiPrefix,
			"CHAT": {
				prefix: 'viewer',
				suffix: 'Viewer'
			}
		};
		return (self.m_mediaType === undefined ? '' : (prefixSuffix[self.m_mediaType] === undefined ? '' : prefixSuffix[self.m_mediaType]));
	};

	///////////////////////////////////////////////////////////
	// Crea el markup del player. 'justTheBody' en true indica que no quiero header, detalle ni footer
	this.CreatePlayer = function(justTheBody) {
		//prefijo o sufijo utilizado en el atributo class de los elementos html
		var prefixSuffix = self.GetPrefixSuffix();
		var arrHtml = [];
		if(justTheBody) {
			// html del player, segun tipo de interaccion
			arrHtml.push(
				self.m_player[self.m_mediaType].CreateHtmlBody(self)// html del player, segun tipo de interaccion
			);
		}
		else {
			//creo el titulo del html del player aqui tambien se encuentra el boton de collapse.
			var content = self.CreateHtmlTitle(prefixSuffix);
			if (content) {
				arrHtml.push(content);
			}
			//creo el detalle de la interacción.
			content = self.CreateHtmlDetail(prefixSuffix);
			if (content) {
				arrHtml.push(content);
			}	
			// html del player, segun tipo de interaccion
			content = self.m_player[self.m_mediaType].CreateHtmlBody(self);
			if (content) {
				arrHtml.push(content);
			}
			// html del pie
			content = self.m_player[self.m_mediaType].CreateHtmlFooter(self);
			if (content) {
				arrHtml.push(content);
			}
		}
		//creo el asigno al div contenedor el html generado
		self.CreateDivContainer(arrHtml, prefixSuffix);

		// inicializo player, creo sonido, slider e inicializo eventos
		var isChatPlayer = (self.m_mediaType === "CHAT" ? true : false);
		self.InitializePlayer(isChatPlayer);
		return isChatPlayer;
	};

	///////////////////////////////////////////////////////////
	// Método privado: inicializo player, creo sonido, slider e inicializo eventos
	this.InitializePlayer = function(isChatPlayer, buildVolume) {
		// si es TAPI creo el sonido para el soundmanager y creo los controles del slider
		if (!isChatPlayer) {
			if (buildVolume === true || buildVolume === undefined) {
				self.CreateSliderVolume();
			}
			self.CreateSliderPosition();
			self.CreateSound(self.m_soundId, self.GetURL());
		}
		self.InitializeEvents();
		self.EnabledDisabledButton('cmdPlay', true);
		self.EnabledDisabledButton('cmdPause', false);
		self.EnabledDisabledButton('cmdStop', false);
		self.m_action = null;
	};

	/////////////////////////////////////////////////////////////////////////////
	//
	this.m_player = {
		"CHAT": {
			CreateHtmlBody: function(self) {
				return {
					'initialElement': 'div', 'properties': {'className': 'viewerControlLeft'}, 'children': [
						'div', {'className': 'viewerControlRight'}, [
							'div', {'className': 'viewerControlChkBox'}, [
								'input', {'id': 'chkScroll', 'checked': 'checked', 'type': 'checkbox', 'onclick': ''}, [],
								'label', {'for': 'chkScroll'}, '<%=_T([[Go to last message]])%>'
							],
							'div', {'id': 'scrolldiv', 'className': 'viewerControlTable'}, [
								'div', {'className': 'viewerControlTableContainer'}, [
									'table', {'id': 'tableChatBody', 'className': 'viewerTableChat', 'cellspacing': '0', 'cellpadding': '0', 'border': '0'}, [
										'tbody', {}, [
											'tr', {}, self.CreateChatHeader()
										]
									]
								]
							]
						]
					]
				};
			},
			CreateHtmlFooter: function(self) {
				return {
					'initialElement': 'div', 'properties': {'className': 'viewerBottomLeft'}, 'children': [
						'div', {'className': 'viewerBottomRight'}, [
							'div', {'className': 'viewerBottomCenter'}, []
						]
					]
				};
			}
		},
		"TAPI": {
			CreateHtmlBody: function(self) {
				var display = (self.m_isLivePlayer === true ? 'none;' : ';');
				var prefix = self.GetPrefixSuffix().prefix;
				return {
					"initialElement": "div", "properties": {"className": prefix + "Bottom"}, "children": [
						"div", {"className": prefix + "Control"}, [
							//este div es utilizado en el storedplayer para visulalizar en progress del truking, en el live es oculto (que corno es el truking??)
								//
							"div", {"className": prefix + "Progress", "style": "display:" + display},
								[
								"div", { "id": "progressPlayingTime", "className": prefix + "ProgressTime" }, [],
								/*"div", { "className": prefix + "ProgressTime" }, [
									"span", { "id": "progressPlayingTime" }, [],
								],*/
								"div", { "id": "progressContainer", "className": prefix + "ProgressBarContainer" }, [
									"div", { "id": "progressLoaded", "className": prefix + "ProgressBarLoaded" }, [
										"div", { "id": "progressPlayingPos", "className": prefix + "ProgressBarPlayingPos" }, []
										]
									]
								],
								//--
								"div", {"id": prefix + "Manager", "className": prefix + "Buttons"}, [
									"button", { "id": "cmdPlay", "className": prefix + "ButtonPlay", "onclick": ""}, [],
									//este link es utilizado en el storedplayer para visulalizar el boton de pause, en el live es oculto
									"button", { "id": "cmdPause", "className": prefix + "ButtonPause-ds", "onclick": "", "style": "display:" + display}, [],
									"button", { "id": "cmdStop", "className": prefix + "ButtonStop-ds", "onclick": ""}, []
								],
								"div", { "className": prefix + "Volume" }, [
									"div", { "className": prefix + "VolumeSlider" }, [
										"div", {"id": "red-slider", "className": prefix + "SliderLine" }, [
										"input", {"id": "red-input", "maxlength": "3", "size": "1", "readonly": "readonly" , "style": "display:none"}, []
										]
									],
								"input", {"id": "red-slider-input", "className": "slider-input"}, []
							]
						]
					]
				};
			},
			CreateHtmlFooter: function(self) {
				return null;
			}
		}
	};

	this.CreateSliderPosition = function() {
		self.m_sliderLoadedData = document.getElementById("progressLoaded");
		self.m_sliderPlayingPos = document.getElementById("progressPlayingPos");

		var jqSlider = jQuery(self.m_sliderLoadedData);
		var jqParentWidth = jqSlider.parent().width();
		self.m_progressBarWidth = jqParentWidth;
		jqSlider.click(function(event) {
			var sound = soundManager.getSoundById(self.m_soundId);
			if(sound) {
				var sliderOffset = jqSlider.offset();
				var mouseX = parseInt(event.clientX, 10);
				// esta cuentita es la inversa a la que se usa en el whileplaying
				var nMsecOffset = Math.floor((mouseX - sliderOffset.left) * (sound.durationEstimate / jqParentWidth));
				sound.setPosition(nMsecOffset);
			}
		});
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreateSliderVolume = function() {
		//self.m_sliderVolume = null;
		var slider = new Slider(document.getElementById("red-slider"), document.getElementById("red-slider-input"));
		self.m_sliderVolume = slider;
		slider.setMaximum(self.m_maxVolume);
		slider.setMinimum(0);
		slider.onchange = function() {
			//Seteo volumen a SoundManager, pero solo si se está reproduciendo audio. Si lo hago antes de dar Play, en vez de setear el volumen modifica
			// el rango de la escala (o sea, si seteo volumen en 10, el rango va a ir de 0 a 10)
			var volume = slider.getValue();
			var sound = soundManager.getSoundById(self.m_soundId);
			if(sound && sound.playState !== 0) {
				soundManager.setVolume(self.m_soundId, volume);
			}
			/*if (typeof window.onchange == "function") {
				window.onchange();	// por qué a window onchange??
			}*/
		};
		slider.setValue(self.m_maxVolume);
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreateChatHeader = function () {
		var arrHeader = [];
		for (var i = 0; i < self.GetJsonLength(self.m_jsonHeader); i++) {
			var arrValueAndKey = self.GetObjectInJsonByProperty(self.m_jsonHeader, "position", i + 1);
			var key = arrValueAndKey[0]; // la clave
			var column = arrValueAndKey[1]; // el objeto
			if (column.visible === 1) {
				arrHeader.push(
					"th", {"width": column.width}, [
						"label", {"id": key.toUpperCase()}, column.text
					]
				);
			}
		}
		return arrHeader;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetDataHtmlDetail = function(jsonData) {
		var fieldsList = self.m_jsonDetail[self.m_mediaType];
		if (fieldsList === undefined) {
			return;
		}
		for (var i = 0; i < self.GetJsonLength(fieldsList); i++) {
			var inputElement = document.getElementById(self.m_prefix + fieldsList[i].fieldId);
			if (inputElement === undefined || inputElement === null) {
				continue;
			}
			////valueToAssign = eval('(jsonData[0].' + inputElement.id + ')'); // esto es para utilizarlo en el caso de que sea un array
			var fieldId = inputElement.id;
			fieldId = fieldId.substr(self.m_prefix.length);
			var valueToAssign = eval('(jsonData.' + fieldId + ')');
			//inputElement.value = (typeof(valueToAssign) == "undefined" ? '' : valueToAssign);
			if (valueToAssign !== undefined) {
				inputElement.value = valueToAssign;
			}
		}
	};

	/*
	* Métodos utilizados para enviar peticion POST, al Server (inconcertWebHandler)
	*  y métodos en los cuales se reciben las respuestas
	*/
	this.m_ajax = {
		send: {
			GetInteractionDetail: function(interactionId, section) {
			//esto comentado no borrarlo es para cuando me viene la seccion en -1 debo ver que hay que hacer con esto.
				//if (section == "-1") {
					//return;
				//}
				var jsonData = {"interactionId": interactionId, "section": section};
				var parameters = '';
				var functionToResponse = self.m_ajax.response.InteractionDetail;

				parameters += 'interactionDetail=';
				parameters += JSON.stringify(jsonData);

				var request = jQuery.ajax({
					url: self.m_pathsList['APPLICATION-SCRIPTS'] + 'get/interactiondetail',
					type: 'POST',
					async: true,
					data: parameters,
					success: functionToResponse,
					error: function(err) {
						//Error getting details of the interaction, please contact your administrator.
						self.ShowMessage('<%=_T([[Could not get interaction detail.]])%>');
					}
				});
				if (self.m_waiting) {
					self.m_waiting.SetRequest(request);
				}
			}
		}
		,
		response: {
			MonitorDirections: function(ajaxResponse) {
				self.m_jsonDirections = eval('(' + ajaxResponse + ')');
				if (self.m_jsonDirections === undefined || self.m_jsonDirections === null || self.m_jsonDirections.length === 0) {
					self.ShowMessage('<%=_T([[No interactions matching your criteria, please try again later.]])%>', 'formInfoMessage');
					return;
				}
				self.m_mediaServer.send.Monitor();
			}
			,
			InteractionDetail: function(ajaxResponse){
				var	jsonData = eval('(' + ajaxResponse + ')');
				if (self.m_jsonDetail === undefined || jsonData === null) {
					return;
				}
				self.SetDataHtmlDetail(jsonData);
			}
		}
	};

	/* (MEDIASERVER)
	* Métodos utilizados para enviar peticion POST, al Servicio (MEDIASERVER)
	*  y métodos en los cuales se reciben las respuestas
	*/
	this.m_mediaServer = {
		send: {
			Monitor: function() {
				var data = JSON.stringify(self.m_jsonDirections);
				var functionToResponse = self.m_mediaServer.response.Monitor;
				var params = data;
				var request = jQuery.ajax({
					url: self.GetMediaServerPath('MONITOR') + '/',
					type: 'POST',
					data: params,
					async: true,
					success: functionToResponse,
					error: function(err) {
						var message = '';
						var className;
						if(err.status === 504) {
							message = '<%=_T([[No interactions matching your criteria, please try again later.]])%>'; //'Timeout error monitoring, please contact your administrator.';
							className = 'formInfoMessage';
						}
						else {
							message = '<%=_T([[Error searching for interactions, please contact your administrator.]])%>'; //'Monitoring error, please contact your administrator.';
						}
						self.ShowMessage(message, className);
					}
				});
				if (self.m_waiting) {
					self.m_waiting.SetRequest(request);
				}
			}
			,
			StartStream: function() {
				var isChatPlayer = self.CreatePlayer();
				if (isChatPlayer) {
  					var data = JSON.stringify(self.m_jsonDataToMonitoring);
					var functionToResponse = self.m_mediaServer.response.StartStream;
					var params = 'direction=' + data;
					params += '&';
					params += 'interactionType=' + self.m_mediaType;

					var request = jQuery.ajax({
						url: self.GetMediaServerPath('START_STREAM'),
						type: 'POST',
						async: true,
						data: params,
						success: functionToResponse,
						error: function(err) {
							//'Error in chat streaming, please contact your administrator.';
							self.ShowMessage('<%=_T([[Error in chat streaming, please contact your administrator.]])%>');
						}
					});
					if (self.m_waiting) {
						self.m_waiting.SetRequest(request);
					}
				}
				else {
					if (self.m_waiting !== undefined) {
						self.m_waiting.Hide();
					}
				}
			}
			,
			PollStream: function() {
				if (self.m_isStreamChat) {
					self.m_token = self.m_jsonData.token;
					TOKEN_BORRAME++;
					if (TOKEN_BORRAME > 3) {TOKEN_BORRAME = 1;}

					var functionToResponse = self.m_mediaServer.response.PollStream;
					var params = 'token=' + self.m_token + TOKEN_BORRAME;
					var request = jQuery.ajax({
						url: self.GetMediaServerPath('POLL_STREAM'),
						type: 'POST',
						async: true,
						data: params,
						success: functionToResponse,
						error: function(err) {
							//'Error pooling chat, please contact your administrator.';
							self.ShowMessage('<%=_T([[Error pooling chat, please contact your administrator.]])%>');
						}
					});
					if (self.m_waiting) {
						self.m_waiting.SetRequest(request);
					}
				}
			}
			,
			StopStream: function() {
				if (self.m_isStreamChat) {
					var functionToResponse = self.m_mediaServer.response.StopStream;
					var params = 'token=' + self.m_token;

					var request = jQuery.ajax({
						url: self.GetMediaServerPath('STOP_STREAM'),
						type: 'POST',
						async: true,
						data: params,
						success: functionToResponse,
						error: function(err) {
							//'Error stoping chat, please contact your administrator.';
							self.ShowMessage('<%=_T([[Error stoping chat, please contact your administrator.]])%>');
						}
					});
					self.m_isStreamChat = false;
					if (self.m_waiting) {
						self.m_waiting.SetRequest(request);
					}
				}
			}
		}
		,
		response: {
			Monitor: function(ajaxResponse) {
				self.m_jsonDataToMonitoring = eval('(' + ajaxResponse + ')');
				if (self.m_jsonDataToMonitoring !== undefined) {
					self.m_ajax.send.GetInteractionDetail(self.m_jsonDataToMonitoring.interactionId,
															self.m_jsonDataToMonitoring.section);
					self.m_mediaServer.send.StartStream();
					if (self.m_mediaType === "TAPI") {
						self.SetDataHtmlDetail(self.m_jsonDataToMonitoring);
					}
				}
			}
			,
			StartStream: function(ajaxResponse) {
				self.SetDataHtmlDetail(self.m_jsonDataToMonitoring);
				self.m_jsonData = eval('(' + ajaxResponse + ')');
				self.ProcessJsonInitialDataChat();
				if (self.m_waiting !== undefined) {
					self.m_waiting.Hide();
				}
			}
			,
			PollStream: function(ajaxResponse) {
				self.m_jsonData = eval('(' + ajaxResponse + ')');
				self.AddRowsToChat(self.m_jsonData.data);
				self.m_mediaServer.send.PollStream();
			}
			,
			StopStream: function() {
			}
		}
	};

	///////////////////////////////////////////////////////////
	//
	this.ProcessJsonInitialDataChat = function() {
		self.m_counterOfMessages = 0;
		self.AddRowsToChat(self.m_jsonData.data);
		self.m_isStreamChat	= true;
		self.m_mediaServer.send.PollStream();
	};

	///////////////////////////////////////////////////////////
	//
	this.AddRowsToChat = function(jsonData) {
		if (jsonData === undefined) {
			return;
		}
		var myTable = document.getElementById('tableChatBody');
		if (myTable === null) {
			return;
		}
		var positionRow = (self.m_rowsOfChatDescending === false ? 1: -1); // si el Row se debe posicionar abajo o arriba de las demas filas
		// recorre cada uno de los mensajes a agregar !!!!!
		for (var i = 0; i < self.GetJsonLength(jsonData); i++) {
			var oRow = myTable.insertRow(positionRow);
			var counterOfColumnAddInHeaders = 0;
			//recorre cada uno de los campos del encabezado de las columnas, para obtener el id del Campo
			for (var j = 0; j < self.GetJsonLength(self.m_jsonHeader); j++) {
				var arrValueAndKey = self.GetObjectInJsonByProperty(self.m_jsonHeader, 'position', j + 1);
				var key = arrValueAndKey[0]; // la clave
				var column = arrValueAndKey[1]; // el objeto

				// si la columna se debe visualizar
				if (column.visible === 1) {
					counterOfColumnAddInHeaders++;
					if (counterOfColumnAddInHeaders === 1) {
						oRow.className = jsonData[i][key];
						oRow.id = "CHAT_MESSAGE_" + (++self.m_counterOfMessages);
					}
					var oCell = oRow.insertCell(-1);
					oCell.innerHTML = jsonData[i][key];
				}
			}
		}
		if (self.m_rowsOfChatDescending === true) {
			var divContainer = document.getElementById('scrolldiv');
			if (self.m_hasScrollToTheLastMessage) {
				divContainer.scrollTop = divContainer.scrollHeight;
			}
		}
	};
} //Fin de la Clase CInconcertPlayer/////////////////////////////////////////////////