local string = string
local os = os
local uuid = require("uuid")

-- llamo con parentesis, para que pase solo el primer parametro
module((...))	-- shared.streaming.constants

--[[
Retorno de la creacin de un stream.
--]]
StreamCreationResult = {
	--[=[
	El origen deseado para el stream no es accesible. Por ejemplo, el archivo a tocar 
	no est en el repositorio, no est en disco, la extensin a escuchar no existe o 
	no est siendo monitoreada.
	--]=]
	SOURCE_UNAVAILABLE = 0,
	--[=[
	El formato de los datos no es el esperado. Por ejemplo, el formato de audio de un 
	archivo no es reconocible.
	--]=]
	SOURCE_WRONG_DATA = 1,
	--[=[
	No se puede aplicar una transformacin a los datos de entrada para convertirlos a 
	MP3.
	--]=]
	CANNOT_TRANSFORM_DATA = 2,
	--[=[
	El Stream fue creado con xito.
	--]=]
	OK = 3,
	--[=[
	No se puede crear un stream para manejar el tipo pedido. 
	--]=]
	NOHANDLER = 4
}

--[[
Status del stream. Cada pedido de un nuevo chunk de datos para enviar retorna uno 
de estos cdigos.
--]]
StreamIOResult = {
	-- An quedan datos por enviar.
	MORE_DATA = 0,
	-- Estamos enviando el ltimo chunk de datos.
	LAST_CHUNK = 1,
	-- Ya no hay ms datos por enviar.
	END_OF_DATA = 2,
	-- No enviar datos, pero mantener viva la conexin.
	DONT_SEND_DATA = 3
}

--[[
constantes utilizadas en el Live (sreamLive.lua), contiene valores de conexion de la asterisk (el port por ahora es hardcode)
--]]

asterisk = {
	connection = {
		port = "1785"
	}
}
