local m_moduleName = select(1, ...)
module(..., package.seeall)
 
local streamConstructors = {
	wave = function(parameter, ...)
		local wave = require(m_moduleName .. ".streamWave")
		return wave.Init(parameter, ...)
	end,
	
	repo = function(parameter, ...)
		local repository = require(m_moduleName .. ".streamRepository")
		return repository.Init(parameter, ...)
	end,

	live = function(parameter, ...)
		local live = require(m_moduleName .. ".streamLive")
		return live.Init(parameter, ...)
	end,

	backup = function(parameter, ...)
		local backup = require(m_moduleName .. ".streamBackup")
		return backup.Init(parameter, ...)
	end
}

function BuildStream(streamType, parameter, ...)
	assert(type(streamType) == "string")
	
	local streamType = streamType:lower()
	local constructor = streamConstructors[streamType]
	if constructor then
		return constructor(parameter, ...)
	end
	error("unknown stream type %s", tostring(streamType))
end


