require("LuaOrm.Mapper")
require("LuaOrm.Entity")
require("LuaOrm.Model")
require("LuaOrm.DBMS.DataSource")
require("LuaOrm.Associations.Associations")
--local luaSerializer = require("LuaOrm.Serializers.Lua")
local m_favoritesinstances = nil

module(..., package.seeall)

--///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function new(applicationName)
	if not (_M.m_favoritesinstances) then
		_M.m_favoritesinstances = {}
	end
	_M.m_favoritesinstances[applicationName] = _M.m_favoritesinstances[applicationName] or {
		applicationName = applicationName,
		models = {},
		InitializeTables = _M.InitializeTables,
		GetFavoritesModel = _M.GetFavoritesModel,
	}
	return _M.m_favoritesinstances[applicationName]
end

function InitializeTables(self, dataSource)
	self.models['Application'] = LuaOrm.Model {
		tableName = "Application",
		dataSource = dataSource,
		Associations = {
			hasMany("ApplicationAction", nil, true),
			hasMany("ApplicationLicense", nil, true)
		},
		Attributes = {
			DisplayDescription = function(entity) 
				return _T(entity.Description)
			end
		}
	}

	-- retorna la lista de tablas inicializadas
	return self.models
end

--[=[
Funcion que retorna una tabla lua con las tablas utilizadas por el modelo de permisos
--]=]
function GetFavoritesModel(self, dataSource)
	self:InitializeTables(dataSource)
	return self.models
end
