drop table filterCombo
drop table filterDetail
drop table filterHeader
drop table filterComboData

CREATE TABLE [filterHeader] (
	[applicationId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[userId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[pageName] [varchar] (60) COLLATE Latin1_General_CI_AI NOT NULL ,
	[filterId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[filterType] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[ordinal] [numeric](5, 0) NOT NULL,
	CONSTRAINT [PK_FILTERHEADER] PRIMARY KEY  CLUSTERED 
	(
		[applicationId],
		[userId],
		[pageName],
		[filterId]
	)  ON [PRIMARY] ,
) ON [PRIMARY]
GO

CREATE TABLE [filterDetail] (
	[applicationId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[userId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[pageName] [varchar] (60) COLLATE Latin1_General_CI_AI NOT NULL ,
	[filterId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[fieldId] [varchar] (20) COLLATE Latin1_General_CI_AI NOT NULL ,
	[captionText] [varchar] (20) COLLATE Latin1_General_CI_AI NOT NULL ,
	[value] [varchar] (50) COLLATE Latin1_General_CI_AI NOT NULL ,
	[tagId] [varchar] (10) COLLATE Latin1_General_CI_AI NOT NULL ,
	[tagType] [varchar] (10) COLLATE Latin1_General_CI_AI NOT NULL ,
	[formatDate] [varchar] (20) COLLATE Latin1_General_CI_AI NOT NULL ,
	[isDynamic] [numeric](1, 0) NOT NULL,
	[hasBlankFirstElement] [numeric](1, 0) NOT NULL,
	[ordinal] [numeric](5, 0) NOT NULL,
	CONSTRAINT [PK_FILTERDETAIL] PRIMARY KEY  CLUSTERED 
	(
		[applicationId],
		[userId],
		[pageName],
		[filterId],
		[fieldId]
	)  ON [PRIMARY] ,
	CONSTRAINT [FK_filterDetail_filterHeader] FOREIGN KEY 
	(
		[applicationId],
		[userId],
		[pageName],
		[filterId]
	) REFERENCES [filterHeader] (
		[applicationId],
		[userId],
		[pageName],
		[filterId]
	)
) ON [PRIMARY]
GO

CREATE TABLE [filterComboData] (
	[ItemId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[Value] [varchar] (100) COLLATE Latin1_General_CI_AI NOT NULL ,
	CONSTRAINT [PK_filterComboData] PRIMARY KEY  CLUSTERED 
	(
		[ItemId]

	)  ON [PRIMARY]
) ON [PRIMARY]
GO


CREATE TABLE [filterCombo] (
	[applicationId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[userId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[pageName] [varchar] (60) COLLATE Latin1_General_CI_AI NOT NULL ,
	[filterId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	[fieldId] [varchar] (20) COLLATE Latin1_General_CI_AI NOT NULL ,
	[ItemId] [varchar] (40) COLLATE Latin1_General_CI_AI NOT NULL ,
	CONSTRAINT [PK_filterCombo] PRIMARY KEY  CLUSTERED 
	(
		[applicationId],
		[userId],
		[pageName],
		[filterId],
		[fieldId],
		[ItemId]

	)  ON [PRIMARY] ,
	CONSTRAINT [FK_filterCombo_filterDetail] FOREIGN KEY 
	(
		[applicationId],
		[userId],
		[pageName],
		[filterId],
		[fieldId]
	) REFERENCES [filterDetail] (
		[applicationId],
		[userId],
		[pageName],
		[filterId],
		[fieldId]
	),
	CONSTRAINT [FK_filterCombo_filterComboData] FOREIGN KEY 
	(
		[ItemId]
	) REFERENCES [filterComboData] (
		[ItemId]
	)
) ON [PRIMARY]
GO

/*


/*
select * from filterDetail where applicationId = 'inconcertmediaplayer'

select * from filterHeader 
select * from filterDetail where applicationId = 'inconcertmediaplayer' and userId = 'agent1' and filterId = 'Agent' and pageName = 'MLPPLAYER'
select * from filterCombo

select * from usuarios0092
select applicationId, userId, filterId, ordinal from filterHeader where filterId = 'FILTER1'

select * from select applicationId, userId, filterId, ordinal from filterHeader where filterId = 'FILTER1' and  and 

SELECT applicationId, userId, filterId, fieldId, captionText, value, tagId, tagType, ordinal FROM filterHeader, filterDetail WHERE filterHeader.filterId = 'FILTER1' AND filterHeader.userId = 'agent1' AND filterHeader.applicationId = 'inconcertmediaplayer' AND filterHeader.filterId = filterDetail.filterId AND filterHeader.userId = filterDetail.userId AND filterHeader.applicationId = filterDetail.applicationId

SELECT filterDetail.applicationId, filterDetail.userId, filterDetail.filterId, filterDetail.fieldId, filterDetail.captionText, filterDetail.value, filterDetail.tagId, filterDetail.tagType, filterDetail.ordinal FROM filterHeader, filterDetail WHERE filterHeader.filterId = 'FILTER2' AND filterHeader.userId = 'agent1' AND filterHeader.applicationId = 'inconcertmediaplayer' AND filterHeader.filterId = filterDetail.filterId AND filterHeader.userId = filterDetail.userId AND filterHeader.applicationId = filterDetail.applicationId


select * from filterCombo
select * from filterDetail
select * from filterHeader
select * from filterComboData


select * from filterHeader where applicationId = 'mediaplayer'
select * from filterDetail where applicationId = 'mediaplayer'
select * from filterCombo where applicationId = 'mediaplayer'

delete from filterHeader where applicationId = 'mediaplayer'
delete from filterDetail where applicationId = 'mediaplayer'
delete from filterCombo where applicationId = 'mediaplayer'

select * from filterHeader where filterid = 'Default VoiceMail'
select * from filterDetail where filterid = 'Default VoiceMail'
select * from filterHeader where filterid = 'Default VoiceMail1'
select * from filterDetail where filterid = 'Default VoiceMail1'
select * from filterHeader where filterid = 'Default22'
select * from filterDetail where filterid = 'Default22'
select * from filterCombo where filterid = 'Default22'

/*
drop table filterCombo
drop table filterDetail
drop table filterHeader
drop table filterComboData
*/
/*

delete from filterCombo
delete from filterDetail
delete from filterHeader
delete from filterComboData


-----------------------------------------------------------------------------------------------
--- Estos registros son para el TESTCASE de 'inoncertGrid.js' --------------------------------
-----------------------------------------------------------------------------------------------
INSERT INTO filterHeader VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'APP',  1)
INSERT INTO filterHeader VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB1', 'APP',  2)

INSERT INTO filterDetail VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'applicationId', 'App.Name', 'MULTIMEDIA LIVE PLAYER', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'dateField', 'dateSample', '', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'textField', 'textSample', 'algo', 'input', 'text', '', 0, 0, 3)
INSERT INTO filterDetail VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB1', 'textField', 'TEXT', '', 'input', 'text', '', 0, 0, 1)

INSERT INTO filterComboData VALUES('MULTIMEDIA LIVE PLAYER', 'Live Player')
INSERT INTO filterComboData VALUES('MULTIMEDIA STORED PLAYER', 'Stored Player')
INSERT INTO filterComboData VALUES('TESTCASE', 'Grid Test Case')

INSERT INTO filterCombo VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'applicationId', 'MULTIMEDIA LIVE PLAYER')
INSERT INTO filterCombo VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'applicationId', 'MULTIMEDIA STORED PLAYER')
INSERT INTO filterCombo VALUES('TESTCASE', 'supervisor', 'PAGE1', 'json From DB', 'applicationId', 'TESTCASE')

-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------


--****************************************************************************************************************
-- Filtros para inconcertmediaplayer
--****************************************************************************************************************

-- /////Tabla que contiene los diferentes tipos de valores que pueden contener los elelemntos tipo SELECT(combo estaticos)////////
INSERT INTO filterComboData VALUES('CHAT', 'chat')
INSERT INTO filterComboData VALUES('FAX', 'fax')
INSERT INTO filterComboData VALUES('MAIL', 'e-mail')
INSERT INTO filterComboData VALUES('TAPI', 'call')
INSERT INTO filterComboData VALUES('VOICEMAIL', 'voice mail')

--===============================================================
-- Filtro de un SUPERVISOR

-- /////Tabla Cabecera de Filtro/////////////////////////////////////////////////////////////////////////////////////////
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Generic', 'GENERIC',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site',  'SITE', 2)

--===============================================================
--select * from filterDetail
-- //////Tabla con cada uno de los campos del filtro/////////////////////////////////////////////////////////////////////
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Generic', 'Type', 'Type', 'TAPI', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Generic', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Generic', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site', 'Type', 'Type', 'VOICEMAIL', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site', 'Site', 'Site', 'Loyal', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)

--===============================================================

-- //////Tabla con que contiene los valores que contiene un campo tipo SELECT (Combo)////////////////////////////////////
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Generic', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Generic', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MLPPLAYER', 'Site', 'Type', 'TAPI')
--===============================================================



--===============================================================
-- Filtro de un AGENTE
	--(agent1)
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MLPPLAYER', 'Generic', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MLPPLAYER', 'Generic', 'Type', 'Type', 'TAPI', 'select', 'text', '', 0, 0, 1)

INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MLPPLAYER', 'Generic', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MLPPLAYER', 'Generic', 'Type', 'TAPI')

	--(Actor4)
INSERT INTO filterHeader VALUES('mediaplayer', 'Actor4', 'MLPPLAYER', 'Generic', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'Actor4', 'MLPPLAYER', 'Generic', 'Type', 'Type', 'TAPI', 'select', 'text', '', 0, 0, 1)

INSERT INTO filterCombo VALUES('mediaplayer', 'Actor4', 'MLPPLAYER', 'Generic', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'Actor4', 'MLPPLAYER', 'Generic', 'Type', 'TAPI')


--===============================================================
-- Filtro de un ADMINISTRADOR

-- /////Tabla Cabecera de Filtro/////////////////////////////////////////////////////////////////////////////////////////
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Generic', 'GENERIC',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site',  'SITE', 2)


--select * from filterDetail
-- //////Tabla con cada uno de los campos del filtro/////////////////////////////////////////////////////////////////////
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Generic', 'Type', 'Type', 'TAPI', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Generic', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Generic', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site', 'Type', 'Type', 'VOICEMAIL', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site', 'Site', 'Site', 'Loyal', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)

-- //////Tabla con que contiene los valores que contiene un campo tipo SELECT (Combo)////////////////////////////////////
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Generic', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Generic', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MLPPLAYER', 'Site', 'Type', 'TAPI')


--===============================================================
-- Filtro de un Dueo del CCV

INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MLPPLAYER', 'Generic', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MLPPLAYER', 'Generic', 'Type', 'Type', 'TAPI', 'select', 'text', '', 0, 0, 1)

INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MLPPLAYER', 'Generic', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MLPPLAYER', 'Generic', 'Type', 'TAPI')

--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MLPPLAYER', 'Generic', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MLPPLAYER', 'Generic', 'Type', 'Type', 'TAPI', 'select', 'text', '', 0, 0, 1)

INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MLPPLAYER', 'Generic', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MLPPLAYER', 'Generic', 'Type', 'TAPI')



--****************************************************************************************************************
-- Filtros para mediaplayer
--****************************************************************************************************************

--===============================================================
-- Filtro de un SUPERVISORES
-- /////Tabla Cabecera de Filtro/////////////////////////////////////////////////////////////////////////////////////////
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CHAT',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPFAXINTERACTIONSVIEW', 'Default', 'FAX',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MAIL',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CALL',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'VOICEMAIL',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'GENERIC',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN',  1)
INSERT INTO filterHeader VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR',  1)

--===============================================================

-- //////Tabla con cada uno de los campos del filtro/////////////////////////////////////////////////////////////////////
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Source', 'Source', 'Source1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Target', 'Target', 'Target1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 5)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCHATINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 6)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPFAXINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPFAXINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPFAXINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPFAXINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailFrom', 'From', 'MailFrom1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailTo', 'To', 'MailTo1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailCc', 'CC', 'MailCc1', 'input', 'text', '', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 5)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 6)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPMAILINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 7)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCALLINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCALLINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCALLINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 5)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 5)

INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 5)


--===============================================================

-- //////Tabla con que contiene los valores que contiene un campo tipo SELECT (Combo)////////////////////////////////////
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')

INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')

INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'supervisor', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')
--===============================================================




--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 5)

INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'ACTOR',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPACTORINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CHAT',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Source', 'Source', 'Source1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Target', 'Target', 'Target1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 4)

--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CHAT',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Source', 'Source', 'Source1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Target', 'Target', 'Target1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 5)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCHATINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 6)

--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CHAT',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Source', 'Source', 'Source1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Target', 'Target', 'Target1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 4)

--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'CHAT',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Source', 'Source', 'Source1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'Target', 'Target', 'Target1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCHATINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 4)

--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'FAX',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)


--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'FAX',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPFAXINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)


--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPFAXINTERACTIONSVIEW', 'Default', 'FAX',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPFAXINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPFAXINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPFAXINTERACTIONSVIEW', 'Default', 'FAX',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPFAXINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPFAXINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)


--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailFrom', 'From', 'MailFrom1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailTo', 'To', 'MailTo1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailCc', 'CC', 'MailCc1', 'input', 'text', '', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 5)

--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailFrom', 'From', 'MailFrom1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailTo', 'To', 'MailTo1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailCc', 'CC', 'MailCc1', 'input', 'text', '', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 5)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 6)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPMAILINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 7)

--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailFrom', 'From', 'MailFrom1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailTo', 'To', 'MailTo1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailCc', 'CC', 'MailCc1', 'input', 'text', '', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 5)

--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailFrom', 'From', 'MailFrom1', 'input', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailTo', 'To', 'MailTo1', 'input', 'text', '', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'MailCc', 'CC', 'MailCc1', 'input', 'text', '', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 5)

--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CALL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CALL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCALLINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)


--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CALL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCALLINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCALLINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPCALLINTERACTIONSVIEW', 'Default', 'CALL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCALLINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCALLINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'VOICEMAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'VOICEMAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 4)

--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'VOICEMAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'VOICEMAIL',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPVOICEMAILINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 2)

--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 5)

INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'GENERIC',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPGENERICINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
--===============================================================
--===============================================================
-- Filtro de un AGENTE
INSERT INTO filterHeader VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'agent1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un ADMINISTRADOR
INSERT INTO filterHeader VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN', 'CampaignDyn', 'CampTemplate1', 'select', 'text', '', 1, 1, 4)
INSERT INTO filterDetail VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'ACTOR', 'ActorDyn', 'agent1', 'select', 'text', '', 1, 1, 5)

INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'administrator1', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un Dueo del CCV
INSERT INTO filterHeader VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'ccvOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
-- Filtro de un Dueo del Negocio
INSERT INTO filterHeader VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'CAMPAIGN',  1)

INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'Type', 'CHAT', 'select', 'text', '', 0, 0, 1)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'StartDate', 'Start Date', '2008-01-01', 'date', '', 'yyyy-MM-dd', 0, 0, 2)
INSERT INTO filterDetail VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'EndDate', 'End Date', '2008-12-31', 'date', '', 'yyyy-MM-dd', 0, 0, 3)

INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'CHAT')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'FAX')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'MAIL')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'TAPI')
INSERT INTO filterCombo VALUES('mediaplayer', 'businessOwner2', 'MSPCAMPAIGNINTERACTIONSVIEW', 'Default', 'Type', 'VOICEMAIL')


--===============================================================
--===============================================================
--===============================================================

