local select = select
local assert = assert

module((...))

local __module_location = select(2, ...)
assert(__module_location, "should be running under inconcertWebHandler")

function Widget(data)
	local widget = {
		GetStylesheets = function()
			return data.styles
		end,
		GetScripts = function()
			return data.scripts
		end
	}
	return widget
end

BasicForm = Widget{
	styles = {
		"/inconcert/shared/forms/styles/inconcertForm.css",
		"/inconcert/shared/forms/styles/inconcertTooltip.css",
		"/inconcert/shared/styles/inconcertImages.css"
	},
	scripts = {
		"/inconcert/lib/json/json2.js",
		"/inconcert/lib/jquery/jquery-1.2.6.js",
		"/inconcert/shared/forms/scripts/form.js",
		"/inconcert/lib/jquery-validate/jquery.validate.js",
		"/inconcert/lib/jquery-validate/additional-methods.js",
		"/inconcert/lib/jquery-tooltip/lib/jquery.dimensions.js",
		"/inconcert/lib/jquery-tooltip/jquery.tooltip.js",
		"/inconcert/shared/forms/scripts/validation.js",
		"/inconcert/shared/scripts/inconcert.jquery.offset.js",
	}
}

--function GetSchedulerHeaders()
Scheduler = Widget{
	styles = {
		"/inconcert/shared/forms/styles/inconcertSchedule.css"
	},
	scripts = {
		"/inconcert/shared/forms/scripts/scheduler.js"
	}
}

--function GetPopupHeaders()
Popup = Widget{
	styles = {
		"/inconcert/shared/forms/styles/inconcertPopup.css",
	},
	scripts = {
		"/inconcert/lib/jqmodal/jqmodal.js",
		"/inconcert/shared/forms/scripts/modalpopups.js",
	}
}

-- DHTMLX Tree
--function GetTreeHeaders()
Tree = Widget{
	styles = {
		"/inconcert/lib/dhtmlx/tree/dhtmlxtree.css",
	},
	scripts = {
		"/inconcert/lib/dhtmlx/tree/dhtmlxcommon.js",
		"/inconcert/lib/dhtmlx/tree/dhtmlxtree.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_dragin.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_ed.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_er.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_json.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_kn.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_lf.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_li.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_rl.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_sb.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_srnd.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_start.js",
		"/inconcert/lib/dhtmlx/tree/ext/dhtmlxtree_xw.js",
	}
}

-- DHTMLX Grid
--function GetGridHeaders()
Grid = Widget{
	styles = {
		"/inconcert/lib/dhtmlx/grid/dhtmlxgrid.css"
	},
	scripts = {
		"/inconcert/lib/dhtmlx/grid/dhtmlxcommon.js",
		"/inconcert/lib/dhtmlx/grid/dhtmlxgrid.js",
		"/inconcert/lib/dhtmlx/grid/dhtmlxgridcell.js",
		"/inconcert/lib/dhtmlx/grid/dhtmlxtreegrid.js",
		"/inconcert/lib/dhtmlx/grid/ext/dhtmlxgrid_drag.js",
		"/inconcert/lib/dhtmlx/grid/ext/dhtmlxgrid_filter.js",
	}
}

-- DHTMLX Paginated Grid
PaginatedGrid = Widget{
	styles = {
		"/inconcert/lib/dhtmlx/grid/ext/dhtmlxgrid_pgn_bricks.css",
	},
	scripts = {
		"/inconcert/lib/dhtmlx/grid/ext/dhtmlxgrid_pgn.js",
	}
}


--function GetHistoryHeaders()
History = Widget{
	styles = {
		"/inconcert/shared/forms/styles/inconcertHistory.css"
	},
	scripts = {
		"/inconcert/shared/forms/scripts/history.js",
	}
}

--function GetComboHeaders()
Combo = Widget{
	styles = {
		"/inconcert/lib/dhtmlx/combo/dhtmlxcombo.css",
	},
	scripts = {
		"/inconcert/lib/dhtmlx/combo/dhtmlxcommon.js",
		"/inconcert/lib/dhtmlx/combo/dhtmlxcombo.js",
		"/inconcert/lib/dhtmlx/combo/ext/dhtmlxcombo_extra.js",
		"/inconcert/lib/dhtmlx/combo/ext/dhtmlxcombo_whp.js",
	}
}

--function GetCalendarHeaders()
Calendar = Widget{
	styles = {
		"/inconcert/lib/dhtmlx/calendar/dhtmlxcalendar.css",
	},
	scripts = {
		"/inconcert/lib/dhtmlx/calendar/dhtmlxcommon.js",
		"/inconcert/lib/dhtmlx/calendar/dhtmlxcalendar.js",
	}
}

--function GetAccordionHeaders()
Accordion = Widget{
	styles = {
	},
	scripts = {
		"/inconcert/lib/jquery-accordion/jquery.accordion.js",
	}
}

--function GetVaultHeaders()
Vault = Widget{
	styles = {
		"/inconcert/lib/dhtmlx/vault/dhtmlXVault.css",
	},
	scripts = {
		"/inconcert/lib/dhtmlx/vault/dhtmlXVault.js",
	}
}