/*global jQuery FormReady

entityId
entityName
m_canSave
onRequestCompleted
*/

var form = {
	
	/*
	
	*/
	disabledLabel: function(labeldId, disabled, required) {
		jQuery('#' + labeldId).attr('disabled', disabled)
			.removeClass('formGrouplabel formGrouplabelReq formGrouplabel-ds')
			.addClass(!disabled ? (!required ? 'formGrouplabel' : 'formGrouplabel formGrouplabelReq') : 'formGrouplabel formGrouplabel-ds');
	},
	/*Funcion generica utilizada en todos los form para dejar el textbox readonly y aplicar las clases correspondientes, ya sea para texbox comunes o extended.
		paremtros:
			textboxId: es el id de unico del textbox en el html
			readonly: (true o false) Dependiendo si se quiere habilitar o no el texbox.
			extend: (true o false) Si viene en true es para los texbox de tipo extended. Por defecto no es extended.
	*/
	readonlyTextbox: function(textboxId, readonly, extended) {
		var enabledClass = 'formGroupField';
		var disabledClass = 'formGroupField formGroupField-ro';
		if (extended === true) {
			enabledClass = 'formGroupFieldExt';
			disabledClass = 'formGroupFieldExt formGroupFieldExt-ro';
		}
		jQuery('#' + textboxId).attr('disabled', readonly)
			.removeClass(disabledClass)
			.addClass(!readonly ? enabledClass : disabledClass);
	},
	/*Funcion generica utilizada en todos los form para dejar el combo dhtmlx en readonly y aplicar las clases correspondientes
		paremtros:
			comboid: es el id de unico del textbox en el html
			readonly: (true o false) Dependiendo si se quiere habilitar o no el texbox.
			extend: (true o false) Si viene en true es para los combo de tipo extended. Por defecto no es extended.
	*/
	readonlyCombo: function(comboId, readonly, extended) {
		var enabledClass = 'dhx_combo_box formGroupSelect';
		var disabledClass = 'dhx_combo_box formGroupSelect formGroupSelect-ro';
		if (extended === true) {
			enabledClass = 'dhx_combo_box formGroupSelectExt';
			disabledClass = 'dhx_combo_box formGroupSelectExt formGroupSelect-ro';
		}
		jQuery('#' + comboId).removeClass(disabledClass)
			.addClass(!readonly ? enabledClass : disabledClass);
		// esto lo que hace es llamar al mtodo "disable" de dhtmlx para los combos.
		window[comboId].disable(readonly);
	},
	/*Funcion generica utilizada en todos los form para dejar el combo dhtmlx "suggested" en readonly y aplicar las clases correspondientes
		paremtros:
			comboid: es el id de unico del textbox en el html
			readonly: (true o false) Dependiendo si se quiere habilitar o no el texbox.
			extend: (true o false) Si viene en true es para los combo de tipo extended. Por defecto no es extended.
	*/
	readonlyComboSuggested: function(comboId, readonly, extended) {
		var enabledClass = 'dhx_combo_box formGroupSelect formGroupSelectSuggestedData';
		var disabledClass = 'dhx_combo_box formGroupSelect formGroupSelectSuggested formGroupSelect-ro';
		if (extended === true) {
			enabledClass = 'dhx_combo_box formGroupSelectExt formGroupSelectSuggestedData';
			disabledClass = 'dhx_combo_box formGroupSelectExt formGroupSelectSuggested formGroupSelect-ro';
		}
		jQuery('#' + comboId).removeClass('dhx_combo_box formGroupSelect formGroupSelectExt formGroupSelectSuggested formGroupSelectSuggestedData formGroupSelect-ro')
			.addClass(!readonly ? enabledClass : disabledClass);
		// esto lo que hace es llamar al mtodo "disable" de dhtmlx para los combos.
		window[comboId].disable(readonly);
	},
	/*-------------------------------------------------------------------------
	(function / timer)
		Funcion recursiva utilizada como timer cada 500ms.
		la misma ejecuta un timeout que vuelve a ejecutar la misma funcin hasta que no existan request pendientes!!
		En el caso de que queden request pendientes se visualiza un waiting informado que se contina reciviendo informacion.
		Cuando no quedan request, se oculta el mensaje de waiting y no se vuelve a ejecutar el timeout donde se llama a la funcin recursiva.
	*/
	requestTimer: function(forceTimer) {
		//console.log("1 - jQuery.active " + jQuery.active);
		if (forceTimer || jQuery.active > 0) {
			if (!forceTimer) {
				jQuery(".formWaitingMessage div").text('<%=_T("Please wait.. Retrieving information.")%>');
				jQuery(".formWaitingMessage").show();
			}
			window.setTimeout( function () {
				//console.log("2 - jQuery.active " + jQuery.active);
				form.requestTimer(false); //aqu se llama de forma recursiva hasta que no queden request ajax pendientes!!
			}, 500);
		}
		else {
			jQuery(".formWaitingMessage").hide();
			// esta funcin debe estar definida en le js del formulario (ej: frmuser.js, frmcampaign.js, etc)
			//	no es obligatorio que la misma se implemente!!!!!
			if (typeof(onRequestCompleted) !== "undefined") {
				onRequestCompleted();
			}
		}
	}
};

jQuery(document).ready(function() {
	jQuery(".formContainerTittle").text(entityName);
	jQuery(".pageTittle").text(entityId);

	form.requestTimer(true); //ejecuto timer de los request!!
	FormReady();
	if (m_canSave === false) {
		jQuery("#btnSave").hide();
		jQuery(".formContainerBottom").addClass("formContainerBottomOneButton").removeClass("formContainerBottom");
	}
	document.onkeydown = function (e) {
		var ev = e || event;
		return ev.keyCode !== 27;
	};

});