/*jslint evil:true */
/*global $ jQuery FormReady

entityId
entityName

dhtmlXGridObject
*/

(function() {
	var m_historyObject = null;
	var m_calledFromTheView = null;
	var m_listOfChildrenAdded = {};
	var m_uriBase = '';

	function GetOperationImage(operation) {
		switch(operation) {
			case "U":
				return "modificationUpdate.png";
			case "D":
				return "modificationUpdate.png";
			case "C":
				return "modificationUpdate.png";
		}
		return "blank.gif";
	}
	/* //////////////////////////////////
		Evento asociado a cuando se expande un nodo del tree.
		Aqu se realiza un request para obtener el detalle del elemento seleccionado.
	*/
	function OnOpendEnd(headerId, state) {
		// si colapso el nodo no hago request
		if (state === -1) {
			return;
		}
		if (m_historyObject === null) {
			return;
		}
		//Si el elemento ya se ha obtenido en un previo request, me voy porque la rama del tree ya esta cargada.
		if (m_listOfChildrenAdded[headerId] === true) {
			return;
		}
		//36 es largo del id del primer nodo (un guid)
		//	esto es para que solo haga el request cuando se expande el primer nodo, el que tienen el guid a busar en la tabla de detalle de history.
		if (headerId.length !== 36) {
			return;
		}
		jQuery(".formWaitingMessage").hide();
		jQuery(".formOkMessage").hide();
		jQuery(".formErrorMessage").hide();
		jQuery("#formWaitingHistoryTree").show();
		var tree = this;
		jQuery.ajax({
			url: m_uriBase + "historydetail/" + headerId,
			success: function(ajaxResponse) {
				var historyDetail = eval('(' + ajaxResponse + ')');
				if (historyDetail === null) {
					jQuery("#formWaitingHistoryTree").hide();
					return;
				}
				var header = null;
				var userKey;
				//obtengo el objeto historyheader.
				for (var i = 0; i < m_historyObject.length; i++) {
					if (m_historyObject[i].Id === headerId) {
						header = m_historyObject[i];
						userKey = header.Id + header.UserId;
						break;
					}
				}
				if (header === null) {
					jQuery("#formWaitingHistoryTree").hide();
					return;
				}
				//funcion que trunca el largo de un campo si supera los N caracteres,
				//	y agrega un botn para abrir un popup que muestre la informacin completa
				var truncateValue = function(value) {
					// si el valor del campo supera los 55 caracteres, lo trunca en 50!!
					if (value && value.length > 55) {
					/*
						return value.substr(1, 50) + " ..." +
							' <img completeValue="' + value + '" class="gridButOpen" alt="alt" src="/inconcert/apps/administration/images/blank.gif" />';
					*/
					/*
						La lnea de cdigo que agrega el markup <IMG> para el botn tiene seteado el 
						evento "onclick" de esa forma porque no pude de ninguna forma agregarle el evento
						"click" mediante jquery!!!!!!!!!!!!!!!!!!!!!! 
						Ni con "bind", ni directamente "click". Creo que ha de ser porque dhtmlx hace
						alguna cosa rara con los eventos!!
						En algn momento habra que ver si se puede!! 
					*/
						return value.substr(1, 50) + " ..." +
							' <img completeValue="' + value + '" class="gridButOpen" alt="alt" src="/inconcert/apps/administration/images/blank.gif" onclick="jQuery(\'#sectionHistory\').viewCompleteFieldValue(this);" />';
					}
					return value;
				};
				// asigno al hash el header como ya cargado para que la siguiente vez no realice el request.
				m_listOfChildrenAdded[headerId] = true;
				//Cargo el tree del elemento seleccionado
				var entityKey, instanceKey, fieldKey;
				for (var j = 0; j < historyDetail.length; j++) {
					var entry = historyDetail[j];
					var type = entry.SubEntity;
					var id = entry.ElementId;
					var field = entry.ChangedField;
					entityKey = header.Id + header.UserId + type;
					instanceKey = header.Id + header.UserId + type + id;
					fieldKey = header.Id + header.UserId + type + id + field;
					if (!tree.doesRowExist(entityKey)) {
						tree.addRow(entityKey, type, null, userKey, "modificationEntity.png", 1);
					}
					if (!tree.doesRowExist(instanceKey)) {
						var operation = entry.Operation;
						tree.addRow(instanceKey, id, null, entityKey, GetOperationImage(operation), 1);
					}
					var dataRow = [field];
					if (m_calledFromTheView === true) {
						dataRow.push('');
						dataRow.push('');
						dataRow.push('');
					}
					dataRow.push(''); // este corresponde a la imagen
					dataRow.push(truncateValue(entry.PreviousValue));
					dataRow.push(truncateValue(entry.ActualValue));
					tree.addRow(fieldKey, dataRow, null, instanceKey, "modificationField.png", 1);
				}
				jQuery("#formWaitingHistoryTree").hide();
			},
			error: function() {
				jQuery("#formWaitingHistoryTree").hide();
				jQuery(".formWaitingMessage").hide();
				jQuery(".formOkMessage").hide();
				jQuery(".formErrorMessage div").text('<%=_T("Server error, in the request of historical detail.")%>');
				jQuery(".formErrorMessage").show();
			}
		});
	}

	jQuery.fn.viewCompleteFieldValue = function(button) {
		button = jQuery(button);
		// genero el div contenedor del popup si es que ya no existe!!
		if (jQuery("#historyPopup").length === 0) {
			jQuery("body").append('<div id="historyPopup" class="formPopUpContainer" style="display:none;"></div>');
		}
		//creo el markup del popup
		jQuery("#historyPopup").html(''.concat(
			'<div class="formPopUpTop"></div>',
			'<div class="formPopUpMiddle">',
				'<a class="hidePopUp" href="#"><img src="/inconcert/shared/forms/images/blank.gif"/>' + '<%=_T("Hide")%>' + '</a>',
				'<div class="formPopUpContentLongText" value="0" readonly="readonly" >',
					button.attr("completeValue"),
				'</div>',
			'</div>',
			'<div class="formPopUpBottomShort"></div>')
		);
		//evento close del popup
		jQuery(".hidePopUp").unbind("click").bind("click", function() {
			jQuery("#historyPopup").html('').jqmHide();
		});
		//valores del offset a calcular y asignar segn el padre!!
		var buttonOffset = button.offset();
		var popupOffset = {
			top: buttonOffset.top - 40,
			left: buttonOffset.left - (jQuery("#historyPopup").width() + 10)
		};
		// 1 - Asigno el offset con el plugin de jquery,
		// 2 - inicializo jqm
		// 3 - muestro el popup!!
		jQuery("#historyPopup").offset(popupOffset).jqm({overlay: 0}).jqmShow();
	};

	jQuery.fn.SetURIRequest = function(uri) {
		m_uriBase = uri;
	};
	jQuery.fn.modificationHistory = function(settings) {
		var m_container = this;
		var m_settings = jQuery.extend({
				header: '<%=_T("Date")%>' + ',' + '<%=_T("Operation")%>' + ',' + '<%=_T("Previous Value")%>' + ',' + '<%=_T("New Value")%>',
				widths: "280,60,163,163",
				align: "left,center,left,left",
				types: "tree,ro,ro,ro",
				sorting: "str,str,str,str",
				imgURL: "/inconcert/shared/forms/images/"
			}, 
		settings);

		return m_container.each(function() {
			var treeNode = jQuery(this);
			treeNode.append("<div id='grdModificationHistory' class='inconcertHistoryTree gridAccordion'></div>");
			treeNode.historyTree = new dhtmlXGridObject('grdModificationHistory');
			treeNode.historyTree.selMultiRows = true;
			treeNode.historyTree.imgURL = m_settings.imgURL;
			treeNode.historyTree.setHeader(m_settings.header);
			treeNode.historyTree.setInitWidths(m_settings.widths);
			treeNode.historyTree.setColAlign(m_settings.align);
			treeNode.historyTree.setColTypes(m_settings.types);
			treeNode.historyTree.setColSorting(m_settings.sorting);
			treeNode.historyTree.enableTreeCellEdit(false);
			treeNode.historyTree.attachEvent("onOpenEnd", OnOpendEnd);
			treeNode.historyTree.attachEvent("onRowCreated", function(rowId, rowObject, relatedXML) {
				//jQuery(".CLASS11").unbind("click").bind("click", function(event) {
				//	alert(event);
				//});
			});
			treeNode.historyTree.init();
		});
	};
	/*/////////////////////////////////////////////////////////
		Cargo el tree con los headers del historico
	*/
	jQuery.fn.loadHistoryInformation =  function (historyObject, calledFromTheView) {
		m_calledFromTheView = calledFromTheView;
		m_historyObject = historyObject;
		var m_container = this;
		return m_container.each(function(){
			//no le cuelga un tree a esto!
			if (!jQuery(this).find('.inconcertHistoryTree').length || !historyObject) {
				return;
			}
			var operationSuffixes = {'C': 'Add', 'U': 'Upd', 'D': 'Rmv'};
			var tree = jQuery(this).find('.inconcertHistoryTree')[0].grid;
			tree.clearAll(false);
			var headerKey, userKey, entityKey, instanceKey, fieldKey;
			for (var i = 0; i < historyObject.length; i++) {
				var header = historyObject[i];
				headerKey = header.Id;
				userKey = header.Id + header.UserId;
				var dataRow = [header.TimeZoneModificationDate];
				if (calledFromTheView === true) {
					dataRow.push(header.UserId);
					dataRow.push(header.DisplayElementType !== undefined ? header.DisplayElementType : header.ElementType);
					dataRow.push(header.ElementId);
				}
				var imageClass = 'gridIcoHistory' + operationSuffixes[header.Operation.toUpperCase()];
				var htmlImage = '<img class="' + imageClass + '" src="' + '/inconcert/shared/forms/images/blank.gif\" />';
				dataRow.push(htmlImage);
				tree.addRow(headerKey, dataRow, i, null, "modificationDate.png");
				tree.addRow(userKey, header.UserId, null, headerKey, "modificationUser.png", 1);
			}
		});
	};
 })(jQuery);