/*global $ jQuery

*/

(function() {

	var BUTTON_SET = { BS_OK:0, BS_YESNO:1, BS_OKCANCEL:2, BS_ABORTRETRY:3 };

	/**
	Private: Creates the buttons as childs of the given node.
	*/
	function CreateButtons(node, buttonset, customButtons) {
		switch (buttonset) {

			case BUTTON_SET.BS_OK:
				node.append('<input id="popupOk" type="submit" class="formButtonAcept" value="<%=_T("Ok")%>" key="Ok" />');
				break;

			case BUTTON_SET.BS_YESNO:
				node.append('<input id="popupYes" type="submit" class="formButtonAcept" value="<%=_T("Yes")%>" key="Yes" />');
				node.append('<input id="popupNo" type="submit" class="formButtonCancel" value="<%=_T("No")%>" key="No" />');
				break;

			case BUTTON_SET.BS_OKCANCEL:
				node.append('<input id="popupOkCancel-Ok" type="submit" class="formButtonAcept" value="<%=_T("Ok")%>" key="Ok" />');
				node.append('<input id="popupOkCancel-Cancel" type="submit" class="formButtonCancel" value="<%=_T("Cancel")%>" key="Cancel" />');
				break;

			case BUTTON_SET.BS_ABORTRETRY:
				node.append('<input id="popupRetry" type="submit" class="formButtonAcept" value="<%=_T("Retry")%>" key="Retry" />');
				node.append('<input id="popupAbort" type="submit" class="formButtonCancel" value="<%=_T("Abort")%>" key="Abort" />');
				break;
		}
		
		if(typeof(customButtons) !== "undefined") {
			for(var i = 0; i < customButtons.length; i++) {
				var button = customButtons[i];
				var newButton = $('<input type="submit" class="' + (button.className === undefined ? 'formButtonAcept' : button.className) + '" ' +
					'value="' + (button.label === undefined ? '' : button.label) + '" />');
				if(typeof(button.onClick) === "function") {
					newButton.click(button.onClick);
				}
				node.append(newButton);
			}
		}
	}

	/**
	Private: Creates the popup itself
	*/
	function CreatePopupContent(node, buttonset, customButtons) {
		//creo botones
		node.append('<div class="inconcertPopupWindow"></div');
		node.find('.inconcertPopupWindow').append('<div class="inconcertPopupTitle clearfix">');
		node.append('<div class="inconcertPopupContent"></div');
		node.find('.inconcertPopupContent').append('<p class="inconcertPopupMessage">');
		node.append('<div class="inconcertPopupButtons"></div');
		CreateButtons(node.find('.inconcertPopupButtons'), buttonset, customButtons);
	}


	/**
	Public: Creates a MessageBox with the given title, message, set of buttons, an optional callback and an optional array of custom buttons.
	Each button is an object with the following properties:
		- className: the css class it will have
		- label: the caption
		- onClick: a function callback
	*/
	function MessageBox(title, msg, buttonset, callback, customButtons) {

		if ($('#inconcertPopup').length) {
			$('#inconcertPopup').html('');
			CreatePopupContent($('#inconcertPopup'), buttonset, customButtons);
		}
		else {
			$('body').append('<div class="inconcertPopup" id="inconcertPopup"></div>');
			CreatePopupContent($('#inconcertPopup'), buttonset, customButtons);
			$('#inconcertPopup').jqm({overlay: 75, modal: true, trigger: false, overlayClass:"inconcertPopupOverlay"});
		}
		var message = (msg === undefined ? '' : msg);
		var messageTitle = (title === undefined ? '' : title);

		$('#inconcertPopup')
			.jqmShow()
			.find('p.inconcertPopupMessage')
				.html(message)
			.end()
			.find('.inconcertPopupTitle')
				.html(messageTitle)
			.end()
			.find(':submit:visible')
				.click(function(){
					if (callback) {
						var key = jQuery("#" + this.id).attr("key");
						callback(key);
					}
					$('#inconcertPopup').jqmHide();
				});
	}
	jQuery.inconcertPopup = {};
	jQuery.inconcertPopup.Show = MessageBox;
	jQuery.inconcertPopup.ButtonSets = BUTTON_SET;

 })(jQuery);