/*jslint forin:true nomen:false eqeqeq:false */
/*global $ jQuery


GetConfiguredScheduler RangeListAsString AddSpecialRow RefreshRangeTable AddRange HourIsEqual HourIsGreater

dhtmlxCalendarObject
dhtmlXGridObject
dhtmlXComboFromSelect
*/

var dateSpecialIncExc;
var dateExceptionalExclusion;
var dateSchedulerStart;
var dateSchedulerEnd;

// Array.insert( index, value ) - Insert value at index, without overwriting existing keys
Array.prototype.insert = function( i, v ) {
	if( i>=0 ) {
		var a = this.slice(), b = a.splice( i , a.length - i);
		a[i] = v;
		return a.concat( b );
	}
};

(function() {
	//estas variables quedan ocultas adentro la funcion
	var m_settings;
	var m_specialDays;
	var cmbDayRange;
	//seccion special days
	var cmbSpecialAction;
	var grdScheduleSpecialDays;
	var m_scheduledRanges = {
		Sunday: 	{day: 1, ranges : []},
		Monday: 	{day: 2, ranges : []},
		Tuesday: 	{day: 3, ranges : []},
		Wednesday: 	{day: 4, ranges : []},
		Thursday: 	{day: 5, ranges : []},
		Friday: 	{day: 6, ranges : []},
		Saturday: 	{day: 7, ranges : []}
	};

	function DisplayErrorMessage(message) {
		if (jQuery.inconcertPopup) {
			var buttons = jQuery.inconcertPopup.ButtonSets.BS_OK;
			jQuery.inconcertPopup.Show('<%=_T("Error")%>', message, buttons, null);
		}
		else {
			alert(message);
		}
	}

	function RangeAsString(range) {
		return range.from.Hours + ':' + range.from.Minutes + "/" + range.to.Hours + ':' + range.to.Minutes;
	}

	function ValidateRange(from, to) {
		return (HourIsGreater(to, from) || (to.Hours == "00" && to.Minutes == "00"));
	}

	function OnDeleteRange() {
		var day = $(this).attr('day');
		var dayIndex =  m_scheduledRanges[day].day - 1;
		m_scheduledRanges[day].ranges = [];
		$("#tblScheduleInterval td.formScheduleTableContent:eq(" + dayIndex  + ")").html('');
		$("#tblScheduleInterval tr:eq(" + dayIndex  + ")").children(":first").attr("class", "formScheduleTableLabel-ds" + (dayIndex === 6 ? " lastRow" : ""));
		$("#tblScheduleInterval tr:eq(" + dayIndex  + ") img").attr("class", "formGridButDelete-ds");
	}

	//si cambia la lista de elementos checkados que existen en el combo de dias (presumiblemente me ayude  a cambiar algun texto helper)
	function OnRangeSelectionChanged() {
		var checkedList = cmbDayRange.getChecked();
	}

	function OnRangeChecked(value) {
		var index = cmbDayRange.getSelectedIndex();
		if (index >= 0){
			cmbDayRange.setChecked(index, value);
			OnRangeSelectionChanged();
		}
	}

	//un scheduler no es valido si no tiene al menos un rango horario de laburo no esiste!
	function ValidateScheduler() {
		var scheduler = GetConfiguredScheduler();
		return (scheduler.ScheduleDays.length > 0 ||
				scheduler.ScheduleSpecialDays.length > 0 ||
				scheduler.ScheduleSpecialDayAllYearss.length >0);
	}

	function GetDayName(index) {
		for (var day in m_scheduledRanges) {
			if (m_scheduledRanges[day].day === index) {
				return day;
			}
		}
		return '';
	}

	function IsNullTime(time) {
		return (time.Hours == "00" && time.Minutes == "00");
	}

	function IsNullRange(range) {
		return (IsNullTime(range.from) && IsNullTime(range.to));
	}

	function IsSameRange(range1, range2) {
		return (HourIsEqual(range1.to, range2.to) && HourIsEqual(range1.from, range2.from));
	}

	function CreateRangeFromDateTime(StartTime, EndTime) {
		var rangeFrom = {};
		rangeFrom.Hours = StartTime.match(/\d\d\d\d-\d\d-\d\d (\d\d):\d\d:\d\d/)[1];
		rangeFrom.Minutes = StartTime.match(/\d\d\d\d-\d\d-\d\d \d\d:(\d\d):\d\d/)[1];
		var rangeTo = {};
		rangeTo.Hours = EndTime.match(/\d\d\d\d-\d\d-\d\d (\d\d):\d\d:\d\d/)[1];
		rangeTo.Minutes = EndTime.match(/\d\d\d\d-\d\d-\d\d \d\d:(\d\d):\d\d/)[1];
		return {from:rangeFrom, to:rangeTo};
	}

	function NormalizeToTen(value) {
		if (value < 10) {
			return "0" + value;
		}
		else {
			return value;
		}
	}

	function LoadScheduler(scheduler) {
		//aca va derecho a pantalla porque no se guarda estructura interna
		for (var i = 0; i < scheduler.ScheduleDays.length; i++) {
			var dayName = GetDayName(scheduler.ScheduleDays[i].DayOfWeek);
			if (dayName.length) {
				var range = CreateRangeFromDateTime(scheduler.ScheduleDays[i].StartTime,scheduler.ScheduleDays[i].EndTime);
				AddRange(dayName, range);
			}
		}
		RefreshRangeTable();
		//primero los dias especiales con dia y/o rango
		for (var i = 0; i < scheduler.ScheduleSpecialDays.length; i++) {
			var specialDay = scheduler.ScheduleSpecialDays[i];
			var date = specialDay.Year + "-" + NormalizeToTen(specialDay.Month) + "-" + NormalizeToTen(specialDay.Day);
			m_specialDays[date] = {};
			m_specialDays[date].reason = specialDay.Description;
			m_specialDays[date].ranges = [];
			if (!specialDay.ScheduleSpecialDayRanges || specialDay.ScheduleSpecialDayRanges.length === 0) {
				//es un override only this year
				m_specialDays[date].action = "Exclusion";
				m_specialDays[date].type = "Year";
			}
			else {
				m_specialDays[date].action = specialDay.Overrides === 1 ? "Override" : "AddRange";
				for (var j = 0; j < specialDay.ScheduleSpecialDayRanges.length; j++) {
					var objectRange = specialDay.ScheduleSpecialDayRanges[j];
					var newRange = CreateRangeFromDateTime(objectRange.StartTime, objectRange.EndTime);
					m_specialDays[date].ranges.push(newRange);
				}
			}
		}
		//luego las exclusiones para todos los anios
		for (var i = 0; i < scheduler.ScheduleSpecialDayAllYearss.length; i++) {
			var specialDay = scheduler.ScheduleSpecialDayAllYearss[i];
			//lamentablemente con el cambio de tablas perdi el anio para manejar una fecha aca, siempre va a volver 1970 a los allyears
			var date = NormalizeToTen(specialDay.Month) + "-" + NormalizeToTen(specialDay.Day);
			m_specialDays[date] = {};
			m_specialDays[date].reason = specialDay.Description;
			m_specialDays[date].action = "Exclusion";
			m_specialDays[date].type = "Always";
		}

		//la mando a pantalla
		var when;
		for (var date in m_specialDays) {
			if(m_specialDays.hasOwnProperty(date)) {
				if (m_specialDays[date].action === "Exclusion") {
					var selected = $("input[@name=ExceptionType][@value=" + m_specialDays[date].type + "]");
					when = selected.next().html();
				}
				else {
					when = RangeListAsString(m_specialDays[date].ranges);
				}
				var value = [date, m_specialDays[date].reason, when];
				AddSpecialRow(m_specialDays[date].action, date, value);
			}
		}
	}

	function HourAsString(number) {
		if (number < 10) {
			return String("0" + number);
		}
		else {
			return String(number);
		}
	}

	function RemoveExclusion() {
		var key = $(this).attr('key');
		m_specialDays[key] = null;
		grdScheduleSpecialDays.deleteRow(key);
	}

	function HourIsEqual(hour1, hour2) {
		return (hour1.Hours === hour2.Hours && hour1.Minutes === hour2.Minutes);
	}

	function HourIsGreater(hour1, hour2) {
		return (hour1.Hours > hour2.Hours || (hour1.Hours === hour2.Hours && hour1.Minutes > hour2.Minutes));
	}

	function RangeOverlapBehind(range1, range2) {
		return ( (HourIsGreater(range1.to, range2.from) || IsNullTime(range1.to)) &&
			(HourIsGreater(range2.to, range1.from) || IsNullTime(range2.to)));
	}

	function RangesOverlap(range1, range2) {
		if (RangeOverlapBehind(range1, range2)) {
			return true;
		}
		if (RangeOverlapBehind(range2, range1)) {
			return true;
		}
		return false;
	}

	function RefreshRangeTable() {
		//seteo a todo el mundo estilo disabled
		$("#tblScheduleInterval tr").children(":first").attr("class", "formScheduleTableLabel-ds");
		$("#tblScheduleInterval tr img").attr("class","formGridButDelete-ds");

		//limpio todos los rangos y agrego dia x dia
		$("#tblScheduleInterval td.formScheduleTableContent").html('');

		for (var day in m_scheduledRanges) {
			var dayIndex =  m_scheduledRanges[day].day - 1;
			var strRanges = RangeListAsString(m_scheduledRanges[day].ranges);
			$("#tblScheduleInterval td.formScheduleTableContent:eq(" + dayIndex + ")").html(strRanges);
			if (strRanges !== '') {
				$("#tblScheduleInterval tr:eq(" + dayIndex  + ")").children(":first").attr("class","formScheduleTableLabel" + (dayIndex === 6 ? " lastRow" : ""));
				$("#tblScheduleInterval tr:eq(" + dayIndex  + ") img").attr("class","formGridButDelete");
			}
		}
	}

	function AddRange(day, newRange) {
		var index = m_scheduledRanges[day].ranges.length;
		//voy hasta el primer rango cuya hora de fin sea antes de mi hora de inicio
		//en esa posicion el siguiente que habia, tiene que arrancar despues de mi hora de fin
		for (var i = m_scheduledRanges[day].ranges.length - 1; i >= 0 ; i--) {
			var range = m_scheduledRanges[day].ranges[i];
			if (RangesOverlap(range, newRange) || IsSameRange(range, newRange) || IsNullRange(range)) {
				DisplayErrorMessage(jQuery.format('<%=_T("Invalid range, it overlaps with range {0} of day {1}")%>', RangeAsString(range), day));
				return false;
			}
			//los rangos que terminan en 00 son siempre los mayores
			if ((HourIsGreater(range.from, newRange.to) && !IsNullTime(newRange.to)) || HourIsEqual(range.from, newRange.to)) {
				index = i;
			}
			else {
				//no hay mas rangos que arranquen despues que yo termino...
				break;
			}
		}
		m_scheduledRanges[day].ranges.splice(index, 0, newRange);
		return true;
	}

	//limpia alguno de los pares de rangos del formulario
	function CleanRangeCombo(controlName) {
		$("#cmbHour" + controlName + "From").val('00');
		$("#cmbMins" + controlName + "From").val('00');
		$("#cmbHour" + controlName + "To").val('00');
		$("#cmbMins" + controlName + "To").val('00');
	}

	//limpia los campos de la configuracoin global una vez que se agregan  exitosamente
	function CleanGlobalConfigurationFields() {
		/*for (var i = 0; i < 7; i++) {
			cmbDayRange.setChecked(i, false);
		}*/
		CleanRangeCombo("Range");
	}

	function DisabledButtonAddSpecialDay(buttonId, disabled) {
		var removeClass = "formButtonAdd ";
		var addClass = "formButtonAdd-ds";
		if (!disabled) {
			var aux = removeClass;
			removeClass = addClass;
			addClass = aux;
		}
		$("#" + buttonId).attr("disabled", disabled).removeClass(removeClass).addClass(addClass);
	}
	
	//limpia los campos de special definition
	function CleanSpecialConfigurationFields() {
		$("#dateSpecialIncExc").val('');
		$("#txtIncExcReason").val('');
		CleanRangeCombo("Special");
		CleanRangeCombo("Special2");
		$("#dateExceptionalExclusion").val('');
		$("#txtExclusionReason").val('');
		$("#ExceptionType").val('');
		if (dateSpecialIncExc && dateSpecialIncExc.isVisible()) {
			dateSpecialIncExc.hide();
		}
		if (dateExceptionalExclusion && dateExceptionalExclusion.isVisible()) {
			dateExceptionalExclusion.hide();
		}
		DisabledButtonAddSpecialDay("btnAddExclusion", true);
		DisabledButtonAddSpecialDay("btnAddSpecialRange", true);
	}

	function CreateRange(controlName) {
		var rangeFrom = {};
		rangeFrom.Hours = $("#cmbHour" + controlName + "From").val();
		rangeFrom.Minutes = $("#cmbMins" + controlName + "From").val();
		var rangeTo = {};
		rangeTo.Hours = $("#cmbHour" + controlName + "To").val();
		rangeTo.Minutes = $("#cmbMins" + controlName + "To").val();
		return {from:rangeFrom, to:rangeTo};
	}

	function AddScheduledRange() {
		var dayList = cmbDayRange.getChecked();
		var range = CreateRange("Range");
		if (!ValidateRange(range.from, range.to) && !IsNullRange(range)) { //el rango de 0 a 0 es un rango valido
			//mensaje que el rango no es valido
			DisplayErrorMessage(jQuery.format('<%=_T("Invalid range {0}, end time must be greater than start time")%>', RangeAsString(range)));
			RefreshRangeTable();
			return;
		}
		for (var i = 0; i < dayList.length; i++) {
			var day = dayList[i];
			if (!AddRange(day, range)) {
				break;
			}
		}
		RefreshRangeTable();
		CleanGlobalConfigurationFields();
	}

	function GetActionImage(action) {
		var image = "/inconcert/shared/forms/images/";
		switch (action) {
			case 'AddRange':
				image += "ico_include.gif";
				break;
			case 'Override':
				image += "ico_exception.gif";
				break;
			case 'Exclusion':
				image += "ico_exclude.gif";
				break;
			case 'Delete':
				image = "/inconcert/shared/styles/images/grid_butdelete.png";
				break;
		}
		return image;
	}

	function AddSpecialRow(action, key, value) {
		if (grdScheduleSpecialDays.doesRowExist(key)) {
			grdScheduleSpecialDays.deleteRow(key);
		}
		value[0] = "<image action='" + action + "' src='" + GetActionImage(action) + "'> " + value[0];
		value = value.insert(value.length, "<image class='formGridButDelete scheduleButRemove' key='" + key + "' src='/inconcert/apps/administration/images/blank.gif' > ");
		grdScheduleSpecialDays.addRow(key, value);
		$("img.scheduleButRemove").click(RemoveExclusion);
	}

	function GetConfiguredScheduler() {
		var scheduler = {};
		scheduler.ScheduleDays = [];
		scheduler.ScheduleSpecialDays = [];
		scheduler.ScheduleSpecialDayAllYearss = [];

		//dias normales
		for (var day in m_scheduledRanges) {
			for (var i = 0; i < m_scheduledRanges[day].ranges.length; i++) {
				var range = m_scheduledRanges[day].ranges[i];
				var schedulerDay = {};
				schedulerDay.StartTime = range.from.Hours + ':' + range.from.Minutes + ":00";
				schedulerDay.EndTime = range.to.Hours + ':' + range.to.Minutes + ":00";
				schedulerDay.DayOfWeek = m_scheduledRanges[day].day;
				schedulerDay.Enabled = 1;
				scheduler.ScheduleDays.push(schedulerDay);
			}
		}
		//dias especiales
		for (var special in m_specialDays) {
			if (m_specialDays[special] === undefined || m_specialDays[special] === null) {
				continue;
			}
			var specialDay = {};
			var splittedDate = special.split(/-/g);
			if (splittedDate.length === 3) {
				specialDay.Day = splittedDate[2];
				specialDay.Month = splittedDate[1];
				specialDay.Year = splittedDate[0];
			}
			else {
				specialDay.Day = splittedDate[1];
				specialDay.Month = splittedDate[0];
			}
			specialDay.Description = m_specialDays[special].reason;
			var action = m_specialDays[special].action;
			if (action === "Exclusion" && m_specialDays[special].type === "Always") {
				//este es el unico caso donde relleno un ALLYEARS
				specialDay.Overrides = 1;
				//esto se hace para evitar que el delta historico pise cambios todas las veces
				specialDay.Year = "1970";
				scheduler.ScheduleSpecialDayAllYearss.push(specialDay);
			}
			else {
				//salgo a juntar rangos (que pueden ser de override day o de add day)
				specialDay.ScheduleSpecialDayRanges = [];
				specialDay.Overrides = action === "AddRange" ? 0 : 1;
				if (action !== "Exclusion") {
					for (var j = 0; j < m_specialDays[special].ranges.length; j++) {
						if (!m_specialDays[special].ranges[j]) {
							continue;
						}
						var dayRange = {};
						dayRange.StartTime = m_specialDays[special].ranges[j].from.Hours + ":" + m_specialDays[special].ranges[j].from.Minutes + ":00";
						dayRange.EndTime = m_specialDays[special].ranges[j].to.Hours + ":" + m_specialDays[special].ranges[j].to.Minutes + ":00";
						dayRange.Day = splittedDate[2];
						dayRange.Month = splittedDate[1];
						dayRange.Year = splittedDate[0];

						specialDay.ScheduleSpecialDayRanges.push(dayRange);
					}
				}
				scheduler.ScheduleSpecialDays.push(specialDay);
			}
		}
		return scheduler;
	}

	//valido si se puede insertar el rango en la lista existente
	function ValidateRangeOverlapping(rangelist, newrange) {
		for (var i = rangelist.length - 1; i >= 0 ; i--) {
			var range = rangelist[i];
			if (range) {
				if (RangesOverlap(range, newrange)) {
					return false;
				}
			}
		}
		return true;
	}

	//arma el string de rangos a partir de un array
	function RangeListAsString(rangelist) {
		var strRanges = '';
		for (var i = 0; i < rangelist.length; i++) {
			var range = rangelist[i];
			if (range) {
				strRanges += RangeAsString(range) + " ";
			}
		}
		return strRanges;
	}

	function AddSpecialRange() {
		var reason;
		var range1, range2;
		range2 = null;
		var action = cmbSpecialAction.getActualValue();
		var date = dateSpecialIncExc.getFormatedDate("%Y-%m-%d");
		if (date.length) {
			reason = $("#txtIncExcReason").val();
			range1 = CreateRange("Special");
			if (action === "Override") {
				range2 = CreateRange("Special2");
				if (IsNullRange(range2)) {
					//si el 2do rango es nulo hago de cuenta que no especifico nada ahi
					range2 = null;
				}
			}
			//rango 2 no tiene porque validar, sino valida no lo tiro para adentro
			if (ValidateRange(range1.from, range1.to)) {
				if (range2 && ValidateRange(range2.from, range2.to)) {
					if (RangesOverlap(range1, range2)) {
						DisplayErrorMessage('<%=_T("Cannot add overlaping ranges")%>');
						return;
					}
				}
				if ((m_specialDays[date] !== undefined && m_specialDays[date] !== null) && 
						m_specialDays[date].action !== null && m_specialDays[date].action === "AddRange" && action === "AddRange") {
					//si estaba ya agregando rangos para el dia solamente hago un push (deberia validar que no se solapa)
					m_specialDays[date].reason = reason;
					if (!ValidateRangeOverlapping(m_specialDays[date].ranges, range1)) {
						DisplayErrorMessage(jQuery.format('<%=_T("Invalid range {0}, it overlaps with existing definition")%>', RangeAsString(range1)));
						return;
					}
					m_specialDays[date].ranges.push(range1);
				}
				else {
					m_specialDays[date] = {};
					m_specialDays[date].reason = reason;
					m_specialDays[date].action = action;
					m_specialDays[date].ranges = [];
					m_specialDays[date].ranges.push(range1);
					m_specialDays[date].ranges.push(range2);
				}
				var value = [date , reason , RangeListAsString(m_specialDays[date].ranges)];
				AddSpecialRow(action, date, value);
				CleanSpecialConfigurationFields();
			}
			else {
				DisplayErrorMessage('<%=_T("Cannot add an invalid range")%>');
			}
		}
	}

	function AddExclusion() {
		var reason, value, type, label;
		var formattDate = ((cmbSpecialAction.getActualValue().toLowerCase() === "exclusion" && 
							$("input[@name=ExceptionType][@checked]").attr('value').toLowerCase() === "always") ? "%m-%d" : "%Y-%m-%d");
		var date = dateExceptionalExclusion.getFormatedDate(formattDate);
		if (date.length) {
			reason = $("#txtExclusionReason").val();
			value = $("#ExceptionType").val();
			var selected = $("input[@name=ExceptionType][@checked]");
			type = selected.attr('value');
			var text = selected.next().html();
			value = [date, reason , text];
			m_specialDays[date] = {};
			m_specialDays[date].reason = reason;
			m_specialDays[date].action = "Exclusion";
			m_specialDays[date].ranges = [];
			m_specialDays[date].ranges.push({from:{Hours:"00", Minutes:"00"}, to:{Hours:"00", Minutes:"00"}});
			m_specialDays[date].type = type;
			AddSpecialRow("Exclusion", date, value);
			CleanSpecialConfigurationFields();
		}
	}

	function OnSpecialActionChanged() {
		switch (cmbSpecialAction.getActualValue()) {
			case 'AddRange':
				$("#sectionInclusion").show();
				$("#sectionExclusion").hide();
				$(".scheduleHourContainerC").hide();
				$("#lblExceptionAction").text('<%=_T("Add Range")%>');
				$("#lblExceptionActionHelp").text('<%=_T("Select date, hour range and a reason for adding range")%>');
				break;
			case 'Override':
				$("#sectionInclusion").show();
				$("#sectionExclusion").hide();
				$(".scheduleHourContainerC").show();
				$("#lblExceptionAction").text('<%=_T("Day Exception")%>');
				$("#lblExceptionActionHelp").text('<%=_T("Select date, hour range and a reason for overriding")%>');
				break;
			case 'Exclusion':
				$("#sectionInclusion").hide();
				$("#sectionExclusion").show();
				break;
		}
		CleanSpecialConfigurationFields();
	}

	function LoadRangeCombos() {
		for (var i = 0; i < 24; i++) {
			jQuery("#cmbHourRangeFrom").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbHourRangeTo").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbHourSpecialFrom").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbHourSpecialTo").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbHourSpecial2From").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbHourSpecial2To").append("<option>" + HourAsString(i) + "</option>");
		}
		for (var i = 0; i <= 50; i += 10) {
			jQuery("#cmbMinsRangeFrom").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbMinsRangeTo").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbMinsSpecialFrom").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbMinsSpecialTo").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbMinsSpecial2From").append("<option>" + HourAsString(i) + "</option>");
			jQuery("#cmbMinsSpecial2To").append("<option>" + HourAsString(i) + "</option>");
		}
	}

	jQuery.getConfiguredScheduler = GetConfiguredScheduler;
	jQuery.validateScheduler = ValidateScheduler;
	jQuery.loadScheduler = LoadScheduler;

	jQuery.fn.scheduler = function(settings) {
		var m_container = this;		//The jquery objects that contain our collapsable items.
		m_settings = jQuery.extend({
			showdates: true
		}, settings);

		//Loop through the jquery objects (de forma usual solamente va a haber un nodo aca a contener al scheduler, pero ta, capaz alguien quiere crear 7 schedulers en simultaneo)
		return m_container.each(function(){
			//This current dom element.
			var currentNode = this;

			// le cuelgo el html del scheduler al current node...
			// hover de los botones
			$(".formButtonAdd ").mouseout(function(){
				$(this).addClass("formButtonAdd ").removeClass("formButtonAdd-ov");
			}).mouseover(function(){
				$(this).addClass("formButtonAdd-ov").removeClass("formButtonAdd ");
			});

			//creo controles segun ids
			var calendarSetting = {
				isYearEditable: true, yearsRange:[2000, 2050],
				isMonthEditable: true
			};
			dateSchedulerStart = new dhtmlxCalendarObject('dateSchedulerStart', true, calendarSetting);
			dateSchedulerEnd = new dhtmlxCalendarObject('dateSchedulerEnd', true, calendarSetting);

			if (m_settings.showdates === false) {
				$("#dateRangeValidity").hide();
			}
			//dias rango
			cmbDayRange = dhtmlXComboFromSelect("cmbDayRange");
			cmbDayRange.readonly(true);
			cmbDayRange.DOMelem.id = "cmbDayRange";

			cmbDayRange.addOption("Sunday", '<%=_T("Sunday")%>');
			cmbDayRange.addOption("Monday", '<%=_T("Monday")%>');
			cmbDayRange.addOption("Tuesday", '<%=_T("Tuesday")%>');
			cmbDayRange.addOption("Wednesday", '<%=_T("Wednesday")%>');
			cmbDayRange.addOption("Thursday", '<%=_T("Thursday")%>');
			cmbDayRange.addOption("Friday", '<%=_T("Friday")%>');
			cmbDayRange.addOption("Saturday", '<%=_T("Saturday")%>');
			cmbDayRange.setComboValue("Monday");
			cmbDayRange.attachEvent("onChange", OnRangeSelectionChanged);
			cmbDayRange.attachEvent("onChecked", OnRangeChecked);
			LoadRangeCombos();
			//el delete se lo asigno a la tabla entera
			$("#tblScheduleInterval td.formScheduleTableButtons").click(OnDeleteRange);
			$("#btnAddScheduledRange").click(AddScheduledRange);

			//seccion especiales..
			m_specialDays = {};
			cmbSpecialAction = dhtmlXComboFromSelect("cmbSpecialAction");
			cmbSpecialAction.addOption( [{value:"AddRange", text:'<%=_T("Add day range")%>', img_src:GetActionImage("AddRange")}]);
			cmbSpecialAction.addOption( [{value:"Override", text:'<%=_T("Override day configuration")%>', img_src:GetActionImage("Override")}]);
			cmbSpecialAction.addOption( [{value:"Exclusion", text:'<%=_T("Day exclusion")%>', img_src:GetActionImage("Exclusion")}]);
			cmbSpecialAction.setComboValue("AddRange");
			cmbSpecialAction.readonly(true);
			cmbSpecialAction.enableOptionAutoHeight(true);
			cmbSpecialAction.attachEvent("onChange", OnSpecialActionChanged);
			OnSpecialActionChanged();

			//fechas
			dateSpecialIncExc = new dhtmlxCalendarObject('dateSpecialIncExc', true, calendarSetting);
			dateExceptionalExclusion = new dhtmlxCalendarObject('dateExceptionalExclusion', true, calendarSetting);
			
						// callback del input que muestra cada calendario. Lo reposiciona respecto al botn que esta a su derecha y resetea la posicin del container del calendario.
			var calendarClick = function(evt, calendar, thisElement) {
				var calendar = evt.data;
				var currentInput = $((thisElement ? thisElement : this));
				calendar.parent.style.left = "0px";
				calendar.parent.style.top = "0px";
				calendar.parent.style.marginLeft = "0px";
				//vaya uno a saber porque a veces se le ocurre no devolver bien el ancho del boton de seleccion, que es siempre 22, asi que aca quedo...
				calendar.setPosition(currentInput.offset().top, currentInput.offset().left + currentInput.width() + 22);
				currentInput.show();
			};
			
			var HandleCalendarButton = function(evt, calendar, parent) {
				if (parent.attr("disabled")) {
					return;
				}
				evt.data = calendar;
				var isVisible = calendar.isVisible();
				calendarClick(evt, undefined, parent);
				if(isVisible) {
					calendar.hide();
				} else {
					calendar.show();
				}
			};
			
			$("#dateSpecialIncExc").bind("click", dateSpecialIncExc, function(evt, calendar) {
				calendarClick(evt, calendar, this);
				DisabledButtonAddSpecialDay("btnAddSpecialRange", false);
			});
			$("#btnSpecialIncExc").bind("click", function(evt) {
				HandleCalendarButton(evt, dateSpecialIncExc, $("#dateSpecialIncExc"));
				DisabledButtonAddSpecialDay("btnAddSpecialRange", false);
			});
			
			$("#dateExceptionalExclusion").bind("click", dateExceptionalExclusion, function(evt, calendar) {
				calendarClick(evt, calendar, this);
				DisabledButtonAddSpecialDay("btnAddExclusion", false);
			});
			$("#btnExceptionalExclusion").bind("click", function(evt) {
				HandleCalendarButton(evt, dateExceptionalExclusion, $("#dateExceptionalExclusion"));
				DisabledButtonAddSpecialDay("btnAddExclusion", false);
			});
			
			$("#dateSchedulerStart").bind("click", dateSchedulerStart, calendarClick);
			$("#btnSchedulerStart").bind("click", function(evt) {
					HandleCalendarButton(evt, dateSchedulerStart, $("#dateSchedulerStart"));
			});
			
			$("#dateSchedulerEnd").bind("click", dateSchedulerEnd, calendarClick);
			$("#btnSchedulerEnd").bind("click", function(evt) {
				HandleCalendarButton(evt, dateSchedulerEnd, $("#dateSchedulerEnd"));
			});

			var gridHeaderNames = '<%=_T("Date")%>' + ',' + '<%=_T("Reason")%>' + ',' + '<%=_T("When")%>' + ",";
			grdScheduleSpecialDays = new dhtmlXGridObject('grdScheduleSpecialDays');
			grdScheduleSpecialDays.setImagePath("/inconcert/lib/dhtmlx/grid/imgs/");
			grdScheduleSpecialDays.setHeader(gridHeaderNames);
			grdScheduleSpecialDays.setInitWidths("100,345,190,26");
			grdScheduleSpecialDays.setColAlign("left,left,left,center");
			grdScheduleSpecialDays.setColTypes("ro,ro,ro,ro");
			grdScheduleSpecialDays.setColSorting("str,str,str,str");
			grdScheduleSpecialDays.enableResizing("false,false,false,false");
			grdScheduleSpecialDays.init();
			$("#btnAddSpecialRange").click(AddSpecialRange);
			$("#btnAddExclusion").click(AddExclusion);

			// hago que los botones no naveguen a ningn lado
			var dontFollow = function() { return false; };
			$(".formButtonDatePicker").each(function(button) {
				this.onclick = dontFollow;
			});
		});
	};
 })(jQuery);
 