/*jslint forin:true */
/*global $ jQuery
*/

var m_formId;

////////////////////////////////////////////////////////////////////////////////////
//
function Validate() {
	$(".formErrorMessage").hide();
	$(".formOkMessage").hide();
	if ($.active > 0) {
		$(".formErrorMessage div").text('<%=_T("Please wait for the form to complete loading before saving.")%>');
		$(".formErrorMessage").show();
		return;
	}
	$(m_formId).submit();
}


////////////////////////////////////////////////////////////////////////////////////
//
function JoinRules(target, source) {
	for (var value in source) {
		target[value] = source[value];
	}
}


function InitializeValidator(formid, rules, saveFunction, accordionId) {
	m_formId = formid;

	jQuery.validator.addMethod("combo", function(value, element) {
		return value.length > 0;
	}, '<%=_T("You must select an item from the combo.")%>');

	jQuery.validator.isComboElement = function(element, rules) {
		var parentId = element.parentNode.id;
		var comboClass = 'dhx_combo_box';
		var regExp = new RegExp(comboClass);
		if (regExp.test(element.parentNode.className)) { //rules[parentId] &&
			return jQuery(element.parentNode);
		}
		else {
			return null;
		}
	};

	jQuery.validator.messages.required = '<%=_T("This field is required")%>';
    var form = $(formid).validate({
			onkeyup:false,
			onfocusout:false,
			showErrors: function(errorMap, errorList) {
				this.defaultShowErrors();
				var totalErrors = 0;
				//la cuenta de errores por span de acordeon se hace basicamente contando cuantas crucecitas hay en pantalla
				//cualquier otro intento de llevar un tracking real de los campos invalidos resulto total y completamente infructuoso
				if (this.settings.accordionId) {
					var accordionSpans = $("#" + this.settings.accordionId + " li").length;
					for (var i = 0; i < accordionSpans; i++) {
						var spanNumber = i;
						var errors = $("#" + this.settings.accordionId + " li:eq(" + spanNumber + ") div.formGroupValidator:visible").length;
						totalErrors += errors;
						if (errors > 0) {
							var message;
							if (errors === 1) {
								message = '<%=_T("1 error")%>';
							}
							else {
								message = jQuery.format('<%=_T("{0} errors")%>', errors);
							}
							$("#" + this.settings.accordionId + " li a span.headerError:eq("+spanNumber+")").text(message);
						}
						else {
							$("#" + this.settings.accordionId + " li a span.headerError:eq("+spanNumber+")").html('');
						}
					}
				}
				else {
					totalErrors = $("div.formGroupValidator:visible").length;
				}
				if (totalErrors > 0) {
					if (totalErrors === 1) {
						var message = '<%=_T("You have 1 field pending review.")%>';
					}
					else {
						var message = jQuery.format('<%=_T("You have {0} fields reviews pending .")%>', totalErrors);
					}
					$(".formErrorMessage div").text(message);
					$(".formErrorMessage").show();
				}
				else {
					$("#orderedlist li:first span").html('');
					$(".formErrorMessage").hide();
				}
			},
			errorClass: "formGroupValidator",
			errorElement: "div",
			accordionId : accordionId,
			rules : rules.rules,
			messages: rules.messages,
			submitHandler:function () {
				$(".formErrorMessage").hide();
				saveFunction();
			},
			errorPlacement: function(error, element) {
				if (element[0].id.length === 0) {
					element = jQuery.validator.isComboElement(element[0], this.rules);
					if (element === null) {
						return;
					}
				}
				if (element.hasClass("formGroupFieldDate")) {
					element = element.next();
				}
				var message = error.html();
				error.html("");
				error.attr("title","");
				error.insertAfter(element);
				error.tooltip({
						track: true,
						bodyHandler: function() {
						 return message;
						},
						delay: 0,
						showURL: false,
						opacity: 1,
						fixPNG: true,
						showBody: " - ",
						extraClass: "pretty",
						top: -5,
						left: 5
				});
			},
			highlight: function(element, errorClass) {
			},
			unhighlight: function(element, errorClass) {
			}
		}
	);
	return form;
}