/*jslint nomen:false  evil:true */
/*global $ jQuery dojo inconcert 
*/

/**
 * @author Cany
 */
/*
este script depende de:
	/inconcert/shared/paginated/styles/inconcertPaginated.css
*/

///////////////////////////////////////////////////////////
//
function CInconcertPaginated(paginatedId, objectName, divPaginatedContainer) {
// properties ---------------------------------------------------------------------
	var self = this;
	this.m_paginatedId = paginatedId;
	this.m_objectName = objectName;	// es el nombre de la variable a la que me asignaron (ej. var pepito = new CInconcertPaginated() , el objectName es 'pepito')
	this.m_divPaginatedContainer = divPaginatedContainer;
	this.m_rowsPerPage = 0;
	this.m_maxNumberOfPage = 10;
	this.m_numberOfRecords = 0;
	this.m_pagePosition = 1;
	this.m_requestFunctionName = undefined;
	this.m_numberOfInitialGroupPages = 0;
	this.m_numberOfFinalGroupPages = 0;
	this.m_canCreateControlsOfThePaginated = true;
	this.m_paginatedPath = '/inconcert/shared/paginated/';

	if(!document.getElementById(self.m_divPaginatedContainer)) {
		throw("CInconcertPaginated: The container element for the paginated does not exist");
	}
	//////////////////////////////////////////////////////////////////////////////
	//
	this.Init = function() {
		//escribo html en pagina
		var divPaginated = document.getElementById(self.m_divPaginatedContainer);
		divPaginated.innerHTML = self.GetHtmlPaginatedContainer();
		if (self.m_numberOfRecords > 0) {
			self.Build(self.m_numberOfRecords, 1, true);
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetRowsPerPage = function() {
		return self.m_rowsPerPage;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetMaxNumberOfPages = function() {
		return self.m_maxNumberOfPage;
	};
	//////////////////////////////////////////////////////////////////////////////
	// asigno evento al textbox de ir a pagina
	this.SetEventsInControls = function() {
		jQuery(document).keyup(function(event){
			if (event.keyCode === 13) {
				eval(self.m_objectName).GotoPage();
			}
		});
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GotoPage = function() {
		var element = document.getElementById(self.m_paginatedId.concat('_gotoPage'));
		if (element === null || isNaN(element.value)) {
			return;
		}
		var goPageNumber = parseInt(element.value, 10);
		if (goPageNumber <= 0 || goPageNumber > self.m_numberOfPages) {
			return;
		}
		if (goPageNumber === self.GetPagePosition()) {
			return;
		}
		eval(self.m_requestFunctionName.concat('(', element.value, ', 3)'));
		element.value = "";
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetHtmlPaginatedContainer = function() {
		var htmlPaginated = '';
		if (self.m_rowsPerPage > 0) {
			var gotoPageCaption = '<%=_T("Goto Page")%>';
			htmlPaginated = ''.concat(
				'<div class="gridPaginatedLeft">',
					'<div class="gridPaginatedRight">',
						'<div class="gridPaginatedCenter">',
							'<div class="gridPaginatedRegistry">',
								'<label id="', self.m_paginatedId,  '_paginatedLabel"></label>',
							'</div>',
							'<div id="', self.m_paginatedId,  '_paginated" class="gridPaginatedControl">',
							'</div>',
							'<div id="', self.m_paginatedId, '_gotoPageContainer" class="gridPaginatedGoPage" style="display:none;">',
								'<div class="gridPaginatedGoPageLabel">',
									'<label>', gotoPageCaption, '</label>',
								'</div>',
								'<div class="gridPaginatedGoPageField">',
									'<input id="', self.m_paginatedId, '_gotoPage" type="text"',
									'/></div>',
								'<div class="gridPaginatedGoPageButton">',
									'<a href="#"',
										' onclick="', self.m_objectName, '.GotoPage();"',
									'>',
										'<img class="butGoToPage" src="', self.m_paginatedPath, 'images/blank.gif"/>',
									'</a>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
				'</div>');
		}
		return htmlPaginated;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetPagePosition = function() {
		return self.m_pagePosition;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ConfigPaginated = function(rowsForPage, maxNumberOfPage, numberOfRowsByRequest, requestFunctionName) {
		self.m_rowsPerPage = rowsForPage;
		self.m_maxNumberOfPage = maxNumberOfPage;
		self.m_numberOfRecords = numberOfRowsByRequest;
		self.m_requestFunctionName = requestFunctionName;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetPreviousPage = function() {
		var ret = self.m_pagePosition - 1;
		if (ret < self.m_numberOfInitialGroupPages) {
			ret = self.m_numberOfInitialGroupPages;
		}
		return ret;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetNextPage = function() {
		var ret = self.m_pagePosition + 1;
		if (ret > self.m_numberOfFinalGroupPages) {
			ret = self.m_numberOfFinalGroupPages;
		}
		return ret;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetInitialPage = function(numberRows, page) {
		var numberOfPages = numberRows / self.m_rowsPerPage; // Total de pginas
		for (var initialPage = 1; initialPage <= numberOfPages; initialPage = initialPage + self.m_maxNumberOfPage) {
			var finalPage = (initialPage + self.m_maxNumberOfPage) - 1;
			if (page >= initialPage && page <= finalPage) {
				return initialPage;
			}
		}
		return 1;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ChangeClass = function(object, type, hasAdd) {
		var element = (typeof(object) === "string" ? document.getElementById(object) : object);
		if (element !== null) {
			var className = (type === 'ds' ? element.className.replace(/-ds/g, '') : element.className.replace(/-ov/g, ''));
			if (hasAdd) {
				className = className.concat('-'.concat(type));
			}
			element.className = className;
			if (type === 'ds') {
				element.disabled = hasAdd;
			}
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.Build = function(numberRows, initialPage, forceBuildOfTheButtons) {
		var elementToWrite = document.getElementById(self.m_paginatedId + '_paginated');
		if(!elementToWrite) {
			throw("CInconcertPaginated: The container element for the paginated buttons does not exist");
		}
		self.m_pagePosition = initialPage;
		var html = self.CreatePaginated(numberRows, initialPage, forceBuildOfTheButtons);
		if (forceBuildOfTheButtons) {
			elementToWrite.innerHTML = html;
		}
		self.HighlightSelectedPageButton();
		self.SetCaptionSelectedPageButton(numberRows);
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreatePaginated = function(numberRows, initialPage, forceBuildOfTheButtons) {
		var rowsForPage = numberRows;
		var htmlPageButtons = '';
		var htmlPreviousPage = '';
		var htmlNextPage = '';
		var htmlPreviousGroup = '';
		var htmlNextGroup = '';
		var selectedPage = initialPage;

		if (self.m_rowsPerPage > 0 && numberRows) {
			initialPage = self.GetInitialPage(numberRows, initialPage);
			//////////////
			// obtengo el numero de pginas, la cantidad de grupos a crear, el numero de pagina inicial, el numero final de pagina.
			rowsForPage = self.m_rowsPerPage;
			var numberOfPages = numberRows / rowsForPage; // Total de pginas
			if (numberOfPages !== parseInt(numberOfPages, 10)) {
				numberOfPages = parseInt(numberOfPages, 10) + 1;
			}
			self.m_numberOfPages = numberOfPages;

			var numberOfGroups = numberOfPages / self.m_maxNumberOfPage;
			if (numberOfGroups !== parseInt(numberOfGroups, 10)) {
				numberOfGroups = parseInt(numberOfGroups, 10) + 1;
			}

			var finalPage;
			if (numberOfPages <= self.m_maxNumberOfPage){
				finalPage = numberOfPages;
			}
			else {
				if (initialPage === 1) {
					for (var idGroup = 1; idGroup <= numberOfGroups; idGroup++) {
						finalPage = idGroup * self.m_maxNumberOfPage;
						initialPage = finalPage - (self.m_maxNumberOfPage) + 1;
						if (self.m_pagePosition >= initialPage && self.m_pagePosition <= finalPage) {
							break;
						}
					}
				}
				else {
					finalPage = initialPage + (self.m_maxNumberOfPage - 1);
					if (finalPage > numberOfPages) {
						finalPage = numberOfPages;
					}
				}
			}
			if (finalPage !== parseInt(finalPage, 10)) {
				finalPage = parseInt(finalPage, 10) + 1;
			}
			
		////////////////////////////////////////////////
		////CREO BOTONES EN P?GINA
			var keyButtonAnt = self.m_objectName + "_ANTERIOR";
			var keyButtonPageAnt = self.m_objectName + "_PAGEANTERIOR";
			var keyButtonSig = self.m_objectName + "_SIGUIENTE";
			var keyButtonPageSig = self.m_objectName + "_PAGESIGUIENTE";

			var functionChangeClass = self.m_objectName.concat('.ChangeClass(this, \'ov\', BOOLEAN);return false;');

			//////////////////////////////////////////////
			// Crea row y col a la tabla principal (en la misma se agrega el paginado)
			// Creo Botones de desplazamiento (Pagina anterior, siguiente)
			var classPagerPrevPage = 'butPagerPrevPage-ds';
			var disabledPagerPrevPage = ' disabled="true" ';
			var classPagerNextPage = 'butPagerNextPage';
			var disabledPagerNextPage = '';
			if (initialPage === finalPage) {
				classPagerNextPage += '-ds';
				disabledPagerNextPage = ' disabled="true" ';
			}
			if (self.m_canCreateControlsOfThePaginated === true || forceBuildOfTheButtons === true) {
				//anterior
				var	functionPreviousPageToExecute = '';
				if (self.m_numberOfRecords !== undefined) {
					functionPreviousPageToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetPreviousPage(), 0)';
				}
				// siguiente
				var	functionNextPageToExecute = '';
				if (self.m_numberOfRecords !== undefined) {
					functionNextPageToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetNextPage(), 0)';
				}
				htmlPreviousPage = ''.concat(
					'<button ',
						'class="', classPagerPrevPage, '"', disabledPagerPrevPage, ' id = "', keyButtonPageAnt, '" ',
						'onclick="', functionPreviousPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
					'></button>');
				htmlNextPage = ''.concat(
					'<button class="', classPagerNextPage, '"', disabledPagerNextPage  ,' id = "', keyButtonPageSig , '" ',
						'onclick="', functionNextPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
					'</button> ');
			}
			else { // Si el HTML ya existe busco los elementos
				//////////////////////////////////////////
				// Bot?n P?gina Anterior
				var elementPageAnt = document.getElementById(keyButtonPageAnt);
				if (elementPageAnt !== null) {
					// Asocio Funcion
					var	functionToExecute = '';
					if (self.m_numberOfRecords !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetPreviousPage(), 0)';
					}
					elementPageAnt.onclick = Function(functionToExecute);
					if (selectedPage === initialPage) {
						elementPageAnt.disabled = true;
						elementPageAnt.className = 'butPagerPrevPage-ds';
					}
					else {
						elementPageAnt.disabled = false;
						elementPageAnt.className = 'butPagerPrevPage';
					}
				}
				//////////////////////////////////////////
				// Bot?n P?gina Siguiente
				var elementPageSig = document.getElementById(keyButtonPageSig);
				if (elementPageSig !== null) {
					// Asocio Funcion
					var	functionToExecute = '';
					if (self.m_numberOfRecords !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetNextPage(), 0)';
					}
					elementPageSig.onclick = Function(functionToExecute);
					if (initialPage === finalPage || finalPage === selectedPage) {
						elementPageSig.disabled = true;
						elementPageSig.className = 'butPagerNextPage-ds';
					}
					else {
						elementPageSig.disabled = false;
						elementPageSig.className = 'butPagerNextPage';
					}
				}
			}
			////////////////////////////////////////////////
			//En el bucle crea los botones referentes a los numeros de p?ginas/////////////////
			var i = 0;
			var idPage = 0;
			var keyButtonPage = "";
			var numberOfFinalGroupPages = (initialPage + (self.m_maxNumberOfPage - 1));
			var functionToExecute = '';

			self.m_numberOfInitialGroupPages = initialPage;
			self.m_numberOfFinalGroupPages = (numberOfFinalGroupPages > numberOfPages) ? numberOfPages : numberOfFinalGroupPages;
			for (i = initialPage; i <= numberOfFinalGroupPages; i++) {
				idPage++;
				keyButtonPage = self.m_objectName + '_' + idPage;

				if (i <= numberOfPages) {
					if (self.m_numberOfRecords !== undefined) {
						functionToExecute = ''.concat(
							'if (', i, ' !== ', self.m_objectName ,'.GetPagePosition()) {',
								self.m_requestFunctionName, '(', i, ', 0);',
							'}');
					}
					// Crea en el documento el bot?n y asigna funci?n
					if (self.m_canCreateControlsOfThePaginated === true || forceBuildOfTheButtons === true) {
						htmlPageButtons = htmlPageButtons.concat(
							'<button class="butPagerNumber" id ="', keyButtonPage, '" ',
								'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
								'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
								'onclick="', functionToExecute, '">', i,
							'</button> ');
					}
					else {
						// visualiza elemento, cambia etiqueta (porque ya existe) y cambia funcion
						var elementPage = document.getElementById(keyButtonPage);
						if (elementPage !== null) {
							elementPage.innerHTML = i;
							elementPage.disabled = false;
							elementPage.style.display = "";
							elementPage.onclick = Function(functionToExecute);
						}
					}
				}
				else {
					// SI NO Existen m?s, oculta el bot?n.
					var elementPage = document.getElementById(keyButtonPage);
					if (elementPage !== null) {
						elementPage.innerHTML = "";
						elementPage.style.display = "none";
						elementPage.disabled = true;
					}
				}
			}
			//////////////////////////////////////////////
			// Creo Botones de desplazamiento (Grupo de paginas anterior y siguiente)
			// Cierro Tablas
			if (self.m_canCreateControlsOfThePaginated === true || forceBuildOfTheButtons === true) {
				//anterior
				var	functionPreviousGroupPageToExecute = '';
				if (self.m_numberOfRecords !== undefined) {
					functionPreviousGroupPageToExecute = self.m_requestFunctionName + '(' + undefined + ', 2)';
				}
				// siguiente
				var	functionNextGroupPageToExecute = '';
				if (self.m_numberOfRecords !== undefined) {
					functionNextGroupPageToExecute = self.m_requestFunctionName + '(' + (finalPage + 1) + ', 1)';
				}
				htmlPreviousGroup = htmlPreviousGroup.concat(
					'<button class="butPagerPrevGroup-ds" disabled="true" id = "',
						keyButtonAnt, '" onclick="', functionPreviousGroupPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
					'></button> ');

				var classNextGroup = "butPagerNextGroup";
				// Deshabilito el boton de "grupo de paginas siguiente" si solo crea un grupo de paginas
				var disabledButtonSig = "";
				if (finalPage === numberOfPages) {
					disabledButtonSig = 'disabled="true" ';
					classNextGroup = classNextGroup.concat('-ds');
				}
				htmlNextGroup = htmlNextGroup.concat(
					'<button ',
						'class="', classNextGroup, '" ',
						'id = "', keyButtonSig, '" ',
						'onclick="', functionNextGroupPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
						disabledButtonSig,
					 '>',
					 '</button> ');

				self.m_canCreateControlsOfThePaginated = false;
			}
			else { // Si el HTML ya existe busco los elementos
				//////////////////////////////////////////
				// Bot?n Grupo de P?ginas Anterior
				var elementAnt = document.getElementById(keyButtonAnt);
				if (elementAnt !== null) {
					var disabled = false;
					if (self.m_pagePosition < self.m_maxNumberOfPage) {
						disabled = true;
					}
					self.ChangeClass(elementAnt, 'ds', disabled);
					// Asocio Funcion
					var paramNumberPage = (initialPage - self.m_maxNumberOfPage);
					if (paramNumberPage < 1) {
						paramNumberPage = 1;
					}
					var	functionToExecute = '';
					if (self.m_numberOfRecords !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + paramNumberPage + ', 2)';
					}

					elementAnt.onclick = Function(functionToExecute);
				}
				//////////////////////////////////////////
				// Botn Grupo de Pginas Siguientes
				var elementSig = document.getElementById(keyButtonSig);
				if (elementSig !== null) {
					var disabled = false;
					if (finalPage === numberOfPages) {
						disabled = true;
					}
					self.ChangeClass(elementSig, 'ds', disabled);

					functionToExecute = '';
					if (self.m_numberOfRecords !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + (finalPage + 1) + ', 1)';
					}

					elementSig.onclick = Function(functionToExecute);
				}
			}
		}
		return ''.concat(htmlPreviousGroup, htmlPreviousPage, htmlPageButtons, htmlNextPage, htmlNextGroup);
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetCaptionSelectedPageButton = function (numberPages) {
		var element = document.getElementById(self.m_paginatedId +  '_paginatedLabel');
		if (element === null) {
			return;
		}
		var captionPages = '';
		if (numberPages > 0 && self.m_pagePosition !== undefined &&
				self.m_numberOfPages !== undefined && self.m_numberOfPages > 0) {
			captionPages = '<%=_T("Page %1 of %2")%>';
			captionPages = captionPages.replace(/%1/g, self.m_pagePosition);
			captionPages = captionPages.replace(/%2/g, self.m_numberOfPages);
		}
		element.innerHTML = captionPages;
		//---
		var elementGotoPage = document.getElementById(self.m_paginatedId +  '_gotoPageContainer');
		if (elementGotoPage === null) {
			return;
		}
		elementGotoPage.style.display = (numberPages === 0 ? 'none' : '');
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.HighlightSelectedPageButton = function () {
		var pag = jQuery('#' + self.m_paginatedId + '_paginated > button');
		if (pag.length > 0) {
			for (var i = 0; i < pag.length; i++) {
				if (pag[i].id.search('ANTERIOR') > 0 || pag[i].id.search('PAGEANTERIOR') > 0 || 
						pag[i].id.search('SIGUIENTE') > 0 || pag[i].id.search('PAGESIGUIENTE') > 0) {
					continue;
				}
				var className = "butPagerNumber";
				if (parseInt(pag[i].innerHTML, 10) === self.m_pagePosition) {
					className = "butPagerNumberCurrent";
				}
				pag[i].className = className;
			}
		}
	};
}
//Fin clase CInconcertPaginated/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////