local inconcert_render = require "inconcert.render"
local setmetatable, require = setmetatable, require

module((...))

local dashboard = nil

-- "inherit" from inconcert.render
setmetatable(_M, { __index = inconcert_render })

-- 
-- This Render uses the masterpage by default, and pulls the dashboard if needed.
local function Render(self, web, env)
	local env = env or {}
	if not dashboard then
		dashboard = require "apps.dashboard"
	end
	env.Dashboard = function()
		return dashboard:Render(self, web, env)
	end
	return RenderPage(self, "/shared/render/pages/masterpage.html", web, env)
end

--
-- Creates a new Render instance. I add some functions to the common render
function new(...)
	local newInstance = inconcert_render.new(...)	--applicationName, parameters
	
	newInstance.Render = Render

	return newInstance
end