/*
AjaxObject: Encapsula una conexion xmlhttprequest.

Permite volver a enviar el mismo request tantas veces como se quiera. O sea que se puede 
hacer http streaming.

Testeado en: 
- Internet Explorer 6
- Internet Explorer 7 beta 3
- Mozilla 1.7.13
- Opera 9.0
- Firefox 1.5.04
- Netscape 7.2, 8.1
- Seamonkey 1.73
*/

/*global ActiveXObject
*/

function append(message) {
	//console.log(message);
}

var inConcert = {

	AjaxObject: function() {
		this.connection = this.getTransport();
		this.debug = 0;
		this.ident = "";
	}
};

inConcert.AjaxObject.prototype = {
	toString: function() { return "[object AjaxObject]"; },
	
	getTransport: function() {
		var con = null;
		if (window.XMLHttpRequest) { con = new XMLHttpRequest(); }
		else if (window.ActiveXObject) {
			try { con = new ActiveXObject("Msxml2.XMLHTTP"); }
			catch(e) {
				try { con = new ActiveXObject("Microsoft.XMLHTTP"); }
				catch(e){}
			}
		}
		return con;
	},
	
	open: function(options) {
		if(typeof options.asynchronous !== "boolean") {
			options.asynchronous = true;
		}
		this.options = options;
		this.connection.open(options.method, options.url, options.asynchronous, options.user, options.password);
	},
	
	bind: function(functions) {
		this.functions = functions;
		var cierre = this;
		this.connection.onreadystatechange = function()
		{
			try {
				if(cierre.debug === 1) { append("onreadystatechange: readystate => "+ cierre.connection.readyState); }
				if( cierre.connection.readyState === 4 ) {
					if(cierre.debug === 1) {
						append("status => " + cierre.connection.status);
					}
					switch(cierre.connection.status) {
						case 200:
							if( cierre.functions.onload && typeof cierre.functions.onload === "function") {
								cierre.functions.onload(cierre);
							}
						break;
						case 404:
							if( cierre.functions.onerror && typeof cierre.functions.onerror === "function") {
								cierre.functions.onerror(cierre);
							}
						break;
						default:
							if(cierre.debug === 1) { append("default"); }
						break;
					}
				}
			}
			catch(e) { alert(cierre.ident + ": " + e.message); }
		};
	},
	
	send: function(parameters) {
		//this.connection.open( this.options.method, this.url, this.options.asynchronous, this.options.user, this.options.password );
		//this.bind( this.options.onload, this.options.onerror, this.options.onreadystatechange );
		this.connection.send( parameters );
	},
	
	resend: function(parameters) {
		this.connection = this.getTransport();
		this.connection.open(this.options.method, this.options.url, this.options.asynchronous, this.options.user, this.options.password);
		this.bind(this.functions);
		this.send(parameters);
	},
	
	reset: function() {
		this.connection = this.getTransport();
	},
	
	abort: function() {
		if(this.connection) {
			this.connection.abort();
			this.connection = null;
		}
	}

};