/*global $ jQuery
sessvars

*/
var inconcert = inconcert || {};

/**
El FakeWizard se usa as:
var wiz = new inconcert.FakeWizard({
	onLoseChanges: function() {
		esta funcion me la llaman cuando se van a perder los cambios porque el usuario asi lo indico
	},
	loseChangesMessage: "el mensaje para avisar al usuario que va a perder los cambios",
	banSelector: "un selector css para elegir los elementos a banear (por defecto banea los hyperlinks)",
	onForbidden: function(ev) {
		esta funcion me la llaman cuando clickean un elemento baneado
	}
});
*/

// por favor, espero que esto sea temporal!!
inconcert.FakeWizard = function(userConfig) {
	var self = this;
	var params = userConfig || {};
	
	self.m_exitAllowed = true;
	self.m_callbackChangesLost = params.onLoseChanges;
	self.m_loseChangesMessage = params.loseChangesMessage;
	self.m_banSelector = params.banSelector || "a";	// by default, we ban all hyperlinks
	self.m_callbackForbidden = params.onForbidden;
	self.m_highlightBannedElements = (params.highlightBans) ? true : false;
	
	this.AllowExit = function() {
		self.m_exitAllowed = true;
		$(window).unbind("unload.fake_wizard");
		if(!self.m_banned) {
			return;
		}
		self.m_banned.each(function(i, element) {
			var newEl = $(element);
			var old = $(element).data("valor");
			newEl.replaceWith(old);
			if(self.m_highlightBannedElements) {
				old.css("border", "solid").css("color", "green");
			}
		});
		delete self.m_banned;
	};
	
	this.ForbidExit = function() {
		self.m_exitAllowed = false;
		self.m_banned = $(self.m_banSelector);
		self.m_banned.each(function(i, element) {
			var current = $(element);
			current.unbind("click.fake_wizard");
			var cloned = current.clone(true);
			current.unbind("click")
				.bind("click.fake_wizard", function(ev) {
					if(self.m_callbackForbidden) {
						self.m_callbackForbidden();
					}
					ev.preventDefault();
				})
				.data("valor", cloned);
			if(self.m_highlightBannedElements) {
				current.css("border", "solid").css("color", "red");
			}
		});
	};

	// si no puedo salir, bindeo una funcion al unload (no uso jquery porque no bindea bien contra onbeforeunload (al menos con jquery 1.2.6)
	var cleanup = function(e) {
		var ev = e || event;
		if(!self.m_exitAllowed) {
			$(window)
				.unbind("unload.fake_wizard")
				.bind("unload.fake_wizard", function(ev) {
					if(self.m_callbackChangesLost) {
						self.m_callbackChangesLost();
					}
					self.m_exitAllowed  = true;
				});
			ev.returnValue = self.m_loseChangesMessage;
		}
	};
	if(window.addEventListener) {	//Mozilla y amigos
		window.addEventListener("beforeunload", cleanup, false);
	}
	else if(window.attachEvent) {	// IE, el renegado
		window.attachEvent("onbeforeunload", cleanup);
	}
	else {
		throw("Unsupported browser");
	}
};