/*jslint evil: true*/
/*global $ jQuery*/

/**
 * @author IGNACIO JAVIER BURGUEO FERRARO
 */
///////////////////////////////////////////////////////////////////
// objeto utilizado como NAMESPACE, el mismo contiene los eventos de la pagina

var view_events = {
	vars: {
		pageId: '',
		filterPath: '/inconcert/shared/filter/',
		applicationFilterPath: undefined,
		applicationPath: '/inconcert/apps/provisioning',
		urlToSaveFilter: '/view/filter/save',
		urlApplyFilter: '/view/filter/apply',
		gridObject: undefined,
		waiting: undefined,
		numberPage: undefined,
		othersGroupsPage: undefined,
		initialObject: undefined,
		viewManager: undefined
	},
	//////////////////////////////////////////////////
	// Inicializa propidades de la clase/////////////////////////////////////
	Init: function(pageId, gridObject, waiting, applyFilterPath, initialObject) {
		this.vars.pageId = pageId;
		this.vars.applicationFilterPath = (applyFilterPath === undefined ? this.vars.filterPath : applyFilterPath);
		this.vars.gridObject = gridObject;
		this.vars.waiting = waiting;
		this.vars.initialObject = initialObject;
	},
	//////////////////////////////////////////////////////////////////////////////
	//
	ShowMessage: function(message, newClass) {
		var className = (newClass === undefined ? 'formErrorMessage' : newClass);
		var element = document.getElementById("messageError");
		if (element && element.className !== className) {
			element.className = className;
		}
		jQuery("#messageError div").text(message);
		jQuery("#messageError").show();
		
		if (view_events.vars.gridObject !== undefined) {
			view_events.vars.gridObject.HideInternalWaiting();
		}
		if (view_events.vars.waiting !== undefined) {
			view_events.vars.waiting.Hide();
		}
	},	
	//////////////////////////////////////////////////
	//
	ajax: {
		send: {
			SaveFilter: function (filterKey, filter) {
				jQuery("#messageError").hide();
				var urlName = view_events.vars.applicationPath + view_events.vars.urlToSaveFilter;
				var listOfParams = {};
				listOfParams[filterKey] = filter;
				var jsonFilter = JSON.stringify(listOfParams);
				var parameters = '';
				parameters += 'filter=' + jsonFilter;

				var peticion = jQuery.ajax({
					url: urlName,
					type: 'POST',
					async: true,
					data: parameters,
					success: view_events.ajax.response.SaveFilter,
					error: function(err){
						view_events.ShowMessage('<%=_T("Error saving filter, please contact your administrator.")%>');
					}
				});
			}
			,ApplyFilter: function (filter, hasShowExternalWaiting) {
				jQuery("#messageError").hide();
				if (view_events.vars.waiting !== undefined) {
					if (hasShowExternalWaiting !== false) {
						view_events.vars.waiting.SetDefaultMessage();
						view_events.vars.waiting.Show();
					}
				}
				var peticion = jQuery.ajax({
				  		url: view_events.vars.applicationFilterPath.concat(view_events.vars.urlApplyFilter),
						type: 'POST',
						async: true,
						data: ''.concat(
							'pageId=', view_events.vars.pageId, '&',
							'filter=', (typeof(filter) === "object" ? JSON.stringify(filter) : null), '&',
							'forceQuery=', (typeof(filter) === "object" ? 0 : 1), '&',
							'permissionInQuery=', (view_events.vars.initialObject.vars.permissionInQuery === true ? 1 : 0)
						),
						success: view_events.ajax.response.ApplyFilter,
						error: function(err){
							view_events.ShowMessage('<%=_T("Error applying filter, please contact your administrator.")%>');
						}
					}
				);
			}
			,Request: function(numberPage, othersGroupsPage) {
				jQuery("#messageError").hide();
				if (view_events.vars.gridObject !== undefined) {
					if (numberPage !== view_events.vars.gridObject.GetPagePosition()) {
						view_events.vars.gridObject.ShowInternalWaiting();
						view_events.vars.numberPage = numberPage;
						view_events.vars.othersGroupsPage = othersGroupsPage;
						var peticion = jQuery.ajax({
						  		url: view_events.vars.applicationFilterPath.concat(view_events.vars.urlApplyFilter),
								type: 'POST',
								async: true,
								data: ''.concat(
									'pageId=', view_events.vars.pageId, '&',
									'numberPage=', 
									numberPage),
								success: view_events.ajax.response.Request,
								error: function(err) {
									view_events.ShowMessage('<%=_T("Error requesting page, please contact your administrator.")%>');
								}
							}
						);
					}
				}
			}
		}
		,response: {
			SaveFilter: function(ajaxResponse) {
				if (view_events.vars.waiting !== undefined) {
					view_events.vars.waiting.Hide();
				}
			}
			,ApplyFilter: function(ajaxResponse) {
				if (view_events.vars.gridObject !== undefined) {
					var data = eval('(' + ajaxResponse + ')');
					view_events.vars.gridObject.SetData(data);
					view_events.vars.gridObject.HideInternalWaiting();
				}
				if (view_events.vars.waiting !== undefined) {
					view_events.vars.waiting.Hide();
				}
			}
			,Request: function(ajaxResponse) {
				if (view_events.vars.gridObject !== undefined) {
					var data = eval('(' + ajaxResponse + ')');
					view_events.vars.gridObject.SetData(data, view_events.vars.numberPage, view_events.vars.othersGroupsPage);
					view_events.vars.gridObject.HideInternalWaiting();
					view_events.vars.initialObject.CheckPermissionButtons();
				}
			}
		}
	}
};
