/*jslint nomen: false*/
/*global $ jQuery

CInconcertWaiting
CInconcertGrid
*/

/**
 * @author Cany
 */

///////////////////////////////////////////////////////////////////////////////////////////////////////
// Tabla que contiene el mapeo del tipo de dato / valor a mostrar en la celda de la grilla
// 		Ej: Tipo de dato 'CALL' muestra en la celda la imagen 'images/telephone.gif'
// 			Esta tabla se pasa como parametro cuando se inicializa la grilla en el m?todo:
//				TU_GRILLA.SetMappedCellOfValue(g_mappedCellOfValue);
//

var view_manager = {
	vars: {
		jsonColumns: undefined,
		jsonData: undefined,
		applicationPath: '/inconcert/apps/',
		urlBase: '/inconcert/apps/',
		permissionInQuery: true,
		imagesPath: '/images',
		pageId: '',
		nameGrid: 'mcallGrid',
		gridObjectName: 'view_manager.vars.gridObject',
		requestFunctionName: 'view_manager.vars.serverEventsObject.ajax.send.Request',
		divGridContainer: '',
		themeId: 'Inconcert',
		gridObject: undefined,
		serverEventsObject: undefined,
		actionsObject: undefined,
		waitingObject: undefined,
		savepermission: true,
		deletepermission: true,
		renderpermission: true
	},
	mappedCellOfValue: {
		'COMMANDCLONE'					:	{type: "class", value: 'gridButClone'},
		'COMMANDCLONE_OVER'				:	{type: "class", value: 'gridButClone-ov'},
		'COMMANDEDIT'					:	{type: "class", value: 'gridButEdit'},
		'COMMANDEDIT_OVER'				:	{type: "class", value: 'gridButEdit-ov'},
		'COMMANDDELETE'					:	{type: "class", value: 'gridButDelete'},
		'COMMANDDELETE_OVER'			:	{type: "class", value: 'gridButDelete-ov'},
		'COMMANDPLAY'					:	{type: "class", value: 'gridButPlay'},
		'COMMANDPLAY_OVER'				:	{type: "class", value: 'gridButPlay-ov'},

		'COMMANDEDITLIVEMONITORINDICATOR':  {type: "class", value: function(column, row){
												return view_manager.GetClassButtonGrid(
													{
														'0': 'gridButEdit',
														'1': 'gridButEdit-ds'
													}, 'IsSystem', column, row);
												}
											},
		'COMMANDDELETELIVEMONITORINDICATOR':{type: "class", value: function(column, row){
												return view_manager.GetClassButtonGrid(
													{
														'0': 'gridButDelete',
														'1': 'gridButDelete-ds'
													}, 'IsSystem', column, row);
												}
											},
		
		'COMMANDDELETEOUTBOUNDPROCESS'	:	{type: "class", value: function(column, row){
												return view_manager.GetClassButtonGrid(
													{	'RUNNING': 'gridButDelete-ds',
														'STOPPED': 'gridButDelete',
														'INVALID': 'gridButDelete-ds',
														'DISABLED': 'gridButDelete-ds',
														'STOPPING': 'gridButDelete-ds'
													}, 'status', column, row);
												}
											},
		
		'COMMANDSTARTSTOP'				:	{type: "class", value: function(column, row){
												return view_manager.GetClassButtonGrid(
													{	'RUNNING': 'gridButOutboundProcessStop',
														'STOPPED': 'gridButOutboundProcessStart',
														'INVALID': 'gridButOutboundProcessStart',
														'DISABLED': 'gridButOutboundProcessStart-ds',
														'STOPPING': 'gridButOutboundProcessStart-ds'
													}, 'status', column, row);
												}
											},
		'COMMANDCANCEL'					:	{type: "class", value: 	function(column, row) {
												return view_manager.GetClassButtonGrid(
													{	'ABORTED': 		'gridButImportationCancel-ds',
														'COMPLETE': 	'gridButImportationCancel-ds',
														'PAUSED': 		'gridButImportationCancel-ds',
														'DELETING': 	'gridButImportationCancel-ds',
														'RUNNING': 		'gridButImportationCancel'
													}, 'status', column, row);
												}
											},
		'COMMANDEDITIMPORTATION'		:	{type: "class", value: 	function(column, row) {
												return view_manager.GetClassButtonGrid(
													{	'ABORTED': 		'gridButEdit',
														'COMPLETE': 	'gridButEdit',
														'PAUSED': 		'gridButEdit',
														'DELETING': 	'gridButEdit-ds',
														'RUNNING': 		'gridButEdit'
													}, 'status', column, row);
												}
											},
		'COMMANDDELETEIMPORTATION'		:	{type: "class", value: 	function(column, row) {
												return view_manager.GetClassButtonGrid(
													{	'ABORTED': 		'gridButDelete',
														'COMPLETE': 	'gridButDelete',
														'PAUSED': 		'gridButDelete',
														'DELETING': 	'gridButDelete-ds',
														'RUNNING': 		'gridButDelete'
													}, 'status', column, row);
												}
											},
		'COMMANDDELETEEXPORTATION'		:	{type: "class", value: 	function(column, row) {
												return view_manager.GetClassButtonGrid(
													{	'ABORTED': 				'gridButDelete',
														'COMPLETE': 			'gridButDelete',
														'VALIDATING': 			'gridButDelete-ds',
														'ASSEMBLING OUTPUT': 	'gridButDelete-ds',
														'QUERYING DB': 			'gridButDelete-ds'
													}, 'status', column, row);
												}
											},
		'COMMANDDOWNLOADEXPORTATION'		:	{type: "class", value: 	function(column, row) {
												var availableFile = view_manager.GetClassButtonGrid({'0': false, '1': true}, 'availablefile', column, row);
												if (!availableFile) {
													return '';
												}
												return view_manager.GetClassButtonGrid(
													{	'ABORTED': 				'gridButDownload-ds',
														'COMPLETE': 			'gridButDownload',
														'VALIDATING': 			'gridButDownload-ds',
														'ASSEMBLING OUTPUT': 	'gridButDownload-ds',
														'QUERYING DB': 			'gridButDownload-ds'
													}, 'status', column, row);
												}
											},
		'COMMANDCANCELEXPORTATION'					:	{type: "class", value: 	function(column, row) {
												return view_manager.GetClassButtonGrid(
													{	'ABORTED': 				'gridButExportationCancel-ds',
														'COMPLETE': 			'gridButExportationCancel-ds',
														'VALIDATING': 			'gridButExportationCancel',
														'ASSEMBLING OUTPUT': 	'gridButExportationCancel',
														'QUERYING DB': 			'gridButExportationCancel'
													}, 'status', column, row);
												}
											},

		'CAMPAIGN'						:	{type: "class", value: 'gridIcoCampaign'},
		'CAMPAIGNINBOUND'				:	{type: "class", value: 'gridIcoCampaignInBound'},
		'CAMPAIGNOUTBOUND'				:	{type: "class", value: 'gridIcoCampaignOutBound'},
		'CAMPAIGNCHAT'					:	{type: "class", value: 'gridIcoCampaignChat'},
		'CAMPAIGNMAIL'					:	{type: "class", value: 'gridIcoCampaignMail'},

		'ADMINISTRATOR'					:	{type: "class", value: 'gridIcoAdministrator'},
		'AGENT'							:	{type: "class", value: 'gridIcoAgent'},
		'BUSINESSMANAGER'				:	{type: "class", value: 'gridIcoBusinesManager'},
		'DEPLOYER'						:	{type: "class", value: 'gridIcoDeployer'},
		'DESIGNER'						:	{type: "class", value: 'gridIcoDesigner'},
		'QUALITYAUDITOR'				:	{type: "class", value: 'gridIcoQualityAuditor'},
		'SUPERVISOR'					:	{type: "class", value: 'gridIcoSupervisor'},
		'NON_SYSTEM_GROUP'				:	{type: "class", value: 'gridIcoNonSystemGroup'},

		'NON_SYSTEM_USER'				:	{type: "class", value: 'gridIcoNonSystemUser'},

		'WORKGROUP'						:	{type: "class", value: 'gridIcoWorkGroup'},

		'ADMINISTRATION_APP'			:	{type: "class", value: 'gridIcoAdministrationApp'},
		'BARAGENT_APP'					:	{type: "class", value: 'gridIcoBaragentApp'},
		'DASHBOARD_APP'					:	{type: "class", value: 'gridIcoDahsobardApp'},
		'DESIGNER_APP'					:	{type: "class", value: 'gridIcoDesignerApp'},
		'MEDIAPLAYER_APP'				:	{type: "class", value: 'gridIcoMediaplayerApp'},
		'MEDIASERVER_APP'				:	{type: "class", value: 'gridIcoMediaserverApp'},
		'OUTBOUNDENGINE_APP'			:	{type: "class", value: 'gridIcoOutboundengineApp'},
		'PROVISIONING_APP'				:	{type: "class", value: 'gridIcoProvisioningApp'},
		'REPORTS_APP'					:	{type: "class", value: 'gridIcoReportsApp'},
		'REPOSITORY_APP'				:	{type: "class", value: 'gridIcoRepositoryApp'},
		'SUPERVISOR_APP'				:	{type: "class", value: 'gridIcoSupverisorApp'},
		'OTHER_APP'						:	{type: "class", value: 'gridIcoOtherApp'},

		'CONTACT_CENTER'				:	{type: "class", value: 'gridIcoCampaignInBoundTypeContacCenter'},
		'SELF_SERVICE'					:	{type: "class", value: 'gridIcoCampaignInBoundTypeSelfService'},

		'IMPORTATION_ABORTED'			:	{type: "class", value: 'gridIcoImportationAborted'},
		'IMPORTATION_COMPLETE'			:	{type: "class", value: 'gridIcoImportationComplete'},
		'IMPORTATION_PAUSED'			:	{type: "class", value: 'gridIcoImportationPaused'},
		'IMPORTATION_RUNNING'			:	{type: "class", value: 'gridIcoImportationRunning'},
		'IMPORTATION_DELETING'			:	{type: "class", value: 'gridIcoImportationDeleting'},

		'EXPORTATION_ABORTED'			:	{type: "class", value: 'gridIcoExportationAborted'},
		'EXPORTATION_COMPLETE'			:	{type: "class", value: 'gridIcoExportationComplete'},
		'EXPORTATION_VALIDATING'		:	{type: "class", value: 'gridIcoExportationValidating'},
		'EXPORTATION_QUERYING_DB'		:	{type: "class", value: 'gridIcoExportationQueryingDB'},
		'EXPORTATION_ASSEMBLING_OUTPUT'	:	{type: "class", value: 'gridIcoExportationAssemblingOutput'},

		'OUTBOUNDPROCESS_DISABLED'		:	{type: "class", value: 'gridIcoOutboundProcessDisabled'},
		'OUTBOUNDPROCESS_INVALID'		:	{type: "class", value: 'gridIcoOutboundProcessInvalid'},
		'OUTBOUNDPROCESS_RUNNING'		:	{type: "class", value: 'gridIcoOutboundProcessRunning'},
		'OUTBOUNDPROCESS_STOPPED'		:	{type: "class", value: 'gridIcoOutboundProcessStopped'},
		'OUTBOUNDPROCESS_STOPPING'		:	{type: "class", value: 'gridIcoOutboundProcessStopping'},

		'OUTBOUNDPROCESS_CALL'			:	{type: "class", value: 'gridIcoOutboundProcessCall'},
		'OUTBOUNDPROCESS_CHAT'			:	{type: "class", value: 'gridIcoOutboundProcessChat'},
		'OUTBOUNDPROCESS_FAX'			:	{type: "class", value: 'gridIcoOutboundProcessFax'},
		'OUTBOUNDPROCESS_MAIL'			:	{type: "class", value: 'gridIcoOutboundProcessMail'},
		'OUTBOUNDPROCESS_VOICEMAIL'		:	{type: "class", value: 'gridIcoOutboundProcessVoiceMail'},
		'OUTBOUNDPROCESS_OTHER'			:	{type: "class", value: 'gridIcoOutboundProcessOther'},

		'MULTIMEDIARESOURCE_CALL'		:	{type: "class", value: 'gridIcoMultimediaResourceCall'},
		'MULTIMEDIARESOURCE_CHAT'		:	{type: "class", value: 'gridIcoMultimediaResourceChat'},

		'ISACTIVEALARM_TRUE' 			:	{type: "class", value: 'gridIcoAlarmEnabledTrue'},
		'ISACTIVEALARM_FALSE'			:	{type: "class", value: 'gridIcoAlarmEnabledFalse'},
		'ISAUTOACTIVATEALARM_TRUE'		:	{type: "class", value: 'gridIcoAlarmEnabledTrue'},
		'ISAUTOACTIVATEALARM_FALSE'		:	{type: "class", value: 'gridIcoAlarmEnabledFalse'},
		'ISLOGALARM_TRUE' 				:	{type: "class", value: 'gridIcoAlarmEnabledTrue'},
		'ISLOGALARM_FALSE'				:	{type: "class", value: 'gridIcoAlarmEnabledFalse'},
		'ISATRIBUTE_ENABLED_TRUE'		:	{type: "class", value: 'gridIcoAttributeEnabledTrue'},
		'ISATRIBUTE_ENABLED_FALSE'		:	{type: "class", value: 'gridIcoAttributeEnabledFalse'},
		
		
		'WRAPUP_TRUE_LIMITED'			:	{type: "class", value: 'gridIcoWrapUpTrueLimited'},
		'WRAPUP_TRUE_UNLIMITED'			:	{type: "class", value: 'gridIcoWrapUpTrueUnlimited'},
		'WRAPUP_FALSE'					:	{type: "class", value: 'gridIcoWrapUpFalse'},
		'ISVALIDCAMPAIGN_TRUE'			:	{type: "class", value: 'gridIcoValidTrue'},
		'ISVALIDCAMPAIGN_FALSE'			:	{type: "class", value: 'gridIcoValidFalse'},
		'ISACTIVECAMPAIGN_TRUE'			:	{type: "class", value: 'gridIcoActiveTrue'},
		'ISACTIVECAMPAIGN_FALSE'		:	{type: "class", value: 'gridIcoActiveFalse'},
		'DISCADOR_TRUE'					:	{type: "class", value: 'gridIcoDiscadorTrue'},
		'DISCADOR_FALSE'				:	{type: "class", value: 'gridIcoDiscadorFalse'},
		'INTERNALCHAT_TRUE'				:	{type: "class", value: 'gridIcoInternalChatTrue'},
		'INTERNALCHAT_FALSE'			:	{type: "class", value: 'gridIcoInternalChatFalse'},
		'USERSTATE_TRUE'				:	{type: "class", value: 'gridIcoUserStateTrue'},
		'USERSTATE_FALSE'				:	{type: "class", value: 'gridIcoUserStateFalse'},
		'BREAK_TRUE'					:	{type: "class", value: 'gridIcoBreakTrue'},
		'BREAK_FALSE'					:	{type: "class", value: 'gridIcoBreakFalse'},
		'OVERRIDE_TRUE'					:	{type: "class", value: 'gridIcoOverrideTrue'},
		'OVERRIDE_FALSE'				:	{type: "class", value: 'gridIcoOverrideFalse'},
		'DAYLIGHT_TRUE'					:	{type: "class", value: 'gridIcoDaylightTrue'},
		'DAYLIGHT_FALSE'				:	{type: "class", value: 'gridIcoDaylightFalse'},

		'ISACTIVE_PROCESS_TRUE'			:	{type: "class", value: 'gridIcoActiveTrue'},
		'ISACTIVE_PROCESS_FALSE'		:	{type: "class", value: 'gridIcoActiveFalse'},

		'REPORT_SUMMARY'				:	{type: "class", value: 'gridIcoSummaryTrue'},
		'REPORT_DETAIL'					:	{type: "class", value: 'gridIcoSummaryFalse'},

		'REDIAL_TRUE'					:	{type: "class", value: 'gridIcoRedialTrue'},
		'REDIAL_FALSE'					:	{type: "class", value: 'gridIcoRedialFalse'},

		'VIP_CONTACT_TRUE' 				:	{type: "class", value: 'gridIcoVipTrue'},
		'VIP_CONTACT_FALSE'				:	{type: "class", value: 'gridIcoVipFalse'},

		'ISCLIENT_CONTACT_TRUE' 		:	{type: "class", value: 'gridIcoClientTrue'},
		'ISCLIENT_CONTACT_FALSE'		:	{type: "class", value: 'gridIcoClientFalse'},

		'EXIST_SCRIPTING_APP' 			:	{type: "class", value: 'gridIcoScriptingAppTrue'},
		'NOT_EXIST_SCRIPTING_APP'		:	{type: "class", value: 'gridIcoScriptingAppFalse'},

//PAISES /////
		'FLAG_1'						:	{type: "class", value: 'gridFlag1'},
		'FLAG_54'						:	{type: "class", value: 'gridFlag54'},
		'FLAG_55'						:	{type: "class", value: 'gridFlag55'},
		'FLAG_598'						:	{type: "class", value: 'gridFlag598'}

	},
	//////////////////////////////////////////////////////////////////////////////////////////
	//
	Start: function(applicationName, pageId, divGridContainter, messageToWaiting, jsonColumns, jsonData, 
						permissionInQuery, events, actions, themeId, deletepermission, savepermission, renderpermission)
	{
		this.vars.applicationPath = this.vars.applicationPath.concat(applicationName);
		this.vars.urlBase = this.vars.urlBase.concat(applicationName);
		this.vars.pageId = pageId;
		this.vars.divGridContainer = divGridContainter;
		this.vars.jsonColumns = jsonColumns;
		this.vars.jsonData = jsonData;
		this.vars.permissionInQuery = (permissionInQuery === undefined ? true : permissionInQuery);
		this.vars.themeId = (themeId === undefined || themeId === "" ? this.vars.themeId : themeId);
		this.vars.deletepermission = deletepermission === undefined ? true : deletepermission;
		this.vars.savepermission = savepermission === undefined ? true : savepermission;
		this.vars.renderpermission = renderpermission === undefined ? true : renderpermission;
		actions.deletepermission = this.vars.deletepermission;
		actions.renderpermission = this.vars.renderpermission;

		this.InitializePathToMapped();
		this.ProcessingDocumentReady(this, messageToWaiting, events, actions);
	},
	//////////////////////////////////////////////////////////////////////////////////////////
	//
	InitializePathToMapped: function() {
		var path = this.vars.applicationPath + this.vars.imagesPath;
		for (var key in this.mappedCellOfValue) {
			if(this.mappedCellOfValue.hasOwnProperty(key)) {
				var cell = this.mappedCellOfValue[key];
				if (cell.type === "image") {
					cell.value = path + cell.value;
				}
			}
		}
	},
	//////////////////////////////////////////////////////////////////////////////////////////
	// Inicializa Grilla
	InitializeGrid: function () {
		//// Instanciando clase y abriendo grilla
		this.vars.gridObject = new CInconcertGrid(this.vars.nameGrid, this.vars.gridObjectName,
													this.vars.divGridContainer, this.vars.themeId);
		this.vars.serverEventsObject.Init(this.vars.pageId, this.vars.gridObject, this.vars.waitingObject, this.vars.urlBase, this);
		this.vars.gridObject.SetEvents(this.vars.actionsObject);
		var rowForPage = this.vars.jsonColumns.grid.other.rowsForPage;
		var maxNumberOfPage = this.vars.jsonColumns.grid.other.maxNumberOfPage;
		var numberOfRecords = this.vars.jsonData.__config.numberOfRecords;

		this.vars.gridObject.ConfigPaginated(rowForPage, maxNumberOfPage, numberOfRecords, this.vars.requestFunctionName);
		this.vars.gridObject.SetColumns(this.vars.jsonColumns);
		this.vars.gridObject.SetEventsFilter(this.vars.serverEventsObject.ajax.send.ApplyFilter,
												null, this.vars.serverEventsObject.ajax.send.SaveFilter);
		this.vars.gridObject.GetExternalTypeColumn = view_manager.GetExternalTypeColumn;
		this.vars.gridObject.SetMappedCellOfValue(view_manager.mappedCellOfValue);
		this.vars.gridObject.SetData(this.vars.jsonData);
		this.vars.gridObject.SetFilterApplied("ALL");
		this.vars.gridObject.SetWaitingObject(this.vars.waitingObject);
		this.vars.gridObject.HideInternalWaiting();
	},
	//////////////////////////////////////////////////////////////////////////////////////////
	//
	CheckPermissionButtons: function() {
		// si no tiene permiso de delete, no visualizo el botn de delete.
		if (!view_manager.vars.deletepermission) {
			jQuery(".gridButDelete").parent().addClass("turbogrid-cell-emtpy");
			jQuery(".gridButDelete").removeClass("gridButDelete").addClass("gridButEmpty");
		}
		// si no tiene permiso de render, no visualizo el boton de edit.
		if (!view_manager.vars.renderpermission) {
			jQuery(".gridButEdit").parent().addClass("turbogrid-cell-emtpy");
			jQuery(".gridButEdit").removeClass("gridButEdit").addClass("gridButEmpty");
		} // si no tiene permiso de save, cambio la imagen a mostrar en el boton edit.
		else if (!view_manager.vars.savepermission) {
			jQuery(".gridButEdit").removeClass("gridButEdit").addClass("gridButView");
		}
	},
	//////////////////////////////////////////////////////////////////////////////////////////
	// funcion que procesa el document.ready (llama funcion para inicializar la grilla)
	ProcessingDocumentReady: function(self, messageToWaiting, events, actions) {
		// document ready ///////////////////////////////////////////////////////////////////////////////
		jQuery(document).ready(function() {
			self.vars.actionsObject = actions; // objeto de eventos
			self.vars.serverEventsObject = events; // objeto de Eventos Manejador de eventos al Server
			// Objeto Manejador del Waiting 
			self.vars.waitingObject = new CInconcertWaiting(messageToWaiting, 'waitingDiv');
			// Inicializo Grilla
			self.InitializeGrid();

			jQuery(window).resize(function() {
				if (view_manager.vars.gridObject !== undefined) {
					view_manager.vars.gridObject.resizeGrid();
				}
				if (view_manager.vars.waitingObject !== undefined) {
					view_manager.vars.waitingObject.OnResize();
				}
			});
			self.CheckPermissionButtons();
		});
	},
	//////////////////////////////////////////////////////////////////////////////////////////
	// Funcion utilizada para visualizar el Tipo Externo de una columna
	//	Ej: En una primera instancias las subgrillas deber?an tener siempre el mismo tipo para cada columna de cada una de las subgrillas.
	//		O sea si una columna es de tipo 'IMAGE' (Esto sale del lua de la definicion de las columnas), se deberian
	//		ver siempre una imagen en cada una de las subgrillas.
	//		Con esta funci?n se puede cambiar el tipo a visualizar en la celda o segun el valor de una celda de la grilla padre.
	GetExternalTypeColumn: function(rowMain, columnId) {
		var typeOf;
		if (rowMain !== undefined) {
			if (columnId.toUpperCase() === "__OPEN") {
				typeOf = {'name': rowMain.Type.name, 'type': ''};

				switch(rowMain.Type.name) {
					case "CALL":
					case "VOICEMAIL":
						typeOf.type = "MEDIA";
					break;
					case "MAIL":
					case "FAX":
					case "CHAT":
						typeOf.type = "IMAGE";
					break;
				}
			}
		}
		return typeOf;
	},
	GetClassButtonGrid: function(data, field, column, row) {
		if (column === undefined) {
			return '';
		}
		if (typeof(column) === "string") {
			for (var key in data) {
				if (data[key] === column) {
					return data[key];
				}
			}
			return '';
		}
		else {
			var index = -1;
			var decrement = (column.m_parent.m_arrColumns[0].m_arrChildColumns === undefined ? 1 : 0);
			for (var i = 0;  i < column.m_parent.m_arrColumns.length; i++) {
				var columnByArray = column.m_parent.m_arrColumns[i];
				if (columnByArray.m_id.toLowerCase() !== field.toLowerCase()) {
					continue;
				}
				index = columnByArray.m_position - decrement;
				break;
			}
			var value = row[index];
			return (data[value] !== undefined ? data[value] : '');
		}
	}
};