/*global $ jQuery
*/
/**
 * @author Cany
 */

function CInconcertWaiting (message, divId, ownerName) {
	var self = this;
	this.m_divId = (divId === undefined ? 'waitingDiv' : divId);
	this.m_overlayDiv = this.m_divId + '_overlay';
	this.m_messageId = this.m_divId + '_message';
	this.m_cancelId = this.m_divId + '_cancel';	
	this.m_request = null;
	this.m_ownerName = ownerName;
//	this.m_opacityValue = 6; // este valor se multiplica por 10 para IE, y se divide entre 10 para otros navegadores.
							// Ej: Si dejamos el valor en 6 = 60% del color 40% transparencia.
							//	100% = no transparencia
	this.m_defaultMessage = (message !== undefined ? message : 'We\'re processing your request... please wait!');
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetDefaultMessage = function(){
		self.SetMessage(self.m_defaultMessage);
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetRequest = function(request){
		self.m_request = null;
		self.m_request = request;
	};
	this.AbortRequest = function() {
		if (self.m_request !== null && self.m_ownerName !== undefined) {
			self.m_request.abort();
			self.Hide();
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreateDivContainer = function (p_message) {
//		var opacitiyValueToIE = self.m_opacityValue * 10;
//		var opacitiyValueOthersBrowsers = self.m_opacityValue / 10;
		var message = (p_message === undefined ? self.m_defaultMessage : p_message);
		var htmlToWrite = '';

		htmlToWrite += '	<table width="100%" height="100%">';
		htmlToWrite += '		<tr>';
		htmlToWrite += '			<td align="center" style="vertical-align:top; padding-top:15px;">';
		htmlToWrite += '				<table width="310px" align="center" >';
		htmlToWrite += '					<tr>';
		htmlToWrite += '						<td class="inconcertWaitingText">';
		htmlToWrite += '							<b id="' + self.m_messageId + '">' + message + '</b>';
		htmlToWrite += '						</td>';
		htmlToWrite += '					</tr>';
		htmlToWrite += '					<tr>';
		htmlToWrite += '						<td align="center" style="vertical-align:top; padding-top:10px;" >';
		htmlToWrite += '							<img src="/inconcert/shared/waiting/images/waiting_animated.gif">';
		htmlToWrite += '						</td>';
		htmlToWrite += '					</tr>';
		if (self.m_ownerName !== undefined) {
			htmlToWrite += '					<tr id="' + self.m_cancelId + '" style="display:none;">';
			htmlToWrite += '						<td align="center" >';
			htmlToWrite += '							<a class="buttonWaitingCancel" href="#" onclick="' + self.m_ownerName + '.AbortRequest();return false;">' + '<%=_T("Cancel")%>' + '</a>';
			htmlToWrite += '						</td>';
			htmlToWrite += '					</tr>';
		}
		htmlToWrite += '				</table>';
		htmlToWrite += '			</td>';
		htmlToWrite += '		</tr>';
		htmlToWrite += '	</table>';

		var containerDiv = document.createElement('div');
		document.body.appendChild(containerDiv);
		if (containerDiv !== null) {
			containerDiv.id = self.m_divId;
			containerDiv.className = "inconcertWaitingDiv";
			containerDiv.innerHTML = htmlToWrite;
		}
		var overlayDiv= document.createElement('div');
		document.body.appendChild(overlayDiv);
		if (overlayDiv !== null) {
			overlayDiv.id = self.m_overlayDiv;
		}
		jQuery('#' + self.m_overlayDiv).addClass("inconcertWaitingOverlayDiv");
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.OnResize = function(e) {
		var overlayDiv = document.getElementById(self.m_overlayDiv);
		if (overlayDiv !== null) {
			overlayDiv.style.width = document.documentElement.clientWidth + 'px';
			overlayDiv.style.height = document.documentElement.clientHeight + 'px';
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.Hide = function() {
		self.m_request = null;
		self.ApplyShowOrHide(false);
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.Show = function() {
		var element = document.getElementById(self.m_cancelId);
		if (element !== null) {
			element.style.display = (self.m_request !== null) ? '' : 'none';
		}
		self.OnResize();
		self.ApplyShowOrHide(true);
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ApplyShowOrHide = function(isShow) {
        var value = (isShow === false ? 'none' : 'block');
        document.getElementById(self.m_divId).style.display = value;
        document.getElementById(self.m_overlayDiv).style.display = value;
    };
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetMessage = function(message) {
		if (document.getElementById(self.m_messageId) !== null && message !== undefined) {
			document.getElementById(self.m_messageId).innerHTML = message;
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ProcessingDocumentReady = function() {
		jQuery("body").keypress(function (e) {
			if (e.which === 27){
				self.AbortRequest(); 
			}
		});	
	};
	
	self.CreateDivContainer(message); // llamo funcion que crea el Div contenedor
	self.ProcessingDocumentReady();
}

