/*jslint nomen:false  evil:true */
/*global $ jQuery dojo turbo inconcert CInconcertFilter
*/

/**
 * @author Cany
 */
/*
este script depende de:
	/inconcert/lib/turbo/config.js
	/inconcert/lib/dojo/dojo.js
	/inconcert/lib/turbo/turbo.js
	/inconcert/lib/turbo/turbo.grid.js
	dojo.hostenv.writeIncludes();
	/inconcert/shared/WebGrid/styles/inconcertPaginated.css
	/inconcert/shared/Filter/scripts/inconcertFilter.js
	/inconcert/shared/scripts/inconcert.utils.js
*/

///////////////////////////////////////////////////////////
//
dojo.addOnLoad(function() {
	dojo.html.applyBrowserClass(document.body.parentNode);
});

///////////////////////////////////////////////////////////
//
function CInconcertGrid(gridId, objectName, divGridContainer, themeId) {
// properties ---------------------------------------------------------------------
	var self = this;
	this.m_gridId = gridId;
	this.m_objectName = objectName;	// es el nombre de la variable a la que me asignaron (ej. var pepito = new CInconcertGrid() , el objectName es 'pepito')
	this.m_divGridContainer = divGridContainer;
	this.m_themeId = themeId;

	this.m_events = undefined;
	this.m_data = [];
	this.m_globalData = [];
	this.m_jsonGlobalData = [];

	this.m_temporalGlobalData = undefined;
	this.m_jsonColumns = undefined;
	this.m_arrColumns = undefined;
	this.m_detailRows = [];

	this.m_rowsForPage = 0;
	this.m_maxNumberOfPage = 10;
	this.m_pagePosition = 1;
	this.m_requestFunctionName = undefined;

	this.m_requestFunction = undefined;
	this.m_numberOfInitialGroupPages = 0;
	this.m_numberOfFinalGroupPages = 0;
	this.m_canCreateControlsOfThePaginated = true;
	this.m_currentBodyHeight = window.innerHeight;
	this.m_currentBodyWidth = window.innerWidth;

	/*estilo de los headers y datos */
	this.m_styleHeaderGrid = undefined;
	this.m_styleHeaderSubGrid = undefined;
	this.m_styleDataGrid = undefined;
	this.m_styleDataSubGrid = undefined;
	// esto es utilizado para mapear el tipo de dato con el valor a mostar en la celda (ejemplo: tipo de dato = "CALL" se muestra en la celda 'images/telephone.gif'
	this.m_mappedCellOfValue = undefined;

	this.m_webGridPath = '/inconcert/shared/webgrid/';
	// Esta prop sirve para saber si el filtro esta expandido/contraido
	//this.m_webGridPath = (webPath === undefined ? '' : webPath + 'WebGrid/');
	//this.m_filterPath = (webPath === undefined ? '' : webPath + 'Filter/');
	this.m_waiting = undefined;
	this.m_ordering = false;
	//////////////

	//objeto manejador del filtro
	this.m_filterManager = undefined;

	if(!document.getElementById(self.m_divGridContainer)) {
		throw("CInconcertGrid: The container element for the grid does not exist");
	}

	// inicializo array que va a contener cada uno de las grillas
	// aca tendria que ver como puedo usar variables de clase en vez de zamparle este valor a dojo que no tiene nada que ver
	if (dojo.myGrid === undefined) {
		dojo.myGrid = []; // inicializo array Dojo
		dojo.gridCount = 0;
	}
	else {
		alert('dojo.myGrid ya existe');
	}
	dojo.gridCount++;

	// Tabla que contiene los estilos a aplicar en los header y datos de la grillas /////////////////////////////////////////////
	// ya que en internet Explorer y opera no funciona el leer utilizando 'cssRules'
	// Esta se puede setear externamente llamando a la funcion -> (SetCssStyleGrid)
	this.m_tableCssStyleProperties = [
		{ name: 'color' },
		/*{ name: 'font-size' },*/
		{ name: 'font-weight' },
		{ name: 'font-style' }
	];

	// events to track /////////////////////////////////////////////
	this.m_eventRows = [
		{ name: 'onCellClick' },
		{ name: 'onRowClick', properties: ['rowIndex'] },
		{ name: 'onCellDblClick' },
		{ name: 'onRowDblClick', properties: ['rowIndex'] },
		{ name: 'onCellMouseOver' },
		{ name: 'onCellMouseOut' },
		{ name: 'onRowMouseOver' },
		{ name: 'onRowMouseOut' },
		{ name: 'onHeaderCellClick' },
		{ name: 'onHeaderClick', properties: ['rowIndex'] },
		{ name: 'onHeaderCellDblClick' },
		{ name: 'onHeaderDblClick', properties: ['rowIndex'] },
		{ name: 'onHeaderCellMouseOver' },
		{ name: 'onHeaderCellMouseOut' },
		{ name: 'onHeaderMouseOver' },
		{ name: 'onHeaderMouseOut' },
		{ name: 'onKeyDown', properties: ['keyCode'] },
		{ name: 'onCellContextMenu' },
		{ name: 'onRowContextMenu', properties: ['rowIndex'] },
		{ name: 'onHeaderCellContextMenu' },
		{ name: 'onHeaderContextMenu', properties: ['rowIndex'] }
	];

// classes ---------------------------------------------------------------------
	// clase columna
	this.CColumn = function (oneColumn, parent, position, arrChildColumns, events) {
		var self = this;
		this.m_parent = parent;
		this.m_arrChildColumns = arrChildColumns;
		this.m_position = position;
		this.m_index = 0;
		this.m_events = events;
		this.m_id = oneColumn.__id;
		this.m_name = oneColumn.caption;
		this.m_width = oneColumn.width;
		this.m_rowSpan = oneColumn.rowSpan;
		this.m_colSpan = oneColumn.colSpan;
		this.m_noresize = (oneColumn.noresize === undefined ? true: oneColumn.noresize);
		this.m_styles = (oneColumn.styles === undefined ? '' : oneColumn.styles);
		this.m_typeOf = oneColumn.typeOf;
		this.m_layout = oneColumn.layout;
		this.m_scroll = oneColumn.scroll;
		this.m_identicalHeightOfColumnsRight = oneColumn.identicalHeightOfColumnsRight;
		this.m_classNameHeader = oneColumn.classNameHeader;
		this.m_classNameData = oneColumn.classNameData;
		this.m_orderBy = oneColumn.orderBy;

		///////////////////////////////////////////////////////////
		//
		this.SetPosition = function (position){
			this.m_position = position;
		};
		///////////////////////////////////////////////////////////
		//
		this.getName = function (inRow, inCell) {
			var row = self.m_parent.m_data[inRow.index % self.m_parent.m_data.length];
			var ret = "";
			var positionInArray = self.m_position - 1;
			if (positionInArray === -1) {
				positionInArray = 0;
			}
			var fieldPosition = self.m_position;
			if (self.m_parent.m_jsonColumns.grid.subGrid === undefined) {
				fieldPosition = ((fieldPosition -1) < 0 ? 0 : fieldPosition - 1);
			}
			try {
				ret = row[fieldPosition];
			}
			catch(err) {
			}
			ret = self.m_parent.FormatedType(self, ret, positionInArray, inRow, undefined, row);

			return ret;
		};

		///////////////////////////////////////////////////////////
		//
		this.getDetailData = function (inRow, inCell) {
			var row = self.m_parent.m_data[inCell.grid.dataRow % self.m_parent.m_data.length][self.m_index];
			var ret = "";
			var rowMain = self.m_parent.m_jsonGlobalData[0][inCell.grid.dataRow];

			try {
				ret = row[inRow.index][inCell.index];
			}
			catch(err) {
			}
			var rowMainOfSubGrid = self.m_parent.m_data[inCell.grid.dataRow % self.m_parent.m_data.length][0];
			var lengthOfArraySubRow = rowMainOfSubGrid[inRow.index].length - 1;
			// en esta posicion (la ultima de la fila del array) esta agreado el objeto (json)
			//correspondiente a la tabla con que se han lleando las filas del subgrid (se ha agregado en la funcion FillSubGrid)
			var jsonSubRow = rowMainOfSubGrid[inRow.index][lengthOfArraySubRow];
			var subColumn = self.m_parent.m_arrColumns[0].m_arrChildColumns[inCell.index];
			return self.m_parent.FormatedType(subColumn, ret, 0, inRow, inCell, rowMain, jsonSubRow);
		};
	};
	// fin clase columna ///////////////////////////////////////////////

	//Functions --------------------------------------------------------------------

	// funciones privadas ------------------------------------------------

	/**
	Ordena una colección de columnas, según su property 'ordinal'
	*/
	var SortColumns = function(columns){
		var sortedColumns = [];
		for(var key in columns) {
			if(columns.hasOwnProperty(key)) {
				sortedColumns[columns[key].ordinal] = { key: key, value: columns[key] };
			}
		}
		return sortedColumns;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	var GetNumberOfColSpanInArray = function(arrOrigen) {
		var numberOfColSpan = 0;
		for (var j = 0; j< arrOrigen.length; j++) {
			if (arrOrigen[j].m_layout !== undefined) {
				if (arrOrigen[j].m_layout.toUpperCase() === "DOWN") {
					numberOfColSpan++;
				}
			}
		}
		return numberOfColSpan;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	var IsRowSpanOfFirstColumnGreaterThanOne = function(arrOrigen) {
		if (arrOrigen[0] !== undefined && arrOrigen[0].m_rowSpan !== undefined) {
			if (arrOrigen[0].m_rowSpan > 1) {
				return true;
			}
		}
		return false;
	};

	// funciones públicas ------------------------------------------------

	//////////////////////////////////////////////////////////////////////////////
	// Setea a la grilla el Theme a visualizar
	this.SetTheme = function (p_themeId) {
		var themeId = (p_themeId !== undefined ? p_themeId : self.m_themeId);
		if (themeId !== undefined) {
			var grid = dojo.widget.byId(self.m_gridId);
			if (grid !== undefined) {
				grid.setTheme(themeId);
			}
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	// Retorna el filtro seleccionado
	this.GetCurrentFilter = function () {
		var filterToReturn;
		if (self.m_filterManager !== undefined) {
			filterToReturn = self.m_filterManager.GetCurrentFilter();
		}
		return filterToReturn;
	};
	//////////////////////////////////////////////////////////////////////////////
	// Retorna el filtro que se ha aplicado
	this.GetAppliedFilter = function () {
		var filterToReturn;
		if (self.m_filterManager !== undefined) {
			filterToReturn = self.m_filterManager.GetAppliedFilter();
		}
		return filterToReturn;
	};
	//////////////////////////////////////////////////////////////////////////////
	//	retorna la cantidad de rows existentes en el json de la grilla principal
	this.GetDataGridLength = function () {
		var data = self.m_jsonGlobalData;
		if(data && data[0]) {
			return data[0].length;
		}
		return 0;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetFilterApplied = function(filterApplyed) {
		if (self.m_filterManager !== undefined) {
			self.m_filterManager.SetFilterApplied(filterApplyed);
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetWaitingObject = function(waiting) {
		self.m_waiting = waiting;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ShowWaitingMessageToChangedPage = function(numberPage) {
		if (self.m_waiting !== undefined) {
			self.m_waiting.SetMessage('Go to page number ' + numberPage);
			self.m_waiting.Show();
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ShowInternalWaiting = function() {
		self.m_ordering = true;
		self.ShowOverlay();
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.HideInternalWaiting = function() {
		self.m_ordering = false;
		self.HideOverlay();
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.ShowOverlay = function() {
		var elementOverlay = document.getElementById(self.m_gridId + '_overlay');
		if (elementOverlay !== null && elementOverlay.style.display === 'none') {
			elementOverlay.style.display = "";
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.HideOverlay = function() {
		var elementOverlay = document.getElementById(self.m_gridId + '_overlay');
		if (elementOverlay !== null && elementOverlay.style.display === '') {
			elementOverlay.style.display = "none";
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetCssStyleGrid = function (tableCssStyleProperties) {
		this.m_tableCssStyleProperties = tableCssStyleProperties;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetHtmlPlayer = function (row, player, columnWidth, columnHeight) {
		return ((self.m_mappedCellOfValue) && (self.m_mappedCellOfValue.PLAYER) &&
				   (self.m_mappedCellOfValue.PLAYER.GetHtmlPlayer) ? self.m_mappedCellOfValue.PLAYER.GetHtmlPlayer(row, player.src) : '' );
	};

	//////////////////////////////////////////////////////////////////////////////
	//	funcion que se implementa en el html que se instancia
	this.GetExternalTypeColumn = function () {
		var ret;
		return ret;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetDataValue = function (value, typeOfRowMain, column, row) {
		if (column !== undefined) {
			var mappedColumn = self.m_mappedCellOfValue[column.m_id.toUpperCase()];
			if (mappedColumn !== undefined) {
				if (typeof(mappedColumn.value) === "function") {
					return mappedColumn.value(column, row);
				}
				return mappedColumn.value;
			}
		}
		var valueToReturn = '';
		if (value === undefined) {
			return valueToReturn;
		}
		if (value.className !== undefined) {
			valueToReturn = value.className;
		}
		else if (self.m_mappedCellOfValue !== undefined) {
			var id = '';
			if (value.inheritedType && typeOfRowMain !== undefined) {
				id = id.concat(typeOfRowMain.name, '_CHILD');
			}
			else {
				if (value.name !== undefined) {
					id += (isNaN(value.name) ? value.name.toUpperCase() : value.name);
				}
			}
			if (self.m_mappedCellOfValue[id] !== undefined) {
				valueToReturn = self.m_mappedCellOfValue[id].value;
			}
		}
		return valueToReturn;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.ImageOnMouseOverOrOnMouseOut = function(element, row, name, columnId) {
		if (element.className.search('-ds') > 0) {
			return;
		}
		if (self.m_mappedCellOfValue[columnId] !== undefined) {
			var className = (typeof(self.m_mappedCellOfValue[columnId].value) === 'function' ? self.m_mappedCellOfValue[columnId].value(element.className) :
								self.m_mappedCellOfValue[columnId].value);
			if (element.className === className) {
				element.className = element.className + '-ov';
			}
			else {
				element.className = element.className.replace(/-ov/g, '');
			}
		}

		// dentro de este if hago el over a las imagenes normalmente, tiene que existir una definicion con over
  		if (row === undefined) {
			var withOutOverId = name;
			var overId = withOutOverId.concat('_OVER');
			if (self.m_mappedCellOfValue[withOutOverId] !== undefined && self.m_mappedCellOfValue[overId] !== undefined) {
				var classNameOver = self.m_mappedCellOfValue[overId].value;
				var classNameWithOutOver = self.m_mappedCellOfValue[withOutOverId].value;

				element.className = (element.className === classNameOver ? classNameWithOutOver : classNameOver);
			}
			return;
		}
		// fuera del if anterior hago over a las columnas de las subgrilla que heradan el tipo del padre
		//	(caso storedplayer chat, fax, mail)
		var id = '';
		var classNameOver;
		var classNameOut;
		id = id + row + '_CHILD';
		if (self.m_mappedCellOfValue[id] !== undefined) {
			classNameOver = self.m_mappedCellOfValue[id].value;
		}
		id = id + '_OVER';
		if (self.m_mappedCellOfValue[id] !== undefined) {
			classNameOut = self.m_mappedCellOfValue[id].value;
		}

		if (classNameOver === undefined || classNameOut === undefined) {
			return;
		}
		 if (element.className.search(classNameOut) > -1) {
		 	element.className = classNameOver;
		 }
		else {
			if (element.className.search(classNameOver) > -1) {
				element.className = classNameOut;
			}
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.FormatedType = function (myColumn, value, indexColumn, inRow, inCell, rowMain, jsonSubRow) {
		var typeOf;
		var typeOfName = '';
		var ret = value;
		var arrOrigen;
		var isSubGrid = false;

		if (ret === null) {
			return '';
		}
		if (self.m_arrColumns[indexColumn] === undefined) {
			return value;
		}
		if (inCell === undefined) {
			typeOf = self.m_arrColumns[indexColumn].m_typeOf;
			arrOrigen = self.m_arrColumns[indexColumn];
		}
		else {
			if (self.m_arrColumns[indexColumn].m_arrChildColumns === undefined) {
				return value;
			}
			if (self.m_arrColumns[indexColumn].m_arrChildColumns[inCell.index] === undefined) {
				return value;
			}
			typeOf = self.m_arrColumns[indexColumn].m_arrChildColumns[inCell.index].m_typeOf;
			arrOrigen = self.m_arrColumns[indexColumn].m_arrChildColumns[inCell.index];
			isSubGrid = true;
		}

		if (typeOf !== undefined) {
			var typeOfRowMain = self.GetExternalTypeColumn(rowMain, arrOrigen.m_id);

			if (typeOfRowMain === undefined) {
				typeOfName = typeOf.id.toUpperCase();
			}
			else {
				typeOfName = typeOfRowMain.type;
			}
			// IMAGEN ///////////////////////////////////////
			if (typeOfName === "IMAGE") {
				var columnWidth;
				if (typeOf.width !== undefined) {
					columnWidth = typeOf.width;
				}
				else {
					columnWidth = inCell.unitWidth;
				}
				var height = '';
				if (typeOf.height !== undefined) {
					height = ' height ="'.concat(typeOf.height, '"');
				}
				var columnBorder = 0;
				if (typeOf.border !== undefined) {
					columnBorder = typeOf.border;
				}
				var objectToSend;
				if (typeOfRowMain !== undefined) {
					objectToSend = typeOfRowMain.name;
				}
				else {
					objectToSend = typeOfRowMain;
				}
				var src = self.GetDataValue(value, typeOfRowMain);
				var display = '';
				if (src !== undefined) {
					display = (src.length > 0 ? '' : 'none');
				}
				ret = ''.concat(
					'<img src="', src, '" style="display:', display, '; "',
						' border="', columnBorder, '"',
						' width ="', columnWidth, '"',
						height,
					' / >',
					'<span>', value.value, '</span>');
			}			// CLASS Utilizado para ver imagenes ///////////////////////////////////////
			else if (typeOfName === "IMAGECLASS") {
				var objectToSend;
				if (typeOfRowMain !== undefined) {
					objectToSend = typeOfRowMain.name;
				}
				else {
					objectToSend = typeOfRowMain;
				}
				var className = self.GetDataValue(value, typeOfRowMain, myColumn, rowMain);
				var valueName = (value === undefined ? '' : value.name);
				var spanValue = (value === undefined ? '' : (value.value === undefined ? '' : value.value));
				
				var columnId = myColumn.m_id.toUpperCase();
				ret = ''.concat(
					'<img',
						' id="', self.m_objectName, '_', inRow.index, '_', indexColumn , '"',
						' class="', className, '"',
						' src="', self.m_webGridPath, 'images/blank.gif"',
						' onMouseOver="', self.m_objectName, '.ImageOnMouseOverOrOnMouseOut(this, \'', objectToSend, '\', \'', valueName, '\', \'', columnId, '\');return false;"',
						' onMouseOut="' + self.m_objectName, '.ImageOnMouseOverOrOnMouseOut(this, \'', objectToSend, '\', \'', valueName, '\', \'', columnId, '\');return false;"',
					' / >',
					'<span>', spanValue, '</span>');
			}
			else if (typeOfName === "MONEY") {
				ret = '$' + parseFloat(ret).toFixed(2);
			}
			else if (typeOfName === "BOOLEAN") {
				ret = '<input type="checkbox" ' + (ret ? 'checked="checked"' : '') + ' ></input>';
			}
			else if (typeOfName === "DATE") {
				var d = new Date(ret);
				ret = turbo.printf('%s/%s/%s', d.getMonth(), d.getDate(), d.getFullYear());
			}
			else if (typeOfName === "LINK") {
				var linkToReplace = '<a class = "inconcertLink" href="{href}">{text}</a>';
				var values = {href: ret, text: ret};
				if (typeof(ret) === "object") {
					values.href = ret.href;
					values.text = ret.text;
				}
				ret =  turbo.supplant(linkToReplace, values);
			}
			else if (typeOfName === "MEDIA") {
				var columnWidth;
				if (typeOf.width !== undefined) {
					columnWidth = typeOf.width;
				}
				else {
					columnWidth = inCell.unitWidth;
				}
				var columnHeight;
				if (typeOf.height !== undefined) {
					columnHeight =  typeOf.height;
				}
				else {
					columnHeight = parseInt(inCell.unitWidth, 10) / 2 + ("px");
				}
				var media = "";
				media = self.GetHtmlPlayer(jsonSubRow, ret, columnWidth, columnHeight);
				ret = media;
			}
		}
		if (typeOfName === '' || typeOfName === 'MONEY' || typeOfName === 'DATE') {
			var selectorName = arrOrigen.m_classNameData;
			var dataStyle = '';
			if (selectorName !== undefined) {
				dataStyle = self.GetCssStyle(selectorName);
			}

			ret = '<div style=\'' + dataStyle + '\'>' + ret + '</div>';
		}

		if (arrOrigen.m_scroll !== undefined) {
			ret = '<div class="text-scrolling" style="height: 100%; width: 100%">' + ret + '</div>';
		}
		return ret;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreateGrid = function() {
		return ''.concat(
			'<div class="formGrid">',
				'<div id="' + self.m_gridId + '_div">',
					'<div id="' + self.m_gridId + '" dojoType="TurboGrid" model="model" structure=' + self.m_gridCells + ' rowCount="0"  elasticView="2">',
					'</div>',
				'</div>',
				self.GetHtmlGridOverlay(),
			'</div>');
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetEvents = function (events) {
		self.m_events = events;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetMappedCellOfValue = function(mappedCellOfValue) {
		self.m_mappedCellOfValue = mappedCellOfValue;
	};
	//////////////////////////////////////////////////////////////////////////////
	// asigno evento al textbox de ir a pagina
	this.SetEventsInControls = function() {
		jQuery(document).keyup(function(event){
			if (event.keyCode === 13) {
				eval(self.m_objectName).GotoPage();
			}
		});
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetEventsFilter = function(functionExecutionOfTheFilter, functionResetFilter, functionSendFilterToServer) {
		if (self.m_filterManager !== undefined) {
			self.m_filterManager.SetEventsFilter(functionExecutionOfTheFilter, functionResetFilter, functionSendFilterToServer);
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.HideExpandContractSubGrid = function() {
		if (self.m_jsonColumns.grid.subGrid === undefined) {
			var value = (dojo.render.html.ie ? 0 : -1);
			self.m_gridCells[0].cells[0][0].width = value;
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.gridEvents = {
		orderBy: function(row, subRowObject, field, subRowIndex, objInconcertGrid, colIndex) {
			if (colIndex === undefined || colIndex === null || isNaN(colIndex)) {
				return;
			}
			if (dojo.widget.byId(self.m_gridId).rowCount === 0) {
				return;
			}
			if (self.m_filterManager === undefined) {
				return;
			}
			var applyedFilter = self.m_filterManager.GetAppliedFilter();
			if (applyedFilter === undefined) {
				return;
			}
			if (self.m_arrColumns[colIndex].m_orderBy === undefined) {
				self.HideInternalWaiting();
				return;
			}
			self.m_arrColumns[colIndex].m_orderBy.ascendent = !self.m_arrColumns[colIndex].m_orderBy.ascendent;
			self.m_filterManager.SetOrderBy(self.m_arrColumns[colIndex].m_orderBy);
			var filter = self.m_filterManager.GetCurrentFilter(true);
			if (filter === undefined) {
				filter = {"__orderBy": self.m_arrColumns[colIndex].m_orderBy};
			}
			self.ShowInternalWaiting();
			self.m_filterManager.ApplyFilter(filter, false);
		}
	};

	/**
	Implicitamente, esta funcion crea los elementos necesarios en el DOM para que dojo cree la grilla propiamente dicha
	*/
	this.SetColumns = function(jSonColumns) {
		self.m_jsonColumns = jSonColumns;

		// ordeno las columnas, se guarda en un array y cada elemento del array pasa a ser un objeto {key, value}
		//  Se sigue mantinendo le objeto de columna original, ya que hay lugares donde se accede al nombre de la columna directamente.
		self.m_jsonColumns.grid.arrColumns = SortColumns(self.m_jsonColumns.grid.columns);

		var arrColumns = [];
		var colIndex = 0;
		var genericEvents = jSonColumns.grid.events;
		//mismo tamaño de la primera celda para todas las grillas
		//self.m_gridCells[0].cells[0][0].width = 2;
		//self.HideExpandContractSubGrid();

		for (var i = 0; i < self.m_jsonColumns.grid.arrColumns.length - 1; i++) {
			var column = self.m_jsonColumns.grid.arrColumns[i + 1];
			var oneColumn = column.value;
			oneColumn.__id = column.key;

			if (typeof(oneColumn) !== "object" || oneColumn.not_show === true) {
				continue;
			}

			var hasSubGrid = true;
			if (colIndex === 0) {
				if (jSonColumns.grid.subGrid === undefined || typeof(jSonColumns.grid.subGrid.subColumns) !== "object") {
					hasSubGrid = false;
				}
				else {
					oneColumn.subColumns = jSonColumns.grid.subGrid.subColumns;
				}
			}

			var arrSubColumns = undefined;
			if (typeof(oneColumn.subColumns) === "object") {
				arrSubColumns = [];
				var subColIndex = 0;
				oneColumn.subColumns = SortColumns(oneColumn.subColumns);

				for (var j = 0; j < oneColumn.subColumns.length - 1; j++) {
					var subColumn = oneColumn.subColumns[j + 1];
					var oneSubColumn = subColumn.value;
					oneSubColumn.__id = subColumn.key;

					if (typeof(oneSubColumn) !== "object" || oneSubColumn.not_show === true) {
						continue;
					}
					//Mapeo eventos con funciones (subColumns)
					var eventsSubColumn = {};
					// Eventos genéricos
					if (typeof(genericEvents) === "object") {
						for (var keyEvent in genericEvents) {
							if (typeof(genericEvents[keyEvent]) === "string") {
								try {
									// mapeo evento con el objeto de eventos que me pasaron por parametro (self.m_events)
									eventsSubColumn[keyEvent] = inconcert.utils.GetProperty(self.m_events, genericEvents[keyEvent]);
								}
								catch(err) {
									// si la funcion no existe en el mapeo anterior, busco mapear en la propia grilla.
									if (eventsSubColumn[keyEvent] === undefined) {
										eventsSubColumn[keyEvent] = inconcert.utils.GetProperty(eval(self.m_objectName), genericEvents[keyEvent]);
									}
								}
							}
						}
					}
					//Eventos de la columna
					if (typeof(oneSubColumn.events) === "object") {
						for (var keyEvent in oneSubColumn.events) {
							if (typeof(oneSubColumn.events[keyEvent]) === "string") {
								eventsSubColumn[keyEvent] = inconcert.utils.GetProperty(self.m_events, oneSubColumn.events[keyEvent]);
							}
						}
					}
					////////////
					if (typeof(oneSubColumn) === "object") {
						var objSubColumn = new self.CColumn(oneSubColumn, self, subColIndex, null, eventsSubColumn);
						arrSubColumns[subColIndex] = objSubColumn;
						subColIndex++;
					}
				}
			}
			//Mapeo eventos con funciones (columnas)
			var events = {};
			// Eventos genéricos
			if (typeof(genericEvents) === "object") {
				for (var keyEvent in genericEvents) {
					if (typeof(genericEvents[keyEvent]) === "string") {
						try {
							// mapeo evento con el objeto de eventos que me pasaron por parametro (self.m_events)
							events[keyEvent] = inconcert.utils.GetProperty(self.m_events, genericEvents[keyEvent]);
						}
						catch(err) {
							// si la funcion no existe en el mapeo anterior, busco mapear en la propia grilla.
							if (events[keyEvent] === undefined)	{
								events[keyEvent] = inconcert.utils.GetProperty(eval(self.m_objectName), genericEvents[keyEvent]);
							}
						}
					}
				}
			}
			//Eventos de la columna
			if (typeof(oneColumn.events) === "object") {
				for (var keyEvent in oneColumn.events) {
					if (typeof(oneColumn.events[keyEvent]) === "string") {
						try {
							// mapeo evento con el objeto de eventos que me pasaron por parametro (self.m_events)
							events[keyEvent] = inconcert.utils.GetProperty(self.m_events, oneColumn.events[keyEvent]);
						}
						catch (err) {
							// si la funcion no existe en el mapeo anterior, busco mapear en la propia grilla.
							if (events[keyEvent] === undefined) {
								events[keyEvent] = inconcert.utils.GetProperty(eval(self.m_objectName), oneColumn.events[keyEvent]);
							}
						}
					}
				}
			}
			//////////////
			var position = colIndex;
			if (hasSubGrid === true){
				position++; // la posicion para leer cambia, si tiene o no subgrid
			}
			var objColumn = new self.CColumn(oneColumn, self, position, arrSubColumns, events);
			arrColumns[colIndex] = objColumn;
			colIndex++;
		}

		if (colIndex === 0) {
			return;
		}
		// seteo array de columnas a array del objeto
		self.m_arrColumns = arrColumns;
		// Creo Tabla principal (Abro)
		var htmlToWriting = '<div id = "inconcertGrid' + dojo.gridCount + '">';

		//Creo Filtros
		self.m_filterManager = new CInconcertFilter(undefined, jSonColumns.grid.filter);
		var htmlFilter = self.m_filterManager.BuildFilters();
		if (htmlFilter.length > 0) {
			htmlToWriting += htmlFilter;
		}

		// Llamo funcion para crear arrays de la grilla
		self.CreateColumns(arrColumns);

		//Inserto TAG para agregar la Grilla de TurboGrid
		var htmlGrid = self.CreateGrid();
		htmlToWriting += htmlGrid;
		// Agrego fila de la tabla correspondiente a el paginado
		htmlToWriting += self.GetHtmlPaginatedContainer();
		// Cierro Tabla principal
		htmlToWriting += '</div>';

		//escribo html en pagina
		var divGrid = document.getElementById(self.m_divGridContainer);
		divGrid.innerHTML = htmlToWriting;

		if (htmlFilter.length > 0) {
			// seteo evento expand contract filter
			self.m_filterManager.SetFunctionExpandContractFilter();
			self.m_filterManager.FillFilterList(jSonColumns.grid.filter.filtersList); // Lleno combo de filtros disponibles
			self.SetEventsInControls();
			self.m_filterManager.SetEventsInFilterButtons();
			self.m_filterManager.SetEventsInFilterFields(jSonColumns.grid.filter.filtersList);
			self.m_filterManager.BuildExternalControls();
		}

		// Le seteo al array global (mio) de objetos, la grilla actual, que soy yo
		dojo.myGrid[self.m_gridId] = self;

		// ahora, hacemos que dojo transforme el container en el Widget
		var parser = new dojo.xml.Parse();
		var fragment = parser.parseElement(divGrid, null, true);
		dojo.widget.getParser().createComponents(fragment);

		// y recién ahora, le seteo la estructura a la grilla
		var widget = dojo.widget.byId(self.m_gridId);
		widget.setStructure(self.m_gridCells);

		self.setGridEvents(widget);
		widget.m_initialGridHeight = widget.height;
		widget.m_initialGridWidth = widget.width;

		// Esto sirve porque en IE la grilla de TurboGrid, cuando no se le setean datos
		// igual muestra rows vacios, osea nunca queda vacia la grilla.
		// Esto no sucede asi en Firefox. Entonces este codigo solo sirve para IE
		if (self.GetDataGridLength() === 0) {
			self.SetRowCount(0);
			self.toggleStructure();
		}
		//este metodo es MIO, lo agreo a turbogrid para que muestre las flechitas del oreder solo en las columnas que tienen byorder.
		widget.setColumnsWithOrder(self.GetColumnsWithByOrder());
		// seteo el tema a visualizar en la grilla
		self.SetTheme();
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetHtmlGridOverlay = function() {
		return '<div id="' + self.m_gridId + '_overlay" class="gridOverlay" style="display:none;" />';
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetColumnsWithByOrder = function() {
		var columnsWithOrder = {gridName: self.m_gridId, 0: false};
		for(var i = 0; i < self.m_arrColumns.length; i++) {
			columnsWithOrder[i+1] = (self.m_arrColumns[i].m_orderBy !== undefined ? true : false);
		}
		return columnsWithOrder;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GotoPage = function() {
		var element = document.getElementById(self.m_gridId.concat('_gotoPage'));
		if (element === null || isNaN(element.value)) {
			return;
		}
		if (element.value <= 0 || element.value > self.m_numberOfPages) {
			return;
		}
		eval(self.m_requestFunctionName.concat('(', element.value, ', 3)'));
		element.value = "";
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetHtmlPaginatedContainer = function() {
		var htmlPaginated = '';
		if (self.m_rowsForPage > 0) {
			var gotoPageCaption = (self.m_jsonColumns.grid.translate === undefined ?
										'' : self.m_jsonColumns.grid.translate.gotoPage === undefined ? '' :
										self.m_jsonColumns.grid.translate.gotoPage);
			htmlPaginated = ''.concat(
				'<div class="gridPaginated">',
					'<div class="gridPaginatedRegistry">',
						'<label id="', self.m_gridId,  '_paginatedLabel"></label>',
					'</div>',
					'<div id="', self.m_gridId,  '_paginated" class="gridPaginatedControl">',
					'</div>',
					'<div id="', self.m_gridId, '_gotoPageContainer" class="gridPaginatedGoPage" style="display:none;">',
						'<div class="gridPaginatedGoPageLabel">',
							'<label>', gotoPageCaption, '</label>',
						'</div>',
						'<div class="gridPaginatedGoPageField">',
							'<input id="', self.m_gridId, '_gotoPage" type="text"',
							'/></div>',
						'<div class="gridPaginatedGoPageButton">',
							'<a href="#"',
								' onclick="', self.m_objectName, '.GotoPage();"',
							'>',
								'<img class="butGoToPage" src="', self.m_webGridPath, 'images/blank.gif"/>',
							'</a>',
						'</div>',
					'</div>',
				'</div>');
		}
		// Cierro Tabla principal
//		htmlPaginated += '</div>';
		return htmlPaginated;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetCssStyle = function (selectorName) {
		// Leer los estilos de esta forma únicamente sirve para (Firefox, NetScape, Flock, safari)
		var cssStyle = '';
		var mySelectorName = '.' + selectorName;
		if (!document.all) { //(Firefox, NetScape, Flock, safari)
			for (var i = 0; i < document.styleSheets.length; i++ ) {
				var cssRules;
				cssRules = document.styleSheets[i].cssRules;
				for (var y = 0; y < cssRules.length; y++ ) {
					var rule = cssRules[y];
					if (rule.selectorText.toUpperCase() === mySelectorName.toUpperCase()) {
						var patronRegExp = new RegExp(mySelectorName + ".{", "gi");
						cssStyle = rule.cssText;
						cssStyle = cssStyle.replace(patronRegExp, "");
						cssStyle = cssStyle.replace(/\}/ig, "");
						break;
					}
				}
			}
		}
		else if (cssStyle.length === 0) { // Si es (IE, Opera)
			if (typeof(self.m_tableCssStyleProperties) === "object") {
				var elementId = '#style_' + self.m_objectName + '_' + selectorName;
				jQuery.each(self.m_tableCssStyleProperties, function(i, object){
				  cssStyle += (object.name + ': ' + jQuery(elementId).css(object.name) + '; ');
				});
			}
		}
		return cssStyle;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreateColumns = function (arrColumns) {
		// grid structure
		// a grid view is a group of columns
		var newElement;
		var selectorName;
		for (var i = 0; i< arrColumns.length; i++) {
			var column = arrColumns[i];
			selectorName = column.m_classNameHeader;
			var styleHeaderGrid = '';
			if (selectorName !== undefined) {
				styleHeaderGrid = self.GetCssStyle(selectorName);
			}
			styleHeaderGrid += column.m_styles;
			var newElement = { name: "<div>" + column.m_name + "</div>", get: column.getName, width: column.m_width,
								events: column.m_events, styles: styleHeaderGrid,
								noresize: column.m_noresize};

			self.m_gridCells[2].cells[0].push(newElement);
			var childColumns = column.m_arrChildColumns;
			if (childColumns !== undefined) {
				var styleHeaderSubGrid = '';
				newElement = {	name: '<div></div>', get: self.getDetail, colSpan: arrColumns.length + 1,
								styles:  styleHeaderSubGrid};
				self.m_gridCells[2].cells[1].push(newElement);

				var numberOfColSpan = GetNumberOfColSpanInArray(childColumns);
				var numberElementOfArray = childColumns.length;
				if (IsRowSpanOfFirstColumnGreaterThanOne(childColumns) === true) {
					numberElementOfArray--;
				}
				var sizeOfColSpan = parseInt((((numberElementOfArray) - numberOfColSpan) / numberOfColSpan), 10);
				var hasOneIncrementLastColSpan = false;
				if ((sizeOfColSpan * numberOfColSpan) !== (numberElementOfArray - numberOfColSpan)) {
					hasOneIncrementLastColSpan = true;
				}

				var counterOfColSpan = 0;
				var widthColOfRowSpan;
				var identicalHeightOfColumnsRight;
				for (var j = 0; j< childColumns.length; j++) {
					var childColumn = childColumns[j];
					// el RowSpan es unicamente de la primer columna
					if (j === 0) {
						widthColOfRowSpan = childColumn.m_width;
						identicalHeightOfColumnsRight = childColumn.m_identicalHeightOfColumnsRight;
					}

					selectorName = childColumn.m_classNameHeader;
					styleHeaderSubGrid = '';
					if (selectorName !== undefined) {
						styleHeaderSubGrid = self.GetCssStyle(selectorName);
					}

					var newChildElement = {
						name: "<div>" + childColumn.m_name + "</div>",
						events: childColumn.m_events,
						rowSpan: childColumn.m_rowSpan,
						colSpan: childColumn.m_colSpan,
						noresize: childColumn.m_noresize,
						width: childColumn.m_width,
						styles: styleHeaderSubGrid + childColumn.m_styles
					};

					childColumn.SetPosition(column.m_position + 1);
					childColumn.m_index = 0;

					var index = 0;
					if (childColumn.m_arrChildColumns === true) {
						index = 1;
					}
					var indexArray = index;
					if (childColumn.m_layout !== undefined) {
						if (childColumn.m_layout.toUpperCase() === "DOWN") {
							indexArray = 1;
							counterOfColSpan++;
							if (hasOneIncrementLastColSpan && (counterOfColSpan === numberOfColSpan)) {
								sizeOfColSpan++;
							}
							newChildElement.colSpan = sizeOfColSpan;
						}
					}

					if (widthColOfRowSpan !== undefined) {
						var cellWidth = 10;
						if (identicalHeightOfColumnsRight) {
							cellWidth = parseInt(widthColOfRowSpan, 10) / 2;
						}
						if (childColumn.m_scroll !== undefined) {
							if (childColumn.m_scroll === 1) {
								cellWidth = parseInt(widthColOfRowSpan, 10) - cellWidth;
							}
						}
						newChildElement.cellStyles = 'height: ' + cellWidth + 'px;';
					}
					self.m_subGridCells[0].cells[indexArray].push(newChildElement);
				}
			}
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	// en __src, asigno en el json la ruta y nombre de archivo exacto de la imagen.
	//	es utilizada en los eventos porque si se necesita la url compelta donde se encuentra la imagen.
	this.SetSrcDataForImages = function(typeOf, rowFieldValue, fieldObject){
		if (typeOf !== undefined && typeof(fieldObject) === "object" ) {
			var typeOfRow = typeOf.id.toUpperCase();
			if (typeOfRow === 'IMAGE') {
				var src = self.GetDataValue(rowFieldValue, typeOfRow);
				fieldObject.__src = src;
			}
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetData = function(jsonData, numberPage, othersGroupsPage) {
		self.m_data = [];
		self.m_globalData = [];
		self.m_jsonGlobalData = jsonData;
		var columnsLength = self.m_jsonColumns.grid.arrColumns.length;

		for (var a in self.m_jsonGlobalData) {
			if(self.m_jsonGlobalData.hasOwnProperty(a)) {
				if (typeof(self.m_jsonGlobalData[a]) !== "object" || self.m_jsonGlobalData[a].length === undefined) {
					continue;
				}

				// Creo array de datos, segun JSON de objetos
				var columns = self.m_jsonColumns.grid.arrColumns;
				for (var i = 0; i < self.m_jsonGlobalData[a].length; i++) {
					self.m_globalData[i] = [];
					for(var x = 0; x < columns.length - 1; x++) {
						var keyColumn = columns[x + 1].key;
						var oneColumn = columns[x + 1].value;

						if (typeof(oneColumn) !== "object") {
							continue;
						}
						if (x === 0) {
							oneColumn.subColumns = (self.m_jsonColumns.grid.subGrid !== undefined) ? self.m_jsonColumns.grid.subGrid.subColumns : undefined;
						}
						var rowObject = self.m_jsonGlobalData[a][i];
						if (typeof(oneColumn.subColumns) === "object") {
							self.m_globalData[i].push([]);
							// el cero corresponde donde esta la clave donde se encuentran los valores del subgrid
							var relationKey = self.m_jsonColumns.grid.subGrid.relationKey;
							self.FillSubGrid(relationKey, rowObject, i, oneColumn);
						}
						var rowFieldValue;
						try {
							rowFieldValue = inconcert.utils.GetProperty(rowObject, keyColumn);
						}
						catch(err) {
							rowFieldValue = '';
						}
						// En un campo de tipo imagen seteo en el json toda la url de la imagen en una nueva propiedad(__src)
						self.SetSrcDataForImages(oneColumn.typeOf, rowFieldValue, rowObject[keyColumn]);
						// agreo en array de la grilla
						self.m_globalData[i].push(rowFieldValue);
					}
				}
				var dataLength = 0;
				if (self.m_numberOfRowsByRequest !== undefined) {
					dataLength = self.m_numberOfRowsByRequest;
					if (self.m_jsonGlobalData.__config.numberOfRecords !== undefined) {
						dataLength = self.m_jsonGlobalData.__config.numberOfRecords;
					}
				}
				else {
					dataLength = self.m_jsonGlobalData[a].length;
				}
				if (numberPage === undefined) {
					numberPage = 1;
				}
				if (othersGroupsPage === undefined) {
					var elementToWrite = document.getElementById(self.m_gridId + '_paginated');
					var forceBuildOfTheButtons = (elementToWrite === null) ? false : true;
					self.m_pagePosition = numberPage;
					var html = self.CreatePaginated(dataLength, numberPage, true, forceBuildOfTheButtons);
					if (elementToWrite) {
						elementToWrite.innerHTML = html;
					}
				}
				else {
					self.SetDataPage(numberPage, dataLength, true, othersGroupsPage);
				}
				self.HighlightSelectedPageButton();
			}
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.FillSubGrid = function(relationKey, rowObject, parentRowIndex, oneColumn) {
		var hasDotInTheRelationship = false;
		var patron = /\./i;
		var myRelationship = relationKey;
		var relationShipNext;
		var pointPosition = myRelationship.search(patron);
		var myListOfRelationsRows;

		if (pointPosition > 0) {
			hasDotInTheRelationship = true;
			myRelationship = relationKey.substr(0, pointPosition);
			relationShipNext = relationKey.substr(pointPosition + 1);
		}
		var subEntityObject = inconcert.utils.GetProperty(rowObject, myRelationship);
		if (subEntityObject === undefined) {
			return;
		}
		if (subEntityObject.constructor === Array) {
			for (var j = 0; j< subEntityObject.length; j++) {
				var subRowObject = subEntityObject[j];
				subRowObject.__parent = rowObject;

				if (hasDotInTheRelationship === true) {
					// llamo recursivamente hasta llegar a una entidad sin relacion
					self.FillSubGrid(relationShipNext, subRowObject, parentRowIndex, oneColumn, myListOfRelationsRows);
				}
				else {
					this.FillSubGridData(subRowObject, parentRowIndex, oneColumn);
				}
			}
		}
		else {
			subEntityObject.__parent = rowObject;
			if (hasDotInTheRelationship === true) {
				// llamo recursivamente hasta llegar a una entidad sin realcion
				self.FillSubGrid(relationShipNext, subEntityObject, parentRowIndex, oneColumn, myListOfRelationsRows);
			}
			else {
				this.FillSubGridData(subEntityObject, parentRowIndex, oneColumn);
			}
		}
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.FillSubGridData = function(subRowObject, parentRowIndex, oneColumn) {
		var counterOfSubRows = self.m_globalData[parentRowIndex][0].length;
		self.m_globalData[parentRowIndex][0].push([]);
		var sortedColumns = SortColumns(oneColumn.subColumns);
		for (var y = 0; y < sortedColumns.length - 1; y++) {
			var subColumn = sortedColumns[y + 1];
			var keySubColumn = subColumn.key;
			var oneSubColumn = subColumn.value;

			if (typeof(oneSubColumn) === "object") {
				// el cero corresponde donde a la clave donde se encuentran los valores del subgrid
				var subRowFieldValue = inconcert.utils.GetProperty(subRowObject, keySubColumn);
				// En un campo de tipo imagen seteo en el json toda la url de la imagen
				self.SetSrcDataForImages(oneSubColumn.typeOf, subRowFieldValue, subRowObject[keySubColumn]);
				// Agrego en data SubGrilla
				self.m_globalData[parentRowIndex][0][counterOfSubRows].push(subRowFieldValue);
			}
		}
		// en esta posicion (la ultima de la fila del array) agreg el objeto (json)
		//correspondiente a la fila de la tabla con que se han lleando las filas del subgrid
		// Esta fila no se visualiza en la grilla y es utilizada en los eventos
		self.m_globalData[parentRowIndex][0][counterOfSubRows].push(subRowObject);
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetPagePosition = function() {
		return self.m_pagePosition;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.ConfigPaginated = function(rowsForPage, maxNumberOfPage, numberOfRowsByRequest, requestFunctionName) {
		self.m_rowsForPage = rowsForPage;
		self.m_maxNumberOfPage = maxNumberOfPage;
		self.m_numberOfRowsByRequest = numberOfRowsByRequest;
		self.m_requestFunctionName = requestFunctionName;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetPreviousPage = function() {
		var ret = self.m_pagePosition - 1;
		if (ret < self.m_numberOfInitialGroupPages) {
			ret = self.m_numberOfInitialGroupPages;
		}
		return ret;
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetNextPage = function() {
		var ret = self.m_pagePosition + 1;
		if (ret > self.m_numberOfFinalGroupPages) {
			ret = self.m_numberOfFinalGroupPages;
		}
		return ret;
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.GetInitialPage = function(numberRows, page) {
		var numberOfPages = numberRows / self.m_rowsForPage; // Total de páginas
		for (var initialPage = 1; initialPage <= numberOfPages; initialPage = initialPage + self.m_maxNumberOfPage) {
			var finalPage = (initialPage + self.m_maxNumberOfPage) - 1;
			if (page >= initialPage && page <= finalPage) {
				return initialPage;
			}
		}
		return 1;
	};


	//////////////////////////////////////////////////////////////////////////////
	//
	this.ChangeClass = function(object, type, hasAdd) {
		var element = (typeof(object) === "string" ? document.getElementById(object) : object);
		if (element !== null) {
			var className = (type === 'ds' ? element.className.replace(/-ds/g, '') : element.className.replace(/-ov/g, ''));
			if (hasAdd) {
				className = className.concat('-'.concat(type));
			}
			element.className = className;
			if (type === 'ds') {
				element.disabled = hasAdd;
			}
		}
	};
	//////////////////////////////////////////////////////////////////////////////
	//
	this.CreatePaginated = function(numberRows, initialPage, canSetData, forceBuildOfTheButtons) {
		var rowsForPage = numberRows;
		var htmlPageButtons = '';
		var htmlPreviousPage = '';
		var htmlNextPage = '';
		var htmlPreviousGroup = '';
		var htmlNextGroup = '';
		var selectedPage = initialPage;
		
		if (self.m_rowsForPage > 0 && numberRows) {
			initialPage = self.GetInitialPage(numberRows, initialPage);
			//////////////
			// obtengo el numero de páginas, la cantidad de grupos a crear, el numero de pagina inicial, el numero final de pagina.
			rowsForPage = self.m_rowsForPage;
			var numberOfPages = numberRows / rowsForPage; // Total de páginas
			if (numberOfPages !== parseInt(numberOfPages, 10)) {
				numberOfPages = parseInt(numberOfPages, 10) + 1;
			}
			self.m_numberOfPages = numberOfPages;

			var numberOfGroups = numberOfPages / self.m_maxNumberOfPage;
			if (numberOfGroups !== parseInt(numberOfGroups, 10)) {
				numberOfGroups = parseInt(numberOfGroups, 10) + 1;
			}

			var finalPage;
			if (numberOfPages <= self.m_maxNumberOfPage){
				finalPage = numberOfPages;
			}
			else {
				if (initialPage === 1) {
					for (var idGroup = 1; idGroup <= numberOfGroups; idGroup++) {
						finalPage = idGroup * self.m_maxNumberOfPage;
						initialPage = finalPage - (self.m_maxNumberOfPage) + 1;
						if (self.m_pagePosition >= initialPage && self.m_pagePosition <= finalPage) {
							break;
						}
					}
				}
				else {
					finalPage = initialPage + (self.m_maxNumberOfPage - 1);
					if (finalPage > numberOfPages) {
						finalPage = numberOfPages;
					}
				}
			}
			if (finalPage !== parseInt(finalPage, 10)) {
				finalPage = parseInt(finalPage, 10) + 1;
			}
			
		////////////////////////////////////////////////
		////CREO BOTONES EN P?GINA
			var keyButtonAnt = self.m_objectName + "_ANTERIOR";
			var keyButtonPageAnt = self.m_objectName + "_PAGEANTERIOR";
			var keyButtonSig = self.m_objectName + "_SIGUIENTE";
			var keyButtonPageSig = self.m_objectName + "_PAGESIGUIENTE";

			var functionChangeClass = self.m_objectName.concat('.ChangeClass(this, \'ov\', BOOLEAN);return false;');

			//////////////////////////////////////////////
			// Crea row y col a la tabla principal (en la misma se agrega el paginado)
			// Creo Botones de desplazamiento (Pagina anterior, siguiente)
			var classPagerPrevPage = 'butPagerPrevPage-ds';
			var disabledPagerPrevPage = ' disabled="true" ';
			var classPagerNextPage = 'butPagerNextPage';
			var disabledPagerNextPage = '';
			if (initialPage === finalPage) {
				classPagerNextPage += '-ds';
				disabledPagerNextPage = ' disabled="true" ';
			}
											
			if (self.m_canCreateControlsOfThePaginated === true || forceBuildOfTheButtons === true) {
				//anterior
				var	functionPreviousPageToExecute = self.m_objectName + '.SetDataPage(' + self.m_objectName + '.GetPreviousPage(), ' + numberRows +	', true)';
				if (self.m_numberOfRowsByRequest !== undefined) {
					functionPreviousPageToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetPreviousPage(), 0)';
				}
				// siguiente
				var	functionNextPageToExecute = self.m_objectName + '.SetDataPage(' + self.m_objectName + '.GetNextPage(), ' + numberRows +	', true)';
				if (self.m_numberOfRowsByRequest !== undefined) {
					functionNextPageToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetNextPage(), 0)';
				}

				htmlPreviousPage = ''.concat(
					'<button ',
						'class="', classPagerPrevPage, '"', disabledPagerPrevPage, ' id = "', keyButtonPageAnt, '" ',
						'onclick="', functionPreviousPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
					'></button>');
				htmlNextPage = ''.concat(
					'<button class="', classPagerNextPage, '"', disabledPagerNextPage  ,' id = "', keyButtonPageSig , '" ',
						'onclick="', functionNextPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
					'</button> ');
			}
			else { // Si el HTML ya existe busco los elementos

				//////////////////////////////////////////
				// Bot?n P?gina Anterior
				var elementPageAnt = document.getElementById(keyButtonPageAnt);
				if (elementPageAnt !== null) {
					// Asocio Funcion
					var	functionToExecute = self.m_objectName + '.SetDataPage(' + self.m_objectName + '.GetPreviousPage(), ' + numberRows +
												', true)';

					if (self.m_numberOfRowsByRequest !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetPreviousPage(), 0)';
					}
					elementPageAnt.onclick = Function(functionToExecute);
					if (selectedPage === initialPage) {
						elementPageAnt.disabled = true;
						elementPageAnt.className = 'butPagerPrevPage-ds';						
					}
					else {
						elementPageAnt.disabled = false;
						elementPageAnt.className = 'butPagerPrevPage';							
					}
				}
				//////////////////////////////////////////
				// Bot?n P?gina Siguiente
				var elementPageSig = document.getElementById(keyButtonPageSig);
				if (elementPageSig !== null) {
					// Asocio Funcion
					var	functionToExecute = self.m_objectName + '.SetDataPage(' + self.m_objectName + '.GetNextPage(), ' + numberRows +
												', true)';
					if (self.m_numberOfRowsByRequest !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + self.m_objectName + '.GetNextPage(), 0)';
					}
					elementPageSig.onclick = Function(functionToExecute);
					if (initialPage === finalPage || finalPage === selectedPage) {
						elementPageSig.disabled = true;
						elementPageSig.className = 'butPagerNextPage-ds';
					}
					else {
						elementPageSig.disabled = false;
						elementPageSig.className = 'butPagerNextPage';					
					}
				}
			}
			////////////////////////////////////////////////
			//En el bucle crea los botones referentes a los numeros de p?ginas/////////////////
			var i = 0;
			var idPage = 0;
			var keyButtonPage = "";
			var numberOfFinalGroupPages = (initialPage + (self.m_maxNumberOfPage - 1));
			var functionToExecute;

			self.m_numberOfInitialGroupPages = initialPage;
			self.m_numberOfFinalGroupPages = (numberOfFinalGroupPages > numberOfPages) ? numberOfPages : numberOfFinalGroupPages;
			for (i = initialPage; i <= numberOfFinalGroupPages; i++) {
				idPage++;
				keyButtonPage = self.m_objectName + '_' + idPage;

				if (i <= numberOfPages) {
					functionToExecute = self.m_objectName + '.SetDataPage(' + i + ',' + numberRows + ', true)';
					if (self.m_numberOfRowsByRequest !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + i + ', 0)';
					}
					// Crea en el documento el bot?n y asigna funci?n
					if (self.m_canCreateControlsOfThePaginated === true || forceBuildOfTheButtons === true) {
						htmlPageButtons = htmlPageButtons.concat(
							'<button class="butPagerNumber" id ="', keyButtonPage, '" ',
								'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
								'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
								'onclick="', functionToExecute, '">', i,
							'</button> ');
					}
					else {
						// visualiza elemento, cambia etiqueta (porque ya existe) y cambia funcion
						var elementPage = document.getElementById(keyButtonPage);
						if (elementPage !== null) {
							elementPage.innerHTML = i;
							elementPage.disabled = false;
							elementPage.style.display = "";
							elementPage.onclick = Function(functionToExecute);
						}
					}
				}
				else {
					// SI NO Existen m?s, oculta el bot?n.
					var elementPage = document.getElementById(keyButtonPage);
					if (elementPage !== null) {
						elementPage.innerHTML = "";
						elementPage.style.display = "none";
						elementPage.disabled = true;
					}
				}
			}
			//////////////////////////////////////////////
			// Creo Botones de desplazamiento (Grupo de paginas anterior y siguiente)
			// Cierro Tablas
			if (self.m_canCreateControlsOfThePaginated === true || forceBuildOfTheButtons === true) {
				//anterior
				var	functionPreviousGroupPageToExecute = self.m_objectName + '.SetDataPage(' + undefined + ',' + numberRows + ', true, ' + 2 +')';
				if (self.m_numberOfRowsByRequest !== undefined) {
					functionPreviousGroupPageToExecute = self.m_requestFunctionName + '(' + undefined + ', 2)';
				}
				// siguiente
				var	functionNextGroupPageToExecute = self.m_objectName + '.SetDataPage(' + (finalPage + 1) + ',' + numberRows + ', true, ' + 1 +')';
				if (self.m_numberOfRowsByRequest !== undefined) {
					functionNextGroupPageToExecute = self.m_requestFunctionName + '(' + (finalPage + 1) + ', 1)';
				}
				htmlPreviousGroup = htmlPreviousGroup.concat(
					'<button class="butPagerPrevGroup-ds" disabled="true" id = "',
						keyButtonAnt, '" onclick="', functionPreviousGroupPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
					'></button> ');

				var classNextGroup = "butPagerNextGroup";
				// Deshabilito el boton de "grupo de paginas siguiente" si solo crea un grupo de paginas
				var disabledButtonSig = "";
				if (finalPage === numberOfPages) {
					disabledButtonSig = 'disabled="true" ';
					classNextGroup = classNextGroup.concat('-ds');
				}
				htmlNextGroup = htmlNextGroup.concat(
					'<button ',
						'class="', classNextGroup, '" ',
						'id = "', keyButtonSig, '" ',
						'onclick="', functionNextGroupPageToExecute, '" ',
						'onMouseOver="', functionChangeClass.replace(/BOOLEAN/g, 'true') ,'" ',
						'onMouseOut="', functionChangeClass.replace(/BOOLEAN/g, 'false') ,'" ',
						disabledButtonSig,
					 '>',
					 '</button> ');

				self.m_canCreateControlsOfThePaginated = false;
			}
			else { // Si el HTML ya existe busco los elementos
				//////////////////////////////////////////
				// Bot?n Grupo de P?ginas Anterior
				var elementAnt = document.getElementById(keyButtonAnt);
				if (elementAnt !== null) {
					var disabled = false;
					if (self.m_pagePosition < self.m_maxNumberOfPage) {
						disabled = true;
					}
					self.ChangeClass(elementAnt, 'ds', disabled);
					// Asocio Funcion
					var paramNumberPage = (initialPage - self.m_maxNumberOfPage);
					if (paramNumberPage < 1) {
						paramNumberPage = 1;
					}
					var	functionToExecute = self.m_objectName + '.SetDataPage(' + paramNumberPage + ',' + numberRows + ', true, ' + 2 +')';
					if (self.m_numberOfRowsByRequest !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + paramNumberPage + ', 2)';
					}

					elementAnt.onclick = Function(functionToExecute);
				}
				//////////////////////////////////////////
				// Botón Grupo de Páginas Siguientes
				var elementSig = document.getElementById(keyButtonSig);
				if (elementSig !== null) {
					var disabled = false;
					if (finalPage === numberOfPages) {
						disabled = true;
					}
					self.ChangeClass(elementSig, 'ds', disabled);

					functionToExecute = self.m_objectName + '.SetDataPage(' + (finalPage + 1) + ',' + numberRows + ', true, ' + 1 +')';
					if (self.m_numberOfRowsByRequest !== undefined) {
						functionToExecute = self.m_requestFunctionName + '(' + (finalPage + 1) + ', 1)';
					}

					elementSig.onclick = Function(functionToExecute);
				}
			}
		}
		var canToogleStructure = false;
		var myGrid = dojo.widget.byId(self.m_gridId);
		if (myGrid) {
			canToogleStructure = true;
		}
		if (canSetData === true) {
			self.SetDataPage(self.m_pagePosition, numberRows, canToogleStructure);
		}

		return ''.concat(htmlPreviousGroup, htmlPreviousPage, htmlPageButtons, htmlNextPage, htmlNextGroup);
	};

	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetCaptionSelectedPageButton = function (numberPages) {
		var element = document.getElementById(self.m_gridId +  '_paginatedLabel');
		if (element === null) {
			return;
		}
		var captionPages = '';
		if (numberPages > 0 && self.m_pagePosition !== undefined &&
				self.m_numberOfPages !== undefined && self.m_numberOfPages > 0 &&
				self.m_jsonColumns.grid.translate !== undefined &&
				self.m_jsonColumns.grid.translate.captionPages !== undefined) {

			captionPages = self.m_jsonColumns.grid.translate.captionPages;
			captionPages = captionPages.replace(/%1/g, self.m_pagePosition);
			captionPages = captionPages.replace(/%2/g, self.m_numberOfPages);
		}
		element.innerHTML = captionPages;
		//---
		var elementGotoPage = document.getElementById(self.m_gridId +  '_gotoPageContainer');
		if (elementGotoPage === null) {
			return;
		}
		elementGotoPage.style.display = (numberPages === 0 ? 'none' : '');
	};

	this.HighlightSelectedPageButton = function () {
		var pag = jQuery('#' + self.m_gridId + '_paginated > button');
		if (pag.length > 0) {
			for (var i = 0; i < pag.length; i++) {
				if (pag[i].id.search('ANTERIOR') > 0 || pag[i].id.search('PAGEANTERIOR') > 0 || 
						pag[i].id.search('SIGUIENTE') > 0 || pag[i].id.search('PAGESIGUIENTE') > 0) {
					continue;
				}
				var className = "butPagerNumber";
				if (parseInt(pag[i].innerHTML, 10) === self.m_pagePosition) {
					className = "butPagerNumberCurrent";
				}
				pag[i].className = className;
			}
		}
	};
	
	//////////////////////////////////////////////////////////////////////////////
	//
	this.SetDataPage = function(numberPage, dataLength, canToogleStructure, othersGroupsPage) {
		if (self.m_rowsForPage === 0) {
			if (canToogleStructure) {
				var myMainGrid = dojo.widget.byId(self.m_gridId);
				if (myMainGrid !== undefined) {
					for (var i = 0; i < self.m_data.length; i++) {
						self.toggleDetail(i, false);
					}
				}
			}
			self.m_data = self.m_globalData;
			self.SetRowCount(self.m_data.length);

			if (canToogleStructure) {
				self.toggleStructure();
			}
		}
		else {
			//set data
			var finalRow = self.m_rowsForPage * numberPage;
			var initialRow = finalRow - self.m_rowsForPage;

			if (self.m_numberOfRowsByRequest !== undefined) {
				initialRow = 0;
				finalRow = self.m_rowsForPage;
			}

			self.m_data = [];
			if (finalRow > self.m_globalData.length) {
				finalRow = self.m_globalData.length;
			}
			// Carga Array Vista
			for (var i = initialRow; i < finalRow; i++) {
				self.m_data.push(self.m_globalData[i]);
			}

			var myMainGrid = dojo.widget.byId(self.m_gridId);
			if (myMainGrid !== undefined) {
				for (var i = 0; i < self.m_data.length; i++) {
					self.toggleDetail(i, false);
					self.destroySubgrid(i);
				}
			}

			var rowsForPage = dataLength;
			if (rowsForPage !== self.m_data.length) {
				rowsForPage = self.m_data.length;
			}
			self.SetRowCount(rowsForPage);

			if (canToogleStructure) {
				self.toggleStructure();
			}
			self.m_pagePosition = numberPage;
			// Create Paginated
			//if (othersGroupsPage === 1 || othersGroupsPage === 2 || othersGroupsPage === 3) {
				self.CreatePaginated(dataLength, numberPage, false, false);
			//}
		}
		self.SetCaptionSelectedPageButton(dataLength);
		if (self.m_waiting !== undefined) {
			self.m_waiting.Hide();
		}
	};

	/////////////////////////////////////////////////////////////////
	// seteo los rowCount al TAG
	this.SetRowCount = function (rowsForPage) {
		var grilla = document.getElementById(self.m_gridId);
		grilla.setAttribute("rowCount", rowsForPage);

		var myGrid = dojo.widget.byId(self.m_gridId);
		if (myGrid) {
			myGrid.rowCount = rowsForPage;
		}
	};
	/////////////////////////////////////////////////////////////////
	//
	this.GetGridSelectedRow = function () {
		var rowToReturn;
		var myMainGrid = dojo.widget.byId(self.m_gridId);
		if (myMainGrid !== undefined) {
			var numberOfSelectedRow = myMainGrid.selection.getSelected();
			if (numberOfSelectedRow !== '') {
				rowToReturn = self.m_jsonGlobalData[0][numberOfSelectedRow];
			}
		}
		return rowToReturn;
	};
	/////////////////////////////////////////////////////////////////
	//
	this.GetGridSelectedIndex = function () {
		var indexToReturn;
		var myMainGrid = dojo.widget.byId(self.m_gridId);
		if (myMainGrid !== undefined) {
			var numberOfSelectedRow = myMainGrid.selection.getSelected();
			if (numberOfSelectedRow !== '') {
				indexToReturn = numberOfSelectedRow;
			}
		}
		return indexToReturn;
	};
	/////////////////////////////////////////////////////////////////
	//
	this.GetSubGridSelectedRow = function (p_rowMainIndex) {
		var subRowToReturn;
		var rowMainIndex = ((p_rowMainIndex === undefined) ? self.GetGridSelectedIndex(): p_rowMainIndex);

		if (typeof(rowMainIndex) === "object") {
			rowMainIndex = rowMainIndex[0];
		}
		if (typeof(rowMainIndex) === "number") {
			var subGrid = dojo.widget.byId(self.makeSubgridId(rowMainIndex));
			if (subGrid !== undefined) {
				var numberOfSelectedRow = subGrid.selection.getSelected();
				if (numberOfSelectedRow !== '') {
					var rowMain = self.m_data[rowMainIndex][0];
					// en esta posicion (la ultima de la fila del array) esta agreado el objeto (json)
					//correspondiente a la tabla con que se han lleando las filas del subgrid (se ha agregado en la funcion FillSubGrid)
					var lengthOfArraySubRow = rowMain[numberOfSelectedRow].length - 1;
					subRowToReturn = rowMain[numberOfSelectedRow][lengthOfArraySubRow];
				}
			}
		}
		return subRowToReturn;
	};


	//////////////////////////////////////////////////////////////////////////////////
	// Manejador de Grilla y SubGrilla////////////////////////////////////////////////////
	// html for the +/- cell
	this.getCheck = function(inRow, inCell) {
		var valueToReturn = '';
		if (self.m_jsonColumns.grid.subGrid !== undefined) {
			var image = (self.m_detailRows[inRow.index] ? 'open.gif' : 'closed.gif');
			var show = (self.m_detailRows[inRow.index] ? 'false' : 'true');
			var src = self.m_webGridPath + 'images/' + image;

			valueToReturn = '<img height="18" width="18" src="' + src + '" onclick="' + self.m_objectName + '.toggleDetail(' + inRow.index + ', ' + show + ')">';
		}

		return valueToReturn;
	};

	/////////////////////////////////////////////////////////////////
	// provide html for the Detail cell in the master grid
	this.getDetail = function (inRow, inCell) {
		self.m_subGridProps.rowCount = self.m_data[inRow.index][0].length;

		// inRow is volatile, data it contains is only good right now
		var rowIndex = inRow.index;
		// we can affect styles and content here, but we have to wait to access actual nodes
		turbo.defer(function() { self.buildSubgrid(rowIndex, inCell); }, 1);
		// look for a subgrid
		var subGrid = dojo.widget.byId(self.makeSubgridId(rowIndex));
		var h = (subGrid ? subGrid.cacheHeight : "120") + "px";
		return '';
		// insert a placeholder
		//return '<div style="height: ' + h + '; background-color: white;"></div>';
	};

	/////////////////////////////////////////////////////////////////
	//
	this.SetMethodGetToSubGrid = function(inRowIndex){
		return self.m_arrColumns[0].m_arrChildColumns[0].getDetailData;
	};

	/////////////////////////////////////////////////////////////////
	// identify subgrids by their row indexes
	this.makeSubgridId = function(inRowIndex) {
		var myMainGrid = dojo.widget.byId(self.m_gridId);
		if (myMainGrid === undefined) {
			return;
		}
		return myMainGrid.widgetId + "_subGrid_" + inRowIndex;
	};

	/////////////////////////////////////////////////////////////////
	// if a subgrid exists at inRowIndex, detach it from the DOM
	this.detachSubgrid = function(inRowIndex) {
		var subGrid = dojo.widget.byId(self.makeSubgridId(inRowIndex));
		if (subGrid) {
			turbo.remove(subGrid.domNode);
		}
	};

	/////////////////////////////////////////////////////////////////
	// render a subgrid into inCell at inRowIndex
	this.buildSubgrid = function(inRowIndex, inCell) {
		var n = inCell.getContentNode(inRowIndex);
		var id = self.makeSubgridId(inRowIndex);
		var subGrid = dojo.widget.byId(id);

		if (subGrid) {
			n.appendChild(subGrid.domNode);
			subGrid.rowCount = self.m_subGridProps.rowCount;
		}
		else {
			self.m_subGridProps.dataRow = inRowIndex;
			self.m_subGridProps.widgetId = id;
			self.m_subGridProps.get = self.SetMethodGetToSubGrid(inRowIndex);
			subGrid = dojo.widget.createWidget('TurboGrid', self.m_subGridProps, n, "append");
		}
		if (subGrid) {
			subGrid.render();
			subGrid.cacheHeight = subGrid.domNode.offsetHeight;
			inCell.grid.rowHeightChanged(inRowIndex);
		}

		this.setGridEvents(subGrid);  // agrego eventos en subgrid
	};

	/////////////////////////////////////////////////////////////////
	// destroy subgrid at inRowIndex
	this.destroySubgrid = function(inRowIndex) {
		var subGrid = dojo.widget.byId(self.makeSubgridId(inRowIndex));
		if (subGrid) {
			subGrid.destroy();
		}
	};

	/////////////////////////////////////////////////////////////////
	// when user clicks the +/-
	this.toggleDetail = function(inIndex, inShow) {
		if (!inShow) {
			self.detachSubgrid(inIndex);
		}
		self.m_detailRows[inIndex] = inShow;
		try{
			var myMainGrid = dojo.widget.byId(self.m_gridId);
			if (myMainGrid === undefined) {
				return;
			}
			myMainGrid.updateRow(inIndex);
		}
		catch(err){
		}
	};

	/////////////////////////////////////////////////////////////////
	// Manejador Resize
	this.resizeInfo = function() {
	};

	/////////////////////////////////////////////////////////////////
	this.resizeGrid = function () {
		var myMainGrid = dojo.widget.byId(self.m_gridId);
		if (myMainGrid === undefined) {
			return;
		}	
		var bodyWidth = 0, bodyHeight = 0;
		var newGridWidth = 0, newGridHeight = 0;

		if( typeof( window.innerWidth ) === 'number' ) {
		    //Non-IE
		    bodyWidth = window.innerWidth;
		    bodyHeight = window.innerHeight;
		} else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
		    //IE 6+ in 'standards compliant mode'
		    bodyWidth = document.documentElement.clientWidth;
		    bodyHeight = document.documentElement.clientHeight;
		} else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {		
		    //IE 4 compatible
		    bodyWidth = document.body.clientWidth;
		    bodyHeight = document.body.clientHeight;
		}
		
		//calculo Width
		if (self.m_currentBodyWidth !== bodyWidth) {						
			newGridWidth = (window.bodyWidth * myMainGrid.m_initialGridWidth) / self.m_initialBodyWidth;
			turbo.setStyleWidthPx(myMainGrid.domNode, newGridWidth);
		}
		//calculo Height
		if (self.m_currentBodyHeight !== bodyHeight) {
			newGridHeight = (bodyHeight * myMainGrid.m_initialGridHeight) / self.m_initialBodyHeight;
		}	
		//Si cambio actulizo grid
		if ((!isNaN(newGridWidth) && !isNaN(newGridHeight)) && (newGridWidth !== 0 || newGridHeight !== 0)) {
			myMainGrid.update();
		}
		
		//Actualizo Current Size
		self.m_currentBodyWidth = bodyWidth;
		self.m_currentBodyHeight = bodyHeight;
	};
	/////////////////////////////////////////////////////////////////
	//
	this.toggleStructure = function() {
		var myMainGrid = dojo.widget.byId(self.m_gridId);
		if (myMainGrid === undefined) {
			return;
		}
		myMainGrid.scrollToRow(0);
		myMainGrid.setStructure(self.m_gridCells);
	};


///////////////////////////////////////////////////////////////////////////////////
////////Manejador de Eventos///////////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////
	// store data about event. By default track event.rowIndex and event.cell.index, but eventRows can specify params, which are event properties to track.
	this.setEventDataGrid = function(inIndex, inEvent) {
		var eRow = self.m_eventRows[inIndex];
		eRow.data = {};
		var properties = eRow.properties;
		var colIndex;

		if (properties) {
			for (var i=0, l=properties.length, p; (p=properties[i] || i < l); i++){
				eRow.data[p] = inEvent[p];
			}
		}
		else {
			eRow.data =  {
				row: (inEvent.rowIndex !== undefined ? Number(inEvent.rowIndex) : 'na'),
				cell: (inEvent.cell && inEvent.cell.index !== undefined ? inEvent.cell.index : 'na')
			};
		}

		// Mio /////////////
		if (typeof(inEvent.cell) !== "object") {
			return;
		}
		if (typeof(inEvent.cell.events) === "object") {
			var clave = self.m_eventRows[inIndex].name;
			// esto esta aca porque sino me muestra el internal waiting cada vez que presiono el header !!!!
			if (self.m_ordering === false) {
				self.HideInternalWaiting();
			}
			if (typeof(inEvent.cell.events[clave]) === "function") {
				var object;
				var dataField = "";
				var rowIndex;
				var subRowIndex;
				var subRowObject;
				var stopEventPropagation = false;
				if (inEvent.cell.grid.widgetId === self.m_gridId) {
					// Es un evento de Main Grid ////////////////////////////
					try {
						colIndex = inEvent.cell.index;
						rowIndex = inEvent.rowIndex;
						var row = self.m_data[rowIndex % self.m_data.length];
						dataField = row[inEvent.cell.index];

						// si se cumple esto quiere decir que eligio paginado con todos los datos
						if (self.m_rowsForPage > 0 && self.m_requestFunctionName === undefined) {
							rowIndex = rowIndex + ((self.m_pagePosition - 1) * this.m_rowsForPage);
						}
						object = self.m_jsonGlobalData[0][rowIndex];
					}
					catch (err) {
						stopEventPropagation = true;
					}
				}
				else {
					// Es un evento de Sub Grid //////////////////////////
					try{
						rowIndex = inEvent.cell.grid.dataRow;
						var row = self.m_data[rowIndex % self.m_data.length][0];
						dataField = row[inEvent.rowIndex][inEvent.cell.index];

						// en esta posicion (la ultima de la fila del array) esta agreado el objeto (json)
						//correspondiente a la tabla con que se han lleando las filas del subgrid (se ha agregado en la funcion FillSubGrid)
						var lengthOfArraySubRow = row[inEvent.rowIndex].length - 1;
						subRowObject = row[inEvent.rowIndex][lengthOfArraySubRow];
						// si se cumple esto quiere decir que eligio paginado con todos los datos
						if (self.m_rowsForPage > 0 && self.m_requestFunctionName === undefined) {
							rowIndex = rowIndex + ((self.m_pagePosition - 1) * this.m_rowsForPage);
						}
						object = self.m_jsonGlobalData[0][rowIndex];
						subRowIndex = inEvent.rowIndex;
					}
					catch (err) {
						stopEventPropagation = true;
					}
				}
				// Llama a la función (EVENTO)
				inEvent.cell.events[clave](object, subRowObject, dataField, subRowIndex, self, colIndex - 1, rowIndex, self.m_objectName);
				if (stopEventPropagation) {
					dojo.event.browser.stopEvent(inEvent);
				}
			}
		}
	};

	/////////////////////////////////////////////////////////////////
	// setup grid events for all events being tracked.
	this.setGridEvents = function(grilla) {
		if (grilla === undefined) {
			return;
		}
		var makeEvent;
		makeEvent = function(inIndex) {
				return function(e) {
					self.setEventDataGrid(inIndex, e);
					this["default"].call(this, self.m_eventRows[inIndex].name, arguments);
				};
		};
		for (var i=0, e; (e = self.m_eventRows[i]); i++) {
			if (grilla[e.name] !== undefined) {
				grilla[e.name] = makeEvent(i);
			}
		}
	};
	/////////////////////////////////////////////////////////////////
	// Main grid structure
	this.m_gridCells = [
		{
			noscroll: true,
			cells: [
				[{ name: '<div></div>',
					cellStyles: "vertical-align: top;", rowSpan1: 2,
					styles: "text-align: center;", width: 2, get: self.getCheck
				}]
			]
		},
		{
			noscroll: true,
			cells: [[],[]]
		},
		{
			onBeforeRow: function(inDataIndex, inSubRows) {
				inSubRows[1].hidden = !self.m_detailRows[inDataIndex];
			},
			noscroll: false,
			cells: [[],[]]
		}
	];

	/////////////////////////////////////////////////////////////////
	// the Detail cell contains a subgrid which we set up below
	this.m_subGridCells = [{
		noscroll: true,
		cells: [[],[]]
	}];

	/////////////////////////////////////////////////////////////////
	//
	this.m_subGridProps = {
		widgetId: '',
		structure: this.m_subGridCells,
		rowCount: 2,
		autoHeight: true,
		autoRender: false
	};
}
//Fin clase CInconcertGrid/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////