if (LogDebug == nil) then LogDebug = print end

LogDebug("")
LogDebug("===================================")
LogDebug("-(applyFilter.lua) (Multimedia Stored Player)")

cgilua.contentheader("text", "plain")


require("inconcert.translators")
local oo = require("loop.base")
require("LuaOrm.Mapper")
require("LuaOrm.Entity")
require("LuaOrm.Model")
require("LuaOrm.DBMS.DataSource")
--require("LuaOrm.DBMS.AbstractLayer")
require("LuaOrm.Associations.Associations")
require("LuaOrm.Associations.AssociationArray")
require("LuaOrm.Serializers.Json")
require("LuaOrm.Date")
--require("lunit")
require("inconcert.translators")
--local console = require("lunit-console")
local rpairs = LuaOrm.Associations.AssociationArray.Iterator
		
------------------------------------------------------------------------
-- Datos recibidos desde el cliente como parametros
LogDebug("--Parametros desde el Cliente =====================================================")
-- Id de la pagina que ha realizado el Request
local m_pageId
if (cgilua.POST.pageId) then
	m_pageId = json.decode(cgilua.POST.pageId)
end
LogDebug('m_pageId = ' .. tostring(m_pageId))
-- Nmero de pagina solicitada
local m_numberPage = 1
if (cgilua.POST.numberPage) then
	m_numberPage = json.decode(cgilua.POST.numberPage)
end
LogDebug('m_numberPage = ' .. tostring(m_numberPage))
-- Cantidad de filas por paginas que va a mostrar la grilla
local m_rowsPerPage
if (cgilua.POST.rowsPerPage) then
	m_rowsPerPage = json.decode(cgilua.POST.rowsPerPage)
end
LogDebug('m_rowsPerPage = ' .. tostring(m_rowsPerPage))
-- cantidad de paginas a mostarar en el paginado
local m_maxNumberOfPage
if (cgilua.POST.maxNumberOfPage) then
	m_maxNumberOfPage = json.decode(cgilua.POST.maxNumberOfPage)
end
LogDebug('m_maxNumberOfPage = ' .. tostring(m_maxNumberOfPage))
-- Si fuerza la consulta (Es utilizado para el F5 en el Navegador) se debe ejecutar la consulta siempre
local m_forceQuery
if (cgilua.POST.forceQuery) then
	m_forceQuery = json.decode(cgilua.POST.forceQuery)
end
LogDebug('m_forceQuery = ' .. tostring(m_forceQuery))
-- Si ha presionado el boton Apply del filtro tienen que venir los datos
local m_filterTable
if (cgilua.POST.filter) then
	LogDebug('m_filterTable = ' .. tostring(m_filterTable))
	m_filterTable = json.decode(cgilua.POST["filter"])
	LogDebug('m_filterTable = ' .. tostring(m_filterTable))
	for _, v in pairs(m_filterTable) do
		LogDebug('	-m_filterTable['.. _ ..']= ' .. tostring(v))
	end
else
	LogDebug('m_filterTable = ' .. tostring(m_filterTable))
end
LogDebug("-- FIN de Parametros desde el Cliente =====================================================")
LogDebug("===========================================================================================")

--LogDebug('type(inconcert.environment) = ' .. type(inconcert.environment))
--LogDebug('type(inconcert.environment.servers) = ' .. type(inconcert.environment.servers))
--LogDebug('type(inconcert.environment.servers[default]) = ' .. type(inconcert.environment.servers['default']))
--LogDebug('type(inconcert.environment.servers[default].database) = ' .. type(inconcert.environment.servers['default'].database))

local dataSource = oo.new(LuaOrm.DBMS.DataSource)

myDatabase = {
	driver = "{SQL Server}"
	,server = "127.0.0.1"
	,database = "mmprodat"
	,uid = "sa"
	,pwd = ""
}
Add_models = function(ms)
	local models = {}
	for k, v in pairs(ms) do
		models[v.name] = myMapper:new(k, v)
	end
	myMapper.models = models
end	
Connect = function (p_dataBase)
	--borrame ----------------------------------------------------------------------------------------
	local myDataBase = p_dataBase
	-----------------------------------------------------------------------------------------------------
	local database = {
	   driver = "inconcertPool"
	   ,conn_string = MakeConnectionString(myDataBase)
	   ,user = ""
	   ,pass = ""   
	}
	LogDebug("Connecting to: driver " .. database.driver .. ", Connection string: " .. database.conn_string)
	local resConn = dataSource:InitRDMBSLayer(database.driver, database.conn_string, database.user, database.pass)
	LogDebug('resConn: ' .. tostring(resConn))
end
MakeConnectionString = function (dataBase)
	local connectionString = ""
	LogDebug("MakeConnectionString. Voy a crear string de conexion a la BD")
	if (dataBase) then
		for property, value in pairs(dataBase) do
			connectionString = connectionString .. property .. "=" .. value .. ";"
		end
	end
	LogDebug("connectionString = " .. connectionString)
	return connectionString
end	

function CreateModel()
	LogDebug('(CreateModel) - voy a crear Modelo')
	Connect(myDatabase)
	LogDebug("filter.InitializeTables")		
	LogDebug('Voy a crear [filterHeader] - os:clock(): ' .. os:clock())

	inconcert.environment.globals.testGrid.listOfModelTables = {
		['filterHeader'] = nil
		,['filterDetail'] = nil
	}
	
	inconcert.environment.globals.testGrid.listOfModelTables["filterHeader"] = LuaOrm.Model {
		tableName = "filterHeader"
		,dataSource = dataSource		
		,Associations = {
			hasMany("filterDetail", nil, true)
		}
		,Attributes = {
			__lnk = function(entity)
				local link = {href = 'http://www.google.com.uy', text = 'GOOGLE URUGUAY'}
				--local link = 'http://www.google.com.uy'
				return link
			end
			,__actorName = function(entity)
				local image = {name ='ACTOR', value = 'Agent1'}
				return image
			end
		} 		
	}
	LogDebug('Voy a crear [filterDetail] - os:clock(): ' .. os:clock())
	inconcert.environment.globals.testGrid.listOfModelTables["filterDetail"] = LuaOrm.Model {
		tableName = "filterDetail"
		,dataSource = dataSource		
		,Associations = {
			belongsToOne("filterHeader")
		}
		,Attributes = {
			__chat = function(entity)
				local image = {name ='CHAT', value = 'Chat-SubGrid'}
				g_cualimagen = g_cualimagen +1
				if g_cualimagen == 2 then
					image = {name ='ACTOR', value = 'actorrr'}
				end
				
				return image
			end
		}		
	}

	LogDebug('4<<< Voy a hacer: LuaOrm.Mapper.new() - os:clock(): ' .. os:clock())
	-- creo mapper de orbit y le agrego los modelos de las tablas
	myMapper = LuaOrm.Mapper.new()
	
	LogDebug('4.1<<< Voy a hacer: dataSource:Validate() - os:clock(): ' .. os:clock())	
	dataSource:Validate()
	
	LogDebug('4.2<<< Voy a hacer: Add_models() - os:clock(): ' .. os:clock())
	Add_models(inconcert.environment.globals.testGrid.listOfModelTables)
	LogDebug('5<< Despues de agregar al modelo - os:clock(): ' .. os:clock())	
end

local executeQuery = false
if ((inconcert.environment.globals.testGrid == nil) or (m_filterTable ~= nil)) then
	if (inconcert.environment.globals.testGrid == nil)  then
		inconcert.environment.globals.testGrid = {}
		CreateModel()
	end
	executeQuery = true
end

if (m_rowsPerPage) then
	inconcert.environment.globals.testGrid.currentRowsPerPage = m_rowsPerPage
else
	m_rowsPerPage = inconcert.environment.globals.testGrid.currentRowsPerPage
end
g_cualimagen = 1


-- Esto es cuando se utiliza Sin paginado del lado del SERVER (momentaneo borrame) MIRA abajo que hay otro igual
--m_rowsPerPage = 22

if (executeQuery == true) then
	----------------------------------------------
	local where = "applicationId <> ?"
	local whereValues = {"__appId"}
	
	if (m_filterTable) then
		where = "applicationId = ?"
		whereValues = {m_filterTable.applicationId.selectedValue}
        LogDebug("  where = " .. where)
        LogDebug("  whereValues = " .. tostring(m_filterTable.applicationId.selectedValue))
	end
		
	inconcert.environment.globals.testGrid.pagedFilters = inconcert.environment.globals.testGrid.listOfModelTables["filterHeader"]:FindAllPaged(where, whereValues, m_rowsPerPage)
end


local pagedRows = inconcert.environment.globals.testGrid.pagedFilters:GetPage(m_numberPage)
local m_numberOfPagesResulting = inconcert.environment.globals.testGrid.pagedFilters:GetNumberOfPages()

LogDebug('--m_numberOfPagesResulting = ' .. tostring(m_numberOfPagesResulting))
LogDebug('-- m_rowsPerPage = ' .. tostring(m_rowsPerPage))

local m_numberOfRowsByLuaORM = m_numberOfPagesResulting * (m_rowsPerPage or 1) -- calculo la cantidad de registros resultantes en el query

-- Esto es cuando se utiliza Sin paginado del lado del SERVER (momentaneo borrame) MIRA Arriba que hay otro igual
--m_numberOfRowsByLuaORM = m_rowsPerPage
LogDebug(' cantRows = ' .. m_numberOfRowsByLuaORM)


local m_dataPage = {
	["__config"] = { -- configuracion esto es agregado ac para informar de ciertos datos al cliente
		numberOfRecords = m_numberOfRowsByLuaORM -- cantidad de registros resultantes en el query
	},
	[0] = nil -- aca viaja la la pagina
}



LogDebug("---m_dataPage: " .. type(m_dataPage))
m_dataPage[0] = pagedRows
LogDebug("----Despues m_dataPage[0]: " .. type(m_dataPage[0]))

jsonString = json.encode(m_dataPage)
--file,err = io.open( "c:\\testWebGrid.json", "w" )
--if err then return _,err end
--file:write(jsonString)
--file:close()
LogDebug(jsonString)
cgilua.put(jsonString)
LogDebug("==========================================================================================================")

