if (LogDebug == nil) then LogDebug = print end

LogDebug("LUA loadFilter.lua ")
---[=[
require("json")
require("inconcert.translators")
g_filter = require("shared.filter")

LogDebug('g_filter  = ' .. tostring(g_filter))

cgilua.contentheader("text", "plain")

local m_applicationId = "TESTCASE"
local m_userId = "ADMINISTRATOR"
local m_pageName = "PAGE1"

LogDebug('m_applicationId = ' .. tostring(m_applicationId))
LogDebug('m_userId = ' .. tostring(m_userId))
LogDebug('m_pageName = ' .. tostring(m_pageName))


--------------------------------------------------------------------------------------------------------------
Add_models = function(ms, mapper)
	local models = {}
	for k, v in pairs(ms) do
		LogDebug('--> Add_models - ' .. v.name)	
		models[v.name] = mapper:new(k, v)
	end
	mapper.models = models
end	
--///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- Esta funcion es la que conecta con la Base de datos 
Connect = function (p_dataBase)
	local myDataBase = p_dataBase
	--borrame ----------------------------------------------------------------------------------------	
	if (inconcert.environment.servers == nil) then
		inconcert.environment.servers = {
			database = {
				default = {
					driver = "{SQL Server}"
					,server = "192.168.20.66"
					,database = "mmprodat"
					,uid = "sa"
					,pwd = ""				
				}
			}
		}
	end
	-----------------------------------------------------------------------------------------------------
	if (myDataBase == nil) then
		myDataBase = inconcert.environment.servers.database['default']
	end
	
	local databaseForLuaORM = {
	   driver = "inconcertPool"
	   ,conn_string = MakeConnectionString(myDataBase)
	   ,uid = ""
	   ,pwd = ""   
	}
	
	LogDebug("Connecting to: driver " .. databaseForLuaORM.driver .. ", Connection string: " .. databaseForLuaORM.conn_string)
	local resConn = LuaOrm.DBMS.AbstractLayer.InitRDMBSLayer(databaseForLuaORM.driver, databaseForLuaORM.conn_string, databaseForLuaORM.uid, databaseForLuaORM.pwd)
	LogDebug('resConn: ' .. tostring(resConn))
end
--///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- Crea el string de conexion a la base, recorriendo la tabla database del objeto global (environment)
MakeConnectionString = function (dataBase)
	local connectionString = ""
	LogDebug("MakeConnectionString. Voy a crear string de conexion a la BD")
	if (dataBase) then
		for property, value in pairs(dataBase) do
			connectionString = connectionString .. property .. "=" .. value .. ";"
		end
	end
	LogDebug("connectionString = " .. connectionString)
	return connectionString
end
------------------------------------------------------------------------------------------------------------------------------------------------

local m_database = {
	driver = "{SQL Server}"
	,server = "127.0.0.1"
	,database = "HistoricalData"
	,uid = "sa"
	,pwd = ""
}
Connect(m_database)

local m_listOfTables = {}
LogDebug("Antes de llamar a g_filter.GetFilterModel()")
local m_filterTables = g_filter.GetFilterModel()
LogDebug('m_filterTables = ' .. tostring(m_filterTables))
if (m_filterTables) then
	LogDebug('(BuildModel) agrego al modelo las tablas de \'filter\'')
	for _, v in pairs(m_filterTables) do
		LogDebug('(BuildModel) 		agreo ' .. _)
		m_listOfTables[_] = v
	end
end

LogDebug('voy a crear el Mapper')			
local m_mapper = orbit.model.new()
LogDebug('+Antes de hacer Add_models a la lista de tablas- os:clock(): ' .. os:clock())
Add_models(m_listOfTables, m_mapper)
LogDebug('-Despues de hacer Add_models a la lista de tablas- os:clock(): ' .. os:clock())

LogDebug("Antes de llamar a g_filter:GetConfig")
local m_filter = g_filter:GetConfig()
m_filter.filtersList = g_filter:GetList(m_applicationId, m_userId, m_pageName, m_database)
LogDebug("type(m_filter) = " .. type(m_filter))

jsonString = json.encode(m_filter)
file,err = io.open( "c:\\loadFilterTest.json", "w" )
if err then return _,err end
file:write(jsonString)
file:close()
LogDebug(jsonString)
cgilua.put(jsonString)
LogDebug("==========================================================================================================")

--]=]

